#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.
#pragma DefaultTab={3,20,4}		// Set default tab width in Igor Pro 9 and later
#include <Waves Average>
#pragma IgorVersion = 7.00

// *** Copyright ***
// © 2023 CNRS Shared by Pierre VINCENT, under the MIT License.
//	Contact: pierre.vincent@cnrs.fr; IGF, 141 rue de la Cardonille, 34094 Montpellier cedex 5, France.

//To be fixed:
//- document the manual with all the different measurements

//	Fixed:
//	when getting to "case "Area Change"", the code doesn't execute: => removed the space in the name
//	Autopositionwindow was executed at the end of each group analysis, with the U_Group window being deleted.
//	Now: U_Group is kept, at the same position; button to autoposition the windows next to group control panel.
StrConstant ksNomDataFolderImport="ImportedData"
StrConstant ksNomsTypeExport="Normalized;Norm_Baseline;Raw"	//	les noms des sous-datafolder export
StrConstant ksNomCondCurs="Curs_"
StrConstant ksNomPulse="Pulse_"
StrConstant ksListeConditions="Curs_;Pulse_"
StrConstant ksNomGroupe="Group_"
StrConstant ksWavesCondForDisplay="W_Mes_Raplouf;W_Mes_Filemaker;W_Mes_Fusion;W_IndexManip"
StrConstant ksWavesCondForDisplayStr="WS_Mes_Filemaker"
StrConstant ksFileMakerParams="Age;Weight;Dose"
StrConstant ksFileMakerParamsStr="Experimenter;Sex;Biosensor;Clone;Genotype;Groupe;CodeAnimal;BrainStruct"
StrConstant ksCursParams1="ROI#;Tag#;AB;CD;EF;GH;∆R/Rmax;Amplitude"
StrConstant ksCursParams1_ROI="ROI#;Tag#;AB;CD;EF;GH;∆R/Rmax;Amplitude;IntensA;IntensB"
StrConstant ksCursParams3="ROI#;Tag#;AB;CD;EF"
StrConstant ksCursParams4="ROI#;Tag#;AB;CD;EF;GH;IJ;∆R/Rmax;AB response;CD fraction"
StrConstant ksCursParams4_ROI="ROI#;Tag#;AB;CD;EF;GH;IJ;∆R/Rmax;AB response;CD fraction;IntensA;IntensB"
StrConstant ksFusionParams="R0;Peak;intercept;slope;AB_norm;CD_norm;Custom1;Custom2;Custom3"
StrConstant ksListeCouleurs="Diverse;Rainbow;From table"
StrConstant ksCursorModes="Ratio;D1/D2 separation;D1 and D2 peak;5 cursors"

//	V_TypeFusion defines what type of data is being analyzed:
//	0:Cursor measurement; 1: Pulse; 2: Profile
//	Formule magique DFREF dfGlobal="root:Global:"

//_______________________________________________________________________________________
// *** Menu ***
Menu "Fusion"
	"Create a new condition", CreeCondition()
	"Open the condition window", CreeFenetreCondition()
	"-------------"
	"Create a new group of conditions ", CreeGroupe()	
	"Open the group window", CreateGroupControl()	
	"-------------"
	"Import infos from database", LitFileMaker()	//	Met à jour les valeurs d'après la base de données
	"-------------"
	"Make a list of experiments", ListeToutesLesManips()
	"Help", DisplayHelpTopic "Fusion overview"; AfficheInit("")
	"Fusion informations", DisplayVersion()
End

//	Custom function:
//	Function called once at the end of condition update; performs any type of calculation on the result of fusion measurement
Function Custom_Calculations()
	Wave W_Mes_Raplouf, W_Mes_Filemaker, W_Mes_Fusion, W_IndexManip
	Wave W_Mes_Raplouf_ROI, W_Mes_Filemaker_ROI, W_Mes_Fusion_ROI, W_IndexManip_ROI
	Wave/T WS_NomManip, WS_Nom_ROI
	variable i
	String sNom
	
	//	AB_norm
	if (DimSize(W_Mes_Raplouf,1)>=5)
		W_Mes_Fusion[][4]=(W_Mes_Raplouf[p][2]-W_Mes_Raplouf[p][4])/(W_Mes_Raplouf[p][5]-W_Mes_Raplouf[p][4])
		W_Mes_Fusion_ROI[][4]=(W_Mes_Raplouf_ROI[p][2]-W_Mes_Raplouf_ROI[p][4])/(W_Mes_Raplouf_ROI[p][5]-W_Mes_Raplouf_ROI[p][4])
	endif

	//	CD_norm
	if (DimSize(W_Mes_Raplouf,1)>=5)
		W_Mes_Fusion[][5]=(W_Mes_Raplouf[p][3]-W_Mes_Raplouf[p][4])/(W_Mes_Raplouf[p][5]-W_Mes_Raplouf[p][4])
		W_Mes_Fusion_ROI[][5]=(W_Mes_Raplouf_ROI[p][3]-W_Mes_Raplouf_ROI[p][4])/(W_Mes_Raplouf_ROI[p][5]-W_Mes_Raplouf_ROI[p][4])
	endif
	
	//	Custom 1
	//	Copy gain value into custom 1 result table, so that it can be viewed in the table
	//	 !! viewed, but not edited in the table: the table only shows a copy of it !!
	Wave/Z W_Gain, W_Gain_ROI
	if (waveexists(W_Gain))
		W_Mes_Fusion[][6]=W_Gain[p]
		W_Mes_Fusion_ROI[][6]=W_Gain_ROI[p]
	endif

	//	Custom 2
	W_Mes_Fusion[][7]=NaN		//(W_Mes_Raplouf[p][2]-W_Mes_Raplouf[p][4])/(W_Mes_Raplouf[p][5]-W_Mes_Raplouf[p][4])
	if (WaveExists(W_Gain_ROI))
		W_Mes_Fusion_ROI[][7]=W_Mes_Raplouf_ROI[p][9]/W_Gain_ROI[p]	//(W_Mes_Raplouf_ROI[p][2]-W_Mes_Raplouf_ROI[p][4])/(W_Mes_Raplouf_ROI[p][5]-W_Mes_Raplouf_ROI[p][4])
	endif

	//	Custom 3
//	W_Mes_Fusion[][8]=NaN		//(W_Mes_Raplouf[p][2]-W_Mes_Raplouf[p][4])/(W_Mes_Raplouf[p][5]-W_Mes_Raplouf[p][4])
//	W_Mes_Fusion_ROI[][8]=NaN	//(W_Mes_Raplouf_ROI[p][2]-W_Mes_Raplouf_ROI[p][4])/(W_Mes_Raplouf_ROI[p][5]-W_Mes_Raplouf_ROI[p][4])	

End

//	Template function to perform some action on all conditions
//	Made for cursor conditions, but can be adapted to any other
Function ActionOnAllGroups()
	variable i, j
	SetDataFolder root:
	String sListe=ListeDF("root:", ksNomGroupe), sNomDF, sListeWaves, sNom1, sNom2
	DFREF dfGroup
	For (i=0; (i<ItemsInList(sListe)); i+=1)
		sNomDF=StringFromList(i, sListe)
		dfGroup=root:$sNomDF
		NVAR/SDFR=dfGroup V_AfficheAxeConcentration, V_MarkerSize
		V_AfficheAxeConcentration=1
		V_MarkerSize=2
	endfor
	SetDataFolder root:
End

Function rien()
//ksCursParams1="ROI#;Tag#;AB;CD;EF;GH;∆R/Rmax;Amplitude"
	string sNomListe="ksCursParams"+"1", sTemp1, sTemp2
	sTemp1=StringFromList(2, sNomListe)
	sTemp2=StringFromList(1, ksCursParams1)
end

//	Initializing the file
//	Looks at the root for a global variable which indicates the type of data; if lacking, asks the user and create that variable
//	Replaces all instances of "Cond_" (ancient df name) with "Curs_" (specific for cursor measurements) in datafolder names
Function InitFusion()
	variable vTypeFusion, i
	string sListe, sNom, sNom2

	SetDataFolder root:
	//	initializes "Global" datafolder
	NewDataFolder/O Global
	InitDataFolder("Init fusion.pxp", "f_Global", "Global")

	SetDataFolder root:
	NVAR/Z V_TypeFusion
	if (!NVAR_Exists(V_TypeFusion))
		prompt vTypeFusion, "Type of data", popup, "Cursor measurement;Pulse;Profile"
		DoPrompt "What type of data to analyze", vTypeFusion
		if (V_Flag)
			print "cancelled by user"
			return(0)
		endif
		Variable/G V_TypeFusion = vTypeFusion-1	//	-1 because popup returns values starting from 1		
	endif
	sListe=ListeDF("root:", "Cond_")
	if ((ItemsInList(sListe)>0) && (V_TypeFusion == 0))
		DoAlert 1, "Renaming Cond_* datatafolders into Curs_* ?" 
		if (V_Flag==1)
			for (i=0; (i<ItemsInList(sListe)); i+=1)
				sNom=StringFromList(i, sListe)
				sNom2=ksNomCondCurs+sNom[5, inf]
				RenameDataFolder root:$sNom, $sNom2
			endfor
		endif
	endif
End
//
////	To update ancient fusion files
////	L'opération se fait en deux temps car la structure des datafolders n'est pas mise à jour après l'exécution de la première phase,
////	et la 2e phase ne s'exécute pas correctement. D'où la séparation en deux fonctions exécutées successivement.
//
////	Première phase: déplace les objets du datafolder condition ou groupe et les mets dans un sous-datafolder "old"
//Function RenoveFusion_0()
//	variable i
//	String sListeConditions=listeDFCond(), sListeGroupes=listeDFGroupe()
//	String sListe=sListeConditions+sListeGroupes
//	String sNomDF, sNomDF_Old
//	SetDataFolder root:
//
//	//	Ferme toutes les fenêtres pour éviter qu'une wave utilisée bloque le processus
//	//	à faire
//
//	//	Copie le contenu des datafolders dans un sous-dossier "Old"
//	For (i=0; (i<ItemsInList(sListe));i+=1)
//		sNomDF=StringFromList(i, sListe)
//		//	Déplace le contenu du datafolder dans un sous-datafolder "Old"
//		sNomDF_Old=sNomDF+":Old"
//		RenameDataFolder root:$sNomDF, Old
//		NewDataFolder root:$sNomDF
//		MoveDataFolder root:Old, root:$sNomDF
//	endfor
//End
//
////	Deuxième phase: 1/ initialise le datafolder condition; 
////	2/ récupère les données des versions anciennes pour les transférer dans les objets de la version actuelle
//Function RenoveFusion_1()
//	variable i
//	String sListeConditions=listeDFCond(), sListeGroupes=listeDFGroupe()
//	String sListe=sListeConditions+sListeGroupes
//	String sNomDF, sNomDF_Old
//
//	//	Conditions
//	For (i=0; (i<ItemsInList(sListeConditions));i+=1)
//		sNomDF=StringFromList(i, sListeConditions)	
//		InitDataFolder("Init fusion.pxp", "f_Curs_", sNomDF)
//		SetDataFolder root:$sNomDF
//		DFREF dfOld=:Old
//		Wave/T/SDFR=dfOld W_ManipStr
//		Wave/SDFR=dfOld w=W_ParametresMesures, W_Manip
//		Wave/T WS_NomManip
//		Wave W_Tag, W_Accept
//		Redimension/N=((DimSize(W_ManipStr,0)),-1) WS_NomManip, W_Tag, W_Accept
//		WS_NomManip[][0]=W_ManipStr[p][0]
//		WS_NomManip[][1]=W_ManipStr[p][1]
//		WS_NomManip[][2]=W_ManipStr[p][3]
//		W_Accept[]=W_Manip[p][0]
//		W_Tag[]=W_Manip[p][1]
//		NVAR V_FitStart, V_FitEnd, V_PeakStart, V_PeakEnd, V_PntsAfterPeak, V_PntsBeforePeak, V_PosNeg, V_CursorMode
//		V_FitStart=w[2]; V_FitEnd=w[3]; V_PeakStart=w[0]; V_PeakEnd=w[1]; V_PntsAfterPeak=w[4]
//		V_PntsBeforePeak=w[5]; V_PosNeg=w[6]; V_CursorMode=w[9]
//	endfor
//	
//	//	Groupes
//	For (i=0; (i<ItemsInList(sListeGroupes));i+=1)
//		sNomDF=StringFromList(i, sListeGroupes)
//		InitDataFolder("Init fusion.pxp", "f_Group", sNomDF)
//		SetDataFolder root:$sNomDF
//		Wave/T WS_Conditions, WS_AxisLabels
//		Wave W_Dose
//		Wave/T wConditions=:Old:W_Conditions, wAxisLabels=:Old:W_AxisLabels
//		Wave wDose=:Old:W_Dose
//		Redimension/N=(DimSize(wConditions, 0)) WS_Conditions, WS_AxisLabels, W_Dose
//		WS_Conditions=wConditions; WS_AxisLabels=wAxisLabels; W_Dose=wDose
//
//		SVAR S_NomGroupe, sNomGroupeOld=:Old:S_NomGroupe
//		S_NomGroupe=sNomGroupeOld
//	EndFor
//	SetDataFolder root:
//End
//

//________________________________________________________________________________________________________________
//*************************** Function which measures onset slope and detects peak  ******************************
//	zone de détermination du min et max, de la pente
//	pente: entre le point 0 et le point où le temps reste inférieur à V_Duree1
//	amplitude: entre le point 0 et le point où le temps reste inférieur à V_Duree2
//	renvoie une wave: [0]: max; [1,2]: coeffs du fit linéaire
Function/WAVE	MesureEtFit(wTemps, wDataOriginal, V_PeakStart, V_PeakEnd, V_FitStart, V_FitEnd, V_PntsBeforePeak, V_PntsAfterPeak, V_PosNeg)
	Wave wTemps, wDataOriginal
	Variable V_PeakStart, V_PeakEnd, V_FitStart, V_FitEnd, V_PntsBeforePeak, V_PntsAfterPeak, V_PosNeg

	variable i, pMin, pMax, vSomme, vNbPts
	Duplicate/FREE wDataOriginal, wData
	Make/FREE/N=3 wResultat

	//	Inverse (ou pas) la trace
	wData*=V_PosNeg
	//	Calcule le max sur la zone de temps définie
	Do	//	Détermine le point dans le temps pour lequel t==début
		i+=1
	While (i<DimSize(wTemps, 0) && (wTemps[i]<V_PeakStart))
	pMin=i
	Do	//	Détermine le point dans le temps pour lequel t>=fin
		i+=1		
	While (i<DimSize(wTemps, 0) && (wTemps[i]<V_PeakEnd))
	pMax=i
	//	On détermine le point maximum; connaissant sa position, on prend ce point ± nbpoints autour pour calculer la moyenne
	WaveStats/R=[pMin, pMax]/Q wData
	//	Calcule la moyenne de l'amplitude sur le nb de point
	for (i=V_maxloc-V_PntsBeforePeak; (i<=V_maxloc+V_PntsAfterPeak); i+=1)
		vSomme+=wData[i]
		vNbPts+=1
	endfor
	wResultat[0]=vSomme/vNbPts

	//	Calcule la pente sur la région pMin, pMax
	i=0
	Do	//	Détermine le point dans le temps pour lequel t==début
		i+=1
	While (i<DimSize(wTemps, 0) && (wTemps[i]<V_FitStart))
	pMin=i
	Do	//	Détermine le point dans le temps pour lequel t>=fin
		i+=1		
	While (i<DimSize(wTemps, 0) && (wTemps[i]<V_FitEnd))
	pMax=i
	CurveFit/NTHR=1/Q line wData[pMin, pMax] /X=wTemps
	Wave W_Coef
	wResultat[1]=W_Coef[0]; wResultat[2]=W_Coef[1]
	KillWaves/Z W_Coef
	Return wResultat
End
//*************************** fin de la fonction de mesure  *****************************************
//_______________________________________________________________________________________


//_______________________________________________________________________________________
// *** Interface with FileMaker ***

//	Structure which defines the data to get from filemaker
Structure structFileMakerData
	String sNomManip
	String sExperimentateur
	Variable vAge
	Variable vPoids
	String sSexe
	String sBiosenseur
	Variable vDoseTestee
	String sClone
	String sGenotype
	String sGroupe
	String sCodeAnimal
	String sBrainStruct
EndStructure

//	Reads the text file (tab-separated values) containing the relevant informations, for all experiments
//	Puts these informations in a series of waves in the root:FileMaker datafolder
Function LitFileMaker()
	
	if (!DataFolderExists("root:FileMaker"))
		NewDataFolder root:FileMaker
	endif
	SetDataFolder root:FileMaker
	//	Define the format to read this text file
	//	Caution: cannot read decimal numbers with a coma: must be a point
	//	Each line defines what should be read in the corresponding column: one item per column
	//	Makes a long string to be passed to LoadWave;
	//	defines if reading a text (F=-2) or number (F=0); gives the name of the wave constructed with these values
	String columnInfoStr = ""
	columnInfoStr += "C=1,F=-2,N=W_FM_NomManip;"	//	nom manip
	columnInfoStr += "C=1,F=-2,N=W_FM_Exp;"	//	Expérimentateur
	columnInfoStr += "C=1,F=0,T=2,N=W_FM_Age;"	//	Age
	columnInfoStr += "C=1,F=0,T=2,N=W_FM_Poids;"	//	Poids
	columnInfoStr += "C=1,F=-2,N=W_FM_Sexe;"	//	Sexe
	columnInfoStr += "C=1,F=-2,N=W_FM_Biosenseur;"	//	Biosenseur
	columnInfoStr += "C=1,F=0,N=W_FM_DoseTestee;"	//	Dose testée
	columnInfoStr += "C=1,F=-2,N=W_FM_Clone;"	//	Clone
	columnInfoStr += "C=1,F=-2,N=W_FM_Genotype;"	//	Génotype du clone
	columnInfoStr += "C=1,F=-2,N=W_FM_Groupe;"	//	Groupe
	columnInfoStr += "C=1,F=-2,N=W_FM_CodeAnimal;"	//	Code animal
	columnInfoStr += "C=1,F=-2,N=W_FM_BrainStruct;"	//	Brain structure or cell type

	PathInfo data	//	The path is invalid; triggers a user response to select the path to data
	if (V_Flag==0)	//	the path "data" points to nowhere
		NewPath/M="Path to analysis files:" data
		PathInfo data
	endif
	LoadWave/B=(columnInfoStr)/J/P=data/O/Q "Liste manips.tab"
	SetDataFolder root:
End

Function AfficheTableFilemaker()
	Edit/K=1 root:FileMaker:W_FM_NomManip
	AppendToTable root:FileMaker:W_FM_Exp
	AppendToTable root:FileMaker:W_FM_Age
	AppendToTable root:FileMaker:W_FM_Poids
	AppendToTable root:FileMaker:W_FM_Biosenseur
	AppendToTable root:FileMaker:W_FM_DoseTestee
	AppendToTable root:FileMaker:W_FM_Clone
	AppendToTable root:FileMaker:W_FM_Genotype
	AppendToTable root:FileMaker:W_FM_Groupe
	AppendToTable root:FileMaker:W_FM_CodeAnimal
	AppendToTable root:FileMaker:W_FM_BrainStruct
End

//	Receives as argument a record containing the name of an experiment
//	Browses W_FM_NomManip until it finds an experiment name that matches 
//	-> determines index in database (iFileMaker) corresponding to that record in the database
//	Fills the instance with the correct values
//	Instance is read globally by the calling function
Function ExtraitFMData(stFMData)
	Struct structFileMakerData &stFMData
	variable iFileMaker
	string sNomFM
	if (DataFolderExists("root:FileMaker"))
		//	Waves qui contiennent les infos en provenance de FileMaker
		Wave/T fmNom=root:FileMaker:W_FM_NomManip
		Wave/T fmExp=root:FileMaker:W_FM_Exp
		Wave fmAge=root:FileMaker:W_FM_Age
		Wave fmPoids=root:FileMaker:W_FM_Poids
		Wave/T fmSexe=root:FileMaker:W_FM_Sexe
		Wave/T fmBiosenseur=root:FileMaker:W_FM_Biosenseur
		Wave fmDoseTestee=root:FileMaker:W_FM_DoseTestee
		Wave/T fmClone=root:FileMaker:W_FM_Clone
		Wave/T fmGenotype=root:FileMaker:W_FM_Genotype
		Wave/T fmGroupe=root:FileMaker:W_FM_Groupe
		Wave/T fmCodeAnimal=root:FileMaker:W_FM_CodeAnimal
		Wave/T fmBrainStruct=root:FileMaker:W_FM_BrainStruct
		iFileMaker=-1
		Do
			iFileMaker+=1
			sNomFM=fmNom[iFileMaker]
			if (iFileMaker>=DimSize(fmNom,0)-1)	//	la fin de la liste de manips est atteinte
				stFMData.sExperimentateur=""	//	expérimentateur
				stFMData.vAge=NaN	//	âge
				stFMData.vPoids=NaN		//	poids
				stFMData.sSexe=""
				stFMData.sBiosenseur=""	//	biosenseur
				stFMData.vDoseTestee=NaN
				stFMData.sClone=""
				stFMData.sGenotype=""
				stFMData.sGroupe=""
				stFMData.sCodeAnimal=""
				stFMData.sBrainStruct=""
				Return(0)
			endif
		While (CmpStr(sNomFM, stFMData.sNomManip)!=0)
		//	iFileMaker est l'index de la manip dans les waves filemaker.
		//	On écrit dans la structure les valeurs correspondant à cette manip
		stFMData.sExperimentateur=fmExp[iFileMaker]	//	expérimentateur
		stFMData.vAge=fmAge[iFileMaker]	//	âge
		stFMData.vPoids=fmPoids[iFileMaker]		//	poids
		stFMData.sSexe=fmSexe[iFileMaker]	
		stFMData.sBiosenseur=fmBiosenseur[iFileMaker]		
		stFMData.vDoseTestee=fmDoseTestee[iFileMaker]
		stFMData.sClone=fmClone[iFileMaker]
		stFMData.sGenotype=fmGenotype[iFileMaker]
		stFMData.sGroupe=fmGroupe[iFileMaker]
		stFMData.sCodeAnimal=fmCodeAnimal[iFileMaker]
		stFMData.sBrainStruct=fmBrainStruct[iFileMaker]
	else
		stFMData.sExperimentateur=""	//	expérimentateur
		stFMData.vAge=NaN	//	âge
		stFMData.vPoids=NaN		//	poids
		stFMData.sSexe=""
		stFMData.sBiosenseur=""
		stFMData.vDoseTestee=NaN
		stFMData.sClone=""
		stFMData.sGenotype=""
		stFMData.sGroupe=""
		stFMData.sCodeAnimal=""
		stFMData.sBrainStruct=""
	endif
End

//	Used for debugging
Function TesteFileMaker(sNomManip)
	string sNomManip
	Struct structFileMakerData stFMData
	stFMData.sNomManip=sNomManip
	ExtraitFMData(stFMData)	//	récupère les infos filemaker pour ce nom de manip
	Print stFMData.sNomManip, stFMData.sExperimentateur	, stFMData.sBiosenseur, stFMData.sBrainStruct, stFMData.sGroupe, stFMData.sCodeAnimal
end

//____________________________________________________________________________________
//*************************** utilities  ************************************************

//	Import the datafolder named sNomExport in the file sNomFichier in the folder data
Function/S ImporteData(sNomFichier, sNomExport)
	String sNomFichier, sNomExport
	String sNomDF, sErreur, sChemin
	variable vErreur
	DFREF dfSav=GetDataFolderDFR
	DFREF dfImport = root:$ksNomDataFolderImport
	if (DataFolderRefStatus(dfImport)==0)
		NewDataFolder/S root:$ksNomDataFolderImport
		dfImport=GetDataFolderDFR()
	endif
	SetDataFolder dfImport
	
	//	Checks the path and data file; if doesn't exist, only proposes to fix the path; the file should not be opened manually
	//GetFileFolderInfo/Q/Z=2/P=data/D sNomFichier
	PathInfo data
	if (V_Flag==0)	//	the path "data" points to nowhere
		NewPath/M="Path to analysis files:" data
	endif

	//	Now get the path to that datafile	
	PathInfo data	//	Get the path to the root of file structures which contains analysis files
	sChemin=S_path+sNomFichier[0,3]+":"
	sNomDF=sNomFichier+"_"+sNomExport
	sNomFichier+=".pxp"

	//	Tests if data file exists
	GetFileFolderInfo/Q/Z sChemin+sNomFichier
	if (V_Flag!=0)
		return("File not found")
	endif

	NewDataFolder/O/S $sNomDF
	
	//	Essaye d'importer les traces depuis le datafolder dNomExport
	Try
		LoadData/O/Q/R/S=sNomExport sChemin+sNomFichier; AbortOnRTE
	Catch
		vErreur=GetRTError(1)
		sErreur=GetErrMessage(vErreur)
//		//	2e tentative, pour le cas où sNomExport="Export_"
		Try
			sNomExport+="_"
			LoadData/O/Q/R/S=sNomExport sChemin+sNomFichier; AbortOnRTE
		Catch
			vErreur=GetRTError(1)
			sErreur=GetErrMessage(vErreur)
			SetDataFolder root:
			Return("Datafolder not found; ")
		Endtry
	EndTry

	//	Import other infos from the same file
	Try
		LoadData/O/Q/S="root:Ratio:"/J="V_R0;" sChemin+sNomFichier; AbortOnRTE
	Catch
		vErreur=GetRTError(1)
		sErreur=GetErrMessage(vErreur)
		SetDataFolder root:
		Return("Variables not found")
	EndTry
	
	SetDataFolder dfSav
	Return("import OK;")
End

//_________________________________________________________________________________________________
//*****************************************		Groups	*****************************************

//	Creates the group datafolder
Function CreeGroupe()
	string sNomDF, sNomGroupe=ksNomGroupe, sListeConditions, sNomCondCurs
	variable i, vNbConds
	variable vTypeFusion
	SetDataFolder root:
	Do
		prompt sNomGroupe, "Name for the group "
		prompt vTypeFusion, "Type of data", popup, "cursor measure; pulse; profile"
		DoPrompt ksNomGroupe, sNomGroupe, vTypeFusion
		if (V_Flag)
			print "cancelled by user"
			return(0)
		endif
		sNomDF=sNomGroupe
	while (DataFolderExists(sNomDF))
	//	crée le datafolder pour ce groupe
	NewDataFolder $sNomDF
	DFREF dfGroupe=root:$sNomDF

	//	Initialise le datafolder groupe	
	InitDataFolder("Init fusion.pxp", "f_Group", sNomDF)
End

Function CreateGroupControl()
	DoWindow P_Group
	if (V_Flag>0)	//	window exists but may be hidden
		DoWindow/F/HIDE=0 P_Group
		return(0)
	endif	

	//	window doesn't exit -> clear all other possible group windows
	STRUCT WMWinHookStruct s; s.eventCode=17
	CrochetGroupe(s)	//	pass a kill event to the hook function attached to group windows

	//	Creating the control panel
	Execute "P_Group()"

	//	Specific settings for some controls
	PopupMenu C_PopChoixGroupe mode=1,popvalue="none"
End

//	Macro defining the control panel for group analysis
//	Attention: après mise à jour automatique de la macro: repérer les objets "localisés" avec recherche sur "root:"
//	Ou bien mieux : modifier un panneau vierge, non connecté à des variables
Window P_Group() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /K=1 /W=(44,66,648,413) as "Group control"
	SetDrawLayer ProgBack
	SetDrawEnv fsize= 9
	DrawText 36,64,"Axis labels"
	SetDrawLayer UserBack
	SetDrawEnv fsize= 8
	DrawText 28,118,"Error shading"
	SetDrawEnv fsize= 10
	DrawText 15,169,"x axis"
	SetDrawEnv fsize= 10
	DrawText 484,167,"marker size"
	GroupBox C_Groupe_Stats,pos={9.00,33.00},size={103.00,260.00}
	GroupBox C_Groupe_Stats,title="Graph window"
	GroupBox C_Def_Y,pos={278.00,46.00},size={154.00,210.00},title="Y value"
	PopupMenu C_PopChoixGroupe,pos={10.00,7.00},size={97.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_PopChoixGroupe,title="Group:"
	PopupMenu C_PopChoixGroupe,mode=1,popvalue="none",value=#"ListeDFGroupe()"
	CheckBox C_Active_P_Global,pos={487.00,8.00},size={113.00,16.00},proc=CheckActivePanneauFusion
	CheckBox C_Active_P_Global,title="Show global variables",value=1,side=1
	PopupMenu C_MoyOuROI,pos={387.00,7.00},size={89.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_MoyOuROI,help={"statistics calculated on measurements made over averged experiment or individual ROI"}
	PopupMenu C_MoyOuROI,mode=1,popvalue="Averages",value=#"\"Averages;ROI\""
	CheckBox C_ShowLegendTraces,pos={14.00,226.00},size={49.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_ShowLegendTraces,title="Legend"
	CheckBox C_ShowLegendTraces,help={"Display the automatic legend, based on Trace labels"}
	CheckBox C_ShowLegendTraces,value=0
	CheckBox C_ShowAnnotations,pos={14.00,244.00},size={65.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_ShowAnnotations,title="Annotation"
	CheckBox C_ShowAnnotations,help={"Display an additional comment on the graph"}
	CheckBox C_ShowAnnotations,value=0
	GroupBox C_DataToPlot,pos={115.00,32.00},size={484.00,260.00}
	GroupBox C_DataToPlot,title="Plot window"
	GroupBox C_Def_X,pos={124.00,47.00},size={154.00,210.00},title="X value"
	PopupMenu C_ChoixWavePourY,pos={286.00,70.00},size={129.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_ChoixWavePourY,mode=1,popvalue="W_Mes_Raplouf",value=#"ksWavesCondForDisplay"
	CheckBox C_DifferentYValues,pos={289.00,151.00},size={106.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_DifferentYValues,title="≠ data per condition"
	CheckBox C_DifferentYValues,help={"Adds an extra column to specify what column # to use as data input"}
	CheckBox C_DifferentYValues,value=0
	GroupBox C_Def_Couleur,pos={435.00,47.00},size={154.00,210.00}
	GroupBox C_Def_Couleur,title="Colors and markers"
	PopupMenu C_TableCouleur,pos={445.00,130.00},size={96.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_TableCouleur,mode=3,popvalue="From table",value=#"ksListeCouleurs"
	SetVariable C_MarkerSize,pos={446.00,170.00},size={57.00,14.00},proc=SetVarProcMaJGroupe
	SetVariable C_MarkerSize,title="exp."
	SetVariable C_MarkerSize,help={"Size of the marker in the stats plot"}
	SetVariable C_MarkerSize,limits={0,inf,0.5}
	PopupMenu C_NumCol_Y,pos={286.00,100.00},size={93.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_NumCol_Y,mode=8,popvalue="Amplitude",value=#"ksCursParams1"
	PopupMenu C_ChoixWavePourX,pos={132.00,70.00},size={65.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_ChoixWavePourX,mode=5,popvalue="Dose",value=#"ksWavesCondForDisplay+\";Dose\""
	PopupMenu C_NumCol_X,pos={132.00,100.00},size={20.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_NumCol_X,mode=8,popvalue="",value=#"ksZero"
	SetVariable C_Bruit,pos={165.00,190.00},size={65.00,14.00},proc=SetVarProcMaJGroupe
	SetVariable C_Bruit,title="Jitter"
	SetVariable C_Bruit,help={"Add some random noise to the X value to spread the points horizontally"}
	SetVariable C_Bruit,limits={-inf,inf,0.1}
	CheckBox C_Log,pos={153.00,160.00},size={65.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_Log,title="log X scale"
	CheckBox C_Log,help={"X axis in logarithmic scale; for dose-response curve"}
	CheckBox C_Log,value=0
	SetVariable C_AxisLabel_Graph_X,pos={20.00,67.00},size={80.00,14.00},title="X"
	SetVariable C_AxisLabel_Graph_Y,pos={20.00,86.00},size={80.00,14.00},title="Y"
	SetVariable C_AxisLabel_Plot_Y,pos={289.00,130.00},size={133.00,14.00}
	SetVariable C_AxisLabel_Plot_Y,title="Y axis lbl"
	SetVariable C_AxisLabel_Plot_Yright,pos={289.00,216.00},size={133.00,14.00}
	SetVariable C_AxisLabel_Plot_Yright,title="Conc. axis lbl"
	SetVariable C_Annotation,pos={20.00,265.00},size={80.00,14.00},title=" "
	GroupBox C_Groupe_SaveGraphs,pos={313.00,292.00},size={194.00,50.00}
	GroupBox C_Groupe_SaveGraphs,title="Save graphs"
	Button C_ExporteGraphes,pos={415.00,312.00},size={80.00,18.00},proc=BoutonGroupe
	Button C_ExporteGraphes,title="In home folder"
	Button C_ExporteGraphes,help={"Export graphs in home folder"},fSize=10
	CheckBox C_ShowLegendPlot,pos={450.00,208.00},size={49.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_ShowLegendPlot,title="Legend"
	CheckBox C_ShowLegendPlot,help={"Display the automatic legend, based on plot labels"}
	CheckBox C_ShowLegendPlot,value=0
	SetVariable C_TraceThickness,pos={13.00,190.00},size={85.00,14.00},proc=SetVarProcMaJGroupe
	SetVariable C_TraceThickness,title="Thickness"
	SetVariable C_TraceThickness,help={"Define the thickness of the traces"}
	PopupMenu C_TypeErreurTrace,pos={22.00,121.00},size={64.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_TypeErreurTrace,fSize=8
	PopupMenu C_TypeErreurTrace,mode=1,popvalue="none",value=#"\"none;SD;Conf. Int.;SEM\""
	CheckBox C_Temps_en_Secondes,pos={46.00,149.00},size={55.00,15.00},proc=CheckProcTempsEnMinutes
	CheckBox C_Temps_en_Secondes,title="Seconds",value=0,mode=1
	CheckBox C_Temps_en_Minutes,pos={46.00,168.00},size={52.00,15.00},proc=CheckProcTempsEnMinutes
	CheckBox C_Temps_en_Minutes,title="Minutes",value=1,mode=1
	PopupMenu C_TypeErreurPlot,pos={262.00,258.00},size={106.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_TypeErreurPlot,title="Error bars",fSize=8
	PopupMenu C_TypeErreurPlot,mode=1,popvalue="none",value=#"\"none;SD;Conf. Int.;SEM\""
	SetVariable C_MarkerSizeAvg,pos={505.00,170.00},size={75.00,14.00},proc=SetVarProcMaJGroupe
	SetVariable C_MarkerSizeAvg,title="average"
	SetVariable C_MarkerSizeAvg,help={"Size of the marker in the stats plot"}
	SetVariable C_MarkerSizeAvg,limits={0,inf,0.5}
	CheckBox C_AfficheNb,pos={450.00,190.00},size={51.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_AfficheNb,title="Show N"
	CheckBox C_AfficheNb,help={"Display on the graph the number of points for each average"}
	CheckBox C_AfficheNb,value=0
	CheckBox C_AfficheAxeConcentration,pos={289.00,193.00},size={85.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_AfficheAxeConcentration,title="Show conc. axis"
	CheckBox C_AfficheAxeConcentration,help={"Display an axis with estimated concentration"}
	CheckBox C_AfficheAxeConcentration,value=0
	Button C_Offsets,pos={513.00,190.00},size={50.00,16.00},proc=BoutonGroupe
	Button C_Offsets,title="Offsets"
	Button C_Offsets,help={"Set offset values for average dot and numeric indication"}
	Button C_Offsets,fSize=11
	Button C_SauveGraphesInPictGallery,pos={327.00,312.00},size={80.00,18.00},proc=BoutonGroupe
	Button C_SauveGraphesInPictGallery,title="In pict. gallery"
	Button C_SauveGraphesInPictGallery,help={"Save the graphs in pict gallery"}
	Button C_SauveGraphesInPictGallery,fSize=10
	Button C_Aide_Groups,pos={532.00,312.00},size={50.00,20.00},proc=BoutonAide
	Button C_Aide_Groups,title="Help",help={"Show help topic"},fSize=11,fStyle=1
	Button C_Aide_Groups,fColor=(52428,1,1)
	CheckBox C_ShowStatBars,pos={450.00,226.00},size={88.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_ShowStatBars,title="Show stats bars"
	CheckBox C_ShowStatBars,help={"Display bar to show significance; define position by setting values in 'W_BarreStats' wave"}
	CheckBox C_ShowStatBars,value=0
	CheckBox C_Pair,pos={401.00,269.00},size={67.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_Pair,title="Paired data"
	CheckBox C_Pair,help={"Treat as paired measurements and link points with line"}
	CheckBox C_Pair,value=0
	CheckBox C_CheckParam,pos={401.00,253.00},size={89.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_CheckParam,title="Parametric tests"
	CheckBox C_CheckParam,help={"Use parametric tests for statistical analysis f checked; use non-parametric tests if unchecked."}
	CheckBox C_CheckParam,value=0
	CheckBox C_FitData,pos={520.00,263.00},size={59.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_FitData,title="Fit Hill eq"
	CheckBox C_FitData,help={"Fit the average with a Hill equation"},value=0
	PopupMenu C_NumCol_Z,pos={445.00,100.00},size={80.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_NumCol_Z,mode=1,popvalue="_None_",value=#"ksZero"
	PopupMenu C_ChoixWavePourZ,pos={445.00,70.00},size={77.00,20.00},proc=PopMenuSelectGroupe
	PopupMenu C_ChoixWavePourZ,mode=5,popvalue="Cond. #",value=#"ksWavesCondForDisplay+\";Cond. #\""
	CheckBox C_CheckAxisLabelsS,pos={290.00,171.00},size={90.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_CheckAxisLabelsS,title="Show axis labels"
	CheckBox C_CheckAxisLabelsS,help={"Use parametric tests for statistical analysis f checked; use non-parametric tests if unchecked."}
	CheckBox C_CheckAxisLabelsS,value=0
	CheckBox C_CheckAxisLabelsG,pos={14.00,208.00},size={90.00,16.00},proc=CheckProcMaJGroupe
	CheckBox C_CheckAxisLabelsG,title="Show axis labels"
	CheckBox C_CheckAxisLabelsG,help={"Use parametric tests for statistical analysis f checked; use non-parametric tests if unchecked."}
	CheckBox C_CheckAxisLabelsG,value=0
	Button C_RangeLesFenetres,pos={20.00,303.00},size={70.00,28.00},proc=BoutonGroupe
	Button C_RangeLesFenetres,title="Autoposition\rwindows"
	Button C_RangeLesFenetres,help={"Position all group windows next to the control panel"}
	Button C_RangeLesFenetres,fSize=10
	SetWindow kwTopWin,hook(Group)=CrochetGroupe
EndMacro

// *** Hook function executed when any window of this ensemble is closed
//	Triggers the closure of all windows used in group analysis
Function CrochetGroupe(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult=0
	Switch(s.eventCode)
		case 17:	//	kill event
			KillWindow/Z G_Group
			KillWindow/Z S_Group
			KillWindow/Z T_Group
			KillWindow/Z U_Group
			KillWindow/Z P_Group
			hookResult=1
		break
	endswitch
	return hookResult
End

//	Executed when a popup is actioned on the group control panel
//	Executed everytime a control is actionned on P_Group, via a relay function (below)
//	Performs the adequate updates on all the controls and popups
//	Triggers the update of the group
Function PopMenuSelectGroupe(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum
	String popStr
	string sNomDF	//	name of the datafolder
		
	variable vTemp, i
	String sListe_C_Choix="C_ChoixWavePourX;C_ChoixWavePourY;C_ChoixWavePourZ", sC_Choix
	String sListe_C_NumCol="C_NumCol_X;C_NumCol_Y;C_NumCol_Z", sC_NumCol
	String sTemp

	NVAR V_TypeFusion=root:V_TypeFusion
	
	//	Initialize the z_Initialisation datafolder and the Global datafolder
	InitFusion()

	//	Get the name of the datafolder from the control
	ControlInfo/W=P_Group C_PopChoixGroupe
	sNomDF=S_Value
	DFREF dfGroupe=root:$sNomDF
	if (DatafolderRefStatus(dfGroupe)!=1)	//	dfGroupe is undefined; should not happen if the popup correctly displays existing df
		DoAlert 0, "group datafolder not found"
		return(0)
	endif

	SetDataFolder dfGroupe
	InitDataFolder("Init fusion.pxp", "f_Group", sNomDF)	//	Initialize this datafolder with all required objects

	NVAR/Z V_CursorMode
	if ((V_TypeFusion==0) && (!NVAR_Exists(V_CursorMode)))
		prompt vTemp, "Cursor mode:", popup, ksCursorModes
		DoPrompt "Enter value", vTemp
		Variable/G V_CursorMode=vTemp
	endif

	ControlInfo C_MoyOuROI
	variable vMoyOuIndividuel=V_Value
	
//	For all types of measurements, there should be the same type of waves to be offered for selection, plus possibly other specific ones
	PopupMenu C_ChoixWavePourX value=ksWavesCondForDisplay+";Dose"
	PopupMenu C_ChoixWavePourY value=ksWavesCondForDisplay
	PopupMenu C_ChoixWavePourZ value=ksWavesCondForDisplay+";Cond. #"
	
	//	if called by setting the C_TypeErreurTrace popup, updates the variable value to what item is selected in the popup
	if (CmpStr(ctrlName, "C_TypeErreurTrace")==0)
		NVAR V_TypeErreurTrace
		ControlInfo C_TypeErreurTrace
		V_TypeErreurTrace=V_Value-1
	endif

	//	if called by setting the C_TypeErreurPlot popup, updates the variable value to what item is selected in the popup
	if (CmpStr(ctrlName, "C_TypeErreurPlot")==0)
		NVAR V_TypeErreurPlot
		ControlInfo C_TypeErreurPlot
		V_TypeErreurPlot=V_Value-1
	endif
	
	//	depending on the type of analysis, updates the popups showing the columns that can be displayed
	Switch(V_TypeFusion)
		case 0:	//	cursor measurement
			//	sets each C_ChoixWavePour*
			for (i=0; (i<3);i+=1)
				sC_Choix=StringFromList(i, sListe_C_Choix)
				sC_NumCol=StringFromList(i, sListe_C_NumCol)
				ControlInfo $sC_Choix
				Switch(V_Value)
					case 1: //	W_Mes_Raplouf
						sTemp="ksCursParams"+num2str(V_CursorMode)	// parameter list depends on the cursor type
						//	Teste si on est en mode ROI
						ControlInfo C_MoyOuROI
						if (V_Value==2)		//	ROI est sélectionné
							sTemp+="_ROI"
						endif
					break
					case 2:	//	W_Mes_Filemaker
						sTemp="ksFileMakerParams"
					break
					case 3:	//	W_Mes_Fusion
						sTemp="ksFusionParams"
					break
					case 4:	//	W_IndexManip
					case 5:	//	Dose
					default:	//	and any other
						sTemp="ksZero"
					break
				EndSwitch
				ControlInfo $sC_NumCol
				PopupMenu $sC_NumCol,value=#sTemp,mode=V_Value	//	sets the popup list to the right ks*Params* list of items
				DoUpdate
				ControlInfo $sC_NumCol	//	to get the list of items in the popup
			endfor
		break
		case 1:	//	pulse
			PopupMenu C_MoyOuROI disable=2		//	only average mode is possible
			//	sets each C_ChoixWavePour*
			for (i=0; (i<3);i+=1)
				sC_Choix=StringFromList(i, sListe_C_Choix)
				sC_NumCol=StringFromList(i, sListe_C_NumCol)
				ControlInfo $sC_Choix
				Switch(V_Value)
					case 1: //	W_Mes_Raplouf
						sTemp="ksPulseParams"
						controlinfo $sC_NumCol
						PopupMenu $sC_NumCol,value=#sTemp,mode=V_Value	//	sets the popup list to the right ks*Params* list of items
					break
					case 2:	//	W_Mes_Filemaker
//						sTemp="ksFileMakerParams"
//					break
					case 3:	//	W_Mes_Fusion
//						sTemp="ksFusionParams"
//					break
					case 4:	//	W_IndexManip
					case 5:	//	Dose
						sTemp="ksZero"
						PopupMenu $sC_NumCol,value=#sTemp,mode=1	//	sets the popup list to "_none_"
					break
				EndSwitch
				DoUpdate
			endfor
		break
//		case 2:	//	profile
//			PopupMenu C_MoyOuROI disable=2, popvalue="disabled"
//		break
	EndSwitch

//	Updates the Group control panel with objects corresponding to this group
	//	Get the name of the datafolder from the control
	ControlInfo/W=P_Group C_PopChoixGroupe
	sNomDF=S_Value
	DFREF dfGroupe=root:$sNomDF
	if (DatafolderRefStatus(dfGroupe)==1)	//	dfGroupe is defined
		NVAR/SDFR=dfGroupe V_Apparie, V_Log, V_AfficheNb, V_AfficheAxeConcentration, V_StatsParametriques, V_ShowLegendTraces,V_ShowLegendPlot, V_ShowAnnotations
		NVAR/SDFR=dfGroupe V_DifferentYValues, V_ShowStatBars, V_FitData, V_MarkerSize, V_Bruit, V_TraceThickness, V_TypeErreurTrace, V_TypeErreurPlot, V_AverageSize
		NVAR/SDFR=dfGroupe V_ShowYAxisLabelG, V_ShowYAxisLabelS
		SVAR/SDFR=dfGroupe S_AxisLabel_Graph_X, S_AxisLabel_Graph_Y, S_AxisLabel_Plot_Y, S_AxisLabel_Plot_Yright, S_Annotation
		CheckBox C_Pair, variable=V_Apparie
		CheckBox C_Log, variable=V_Log
		CheckBox C_AfficheNb,variable=V_AfficheNb
		CheckBox C_AfficheAxeConcentration, variable=V_AfficheAxeConcentration
		CheckBox C_CheckParam, variable=V_StatsParametriques
		CheckBox C_ShowLegendTraces, variable=V_ShowLegendTraces
		CheckBox C_ShowLegendPlot, variable=V_ShowLegendPlot
		CheckBox C_ShowAnnotations, variable=V_ShowAnnotations
		CheckBox C_DifferentYValues, variable=V_DifferentYValues
		CheckBox C_ShowStatBars, variable=V_ShowStatBars
		CheckBox C_FitData, variable=V_FitData
		CheckBox C_CheckAxisLabelsS variable=V_ShowYAxisLabelS
		CheckBox C_CheckAxisLabelsG variable=V_ShowYAxisLabelG

		SetVariable C_TraceThickness, variable=V_TraceThickness
		SetVariable C_Bruit,value=V_Bruit
		SetVariable C_MarkerSize,value=V_MarkerSize
		SetVariable C_MarkerSizeAvg,value=V_AverageSize
		SetVariable C_AxisLabel_Graph_X value=S_AxisLabel_Graph_X
		SetVariable C_AxisLabel_Graph_Y value=S_AxisLabel_Graph_Y
		SetVariable C_AxisLabel_Plot_Y value=S_AxisLabel_Plot_Y
		SetVariable C_AxisLabel_Plot_Yright value=S_AxisLabel_Plot_Yright
		SetVariable C_Annotation value=S_Annotation
		
		PopupMenu C_TypeErreurTrace mode=V_TypeErreurTrace+1
		PopupMenu C_TypeErreurPlot mode=V_TypeErreurPlot+1
		DoUpdate
	endif

	//	performs the analysis of the group defined by the datafolder name
	MajGroupe()
End

//	Relay function activated by setvar controls
Function SetVarProcMaJGroupe(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName
	PopMenuSelectGroupe("rien",0,"")
End

//	Relay function activated by checkbox controls
Function CheckProcMaJGroupe(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	PopMenuSelectGroupe("rien",0,"")
End

//	Called by the C_PopChoixGroupe popup, to display a list of groups
Function/S ListeDFGroupe()
	String sListe=ListeDF("root:", ksNomGroupe)
	Return sListe
End

//	Called by the buttons on the group window
Function BoutonGroupe(ctrlName) : ButtonControl
	String ctrlName
	variable i, a, b, c, d, vTypeExport
	String sNomDF, sListe, sNom, sNomChemin, sNomExport, sNomGroupe, sNomGraphe1, sNomGraphe2, sNomExt, sNomTemp
	NVAR V_TypeFusion=root:V_TypeFusion

	//	Get the name of the datafolder from the control
	ControlInfo/W=P_Group C_PopChoixGroupe
	sNomDF=S_Value
	DFREF dfGroupe=root:$sNomDF, dfCondition
	
	Wave/T/SDFR=dfGroupe WS_Conditions
	SVAR/SDFR=dfGroupe S_NomGroupe
	NVAR/SDFR=dfGroupe V_DifferentYValues

	//	Depending on the button name that called the function, performs different actions
	StrSwitch(ctrlName)
		//	Updates all conditions contained in this group
		case "C_MaJCond":
			For (i=0; (i<DimSize(WS_Conditions, 0)); i+=1)
				sNomDF=WS_Conditions[i]
				Switch(V_TypeFusion)
					case 0:	//	Cursor measurement
						DoAlert 0, "Not yet implemented"
						Return(0)
						sNomDF=ksNomCondCurs+S_NomGroupe+"_"+sNomDF
						MajCondCurs(sNomDF)
					break
					case 1:	//	Pulse
						sNomDF=ksNomPulse+sNomDF
						MajCondPulse(sNomDF)
					break
				EndSwitch
			endfor
			SetDataFolder dfGroupe
		break

		//	Save G_Group and S_Group as static images; either exported in "home", or kept in pictgallery
		case "C_SauveGraphesInPictGallery":
		case "C_ExporteGraphes":
			ControlInfo/W=P_Group C_PopChoixGroupe
			sNomGroupe=S_Value
			ControlInfo/W=P_Group C_MoyOuROI
			Switch(V_Value)
				case 1:	//	per average
					sNomGroupe+="_Avg"
				break
				case 2:	//	per ROI
					sNomGroupe+="_ROI"
				break
			endswitch
			sNomGraphe1="G_Group"
			sNomGraphe2="S_Group"
			sNomTemp=sNomGroupe[6,inf]
			//	Check if a column number is selected
			if (V_DifferentYValues==0) 	//	 not checked
				//	Determines what is currently selected as X and Y data, to build a meaningful name
				ControlInfo/W=P_Group C_NumCol_Y
				sNomTemp+="_"+S_Value
			endif

			ControlInfo/W=P_Group C_ChoixWavePourX
			StrSwitch(S_Value)
				case "Dose":
				break
				default:
					ControlInfo/W=P_Group C_NumCol_X
					sNomTemp+=("_vs_"+S_Value)
				break
			endswitch

			StrSwitch(ctrlName)
				case "C_SauveGraphesInPictGallery":
					vTypeExport=-8
					sNomChemin="_PictGallery_"
					sNomExt=""	//	no extension added to the image name ("." in the export name causes problems)
				break
				case "C_ExporteGraphes":
					sNomChemin="home"
					prompt a, "What format", popup, "svg;png;pdf"
					prompt sNomTemp, "Default name:"
					DoPrompt "Exported graph:", a, sNomTemp
					if (V_Flag)
						print "Cancelled by user"
						return(0)
					endif
					Switch(a)	//	type of image
						case 1:	//	svg
							vTypeExport=-9
							sNomExt=".svg"
						break
						case 3:	//	pdf
							vTypeExport=-8
							sNomExt=".pdf"
						break
						case 2:	//	png
							vTypeExport=-5
							sNomExt=".png"
						break
					endswitch
				break
			EndSwitch
			if (V_TypeFusion==0)	//	cursor measurements -> also export the graph window
				sNomExport=sNomTemp+"_G"+sNomExt
				DoWindow/F $sNomGraphe1
				SavePict/O/E=(vTypeExport)/RES=300/P=$sNomChemin as sNomExport
			endif
			DoWindow/F $sNomGraphe2
			sNomExport=sNomTemp+"_S"+sNomExt
			SavePict/O/E=(vTypeExport)/RES=300/P=$sNomChemin as sNomExport
		break
		
		//	Sets the offset values for avg dot and numeric indication
		case "C_Offsets":
			NVAR/SDFR=dfGroupe V_OffsetN_X, V_OffsetN_Y, V_OffsetMoy_X, V_AxisLabelRotation
			a=V_OffsetN_X; b=V_OffsetN_Y; c=V_OffsetMoy_X; d=V_AxisLabelRotation
			prompt a, "number offset - X"
			prompt b, "number offset - Y"
			prompt c, "average offset - X"
			prompt d, "axis label rotation - °"
			DoPrompt "Offsets", a, b, c, d
			V_OffsetN_X=a; V_OffsetN_Y=b; V_OffsetMoy_X=c; V_AxisLabelRotation=d
			MajGroupe()
		break

		case "C_RangeLesFenetres":
// *** Organizing windows on the screen ***
//	alternative more versatile way to position a window
//	GetWindow P_Group, wsizeRM		//	V_left, V_right, V_top, and V_bottom
//	MoveWindow/W=T_Group V_left, V_Bottom+22, V_left+1000, V_bottom+350	//	positionne la fenêtre par-rapport au graphe
			AutoPositionWindow/R=P_Group G_Group
			AutoPositionWindow/M=1/R=P_Group T_Group
			if (V_TypeFusion==1)	//	Pulse -> G_Group graph window is hidden
				AutoPositionWindow/R=P_Group S_Group
			else
				AutoPositionWindow/R=G_Group S_Group
			endif
			AutoPositionWindow/M=1/R=S_Group U_Group
		break
		default:
			DoAlert 0, "The button named "+ctrlName+" did nothing."
		break
	EndSwitch
End

//______________________________________________________________________________
//	Main function which performs the analysis of a group
//	This function is activated when a control on the group window is actionned
Function MaJGroupe()

	DFREF dfGlobal=$"root:Global:"	
	NVAR/SDFR=dfGlobal V_IMin, V_IMax, V_AlphaStats//, V_ErrorInterval_SD, V_ErrorInterval_CI		//	Global variables

	variable i, j, vNbConditions, vMoyOuIndividuel, vHistMin=-20,vTailleBin=20,vNbBins=10
	variable vCompteur, vTemp, vChoixCouleurTraces, vChoixCouleurStats, vCustom	//	=1 if selecting specific columns
	variable vRed, vGreen, vBlue
	variable vErrorType, vPValue
	variable vLeft, vDelta
	string sListe, sNomTrace, sNomTraceErr, sNomPlot, sNomWave, sNomIndex, sNomHist, sMessage, sNomListe
	string sTemp, sListeTraces="", sListeLegende=""
	string sTraceLegend=""	//	to record trace names and legend, then build a legend string
	string sPlotLegend=""	//	same for plot
	String sNomDF			//	name of the group datafolder to be analyzed
	Struct RGBColor stCouleur

	String sNomWave_X, sNomWave_Y, sNomWave_Z, sNomWave_T	 	//	Name of the wave containing the data to be analyzed for statistics
	Variable vColWave_X, vColWave_Y, vColWave_Z, vColWave_T		//	Colomn number of that wave to be analyzed for statistics
	
	//	Get the name of the datafolder from the control
	ControlInfo/W=P_Group C_PopChoixGroupe
	sNomDF=S_Value
	DFREF dfGroupe=root:$sNomDF

	//	Root objects
	NVAR V_TypeFusion=root:V_TypeFusion
	
	//	Global objects
	SetDataFolder root:Global:
	//	Color tables
	Wave M_CouleursVariees, M_CouleursSpectre, M_CouleursD1, M_CouleursD2
	NVAR V_xhalf, V_rate, V_Rmin, V_Rmax
	
	//	Group objects
	SetDataFolder dfGroupe	//	Go to the group datafolder
	InitDataFolder("Init fusion.pxp", "f_Group", sNomDF)	//	Initialize this datafolder with all required objects
	Wave W_Vide=$ksNomCheminInit+"f_Global:W_Vide"		
	Wave/T WS_Conditions, WS_AxisLabels, WS_TraceLabels,WS_PlotLabels, WS_ListeElements, WS_Concentration 
	Wave W_Moy, W_SD, W_SEM, W_N, W_NbROI, W_NbDays, W_Dose, W_Axis, W_BarreStats, W_ListeElements, W_StatTests, W_Shapiro, W_Colors, W_Symbols, W_Style
	Wave W_Concentration_X, W_Concentration_Y
	NVAR V_Bruit, V_Log, V_Apparie, V_AfficheNb, V_OffsetN_X, V_OffsetN_Y, V_OffsetMoy_X, V_TypeErreurTrace, V_TypeErreurPlot
	NVAR V_AfficheAxeConcentration, V_StatsParametriques, V_AxisLabelRotation, V_MarkerSize,V_TraceThickness, V_AverageSize
	NVAR V_DifferentYValues, V_ShowLegendTraces, V_ShowLegendPlot, V_ShowAnnotations, V_ShowStatBars, V_FitData, V_Temps_en_Minutes
	NVAR V_ShowYAxisLabelS, V_ShowYAxisLabelG
	Wave W_EtoilesStats
	Wave/T WS_EtoilesStats

	SVAR S_NomGroupe, S_Annotation, S_AxisLabel_Graph_X, S_AxisLabel_Graph_Y, S_AxisLabel_Plot_Y, S_AxisLabel_Plot_Yright
	
	if (V_TypeFusion==0)
		//	Create V_CursorMode variable to keep ref of what type of cursor was used in this group
		//	Need to ask the user what cursor mode was used
		NVAR/Z V_CursorMode
		if (!NVAR_Exists(V_CursorMode))
			prompt vTemp, "Cursor mode:", popup, ksCursorModes
			DoPrompt "Enter value", vTemp
			Variable/G V_CursorMode=vTemp
		endif
	endif
	
	//	Number of conditions in this group
	vNbConditions=DimSize(WS_Conditions,0)

	//	Waves to contain the results are redimensioned to match the number of conditions
	Redimension/N=(vNbConditions, -1) W_Moy, W_SD, W_SEM, W_N, W_Dose, WS_AxisLabels, WS_TraceLabels, WS_PlotLabels, W_ListeElements, WS_ListeElements, W_StatTests, W_NbROI, W_NbDays, W_Shapiro, W_Colors, W_Symbols, W_Style
		
	//	Create the waves of waves which contain the pointers to the different plot measurements
	Make/N=(vNbConditions)/FREE/WAVE wWave_X, wWave_Y, wWave_T, wWave_Z, wWave_Trace, wWave_TraceErr
		
	//	Reading colorization type for stats plot
//	ControlInfo/W=P_Group C_ChoixCouleurTraces
//	vChoixCouleurTraces=V_Value
	ControlInfo/W=P_Group C_TableCouleur
	vChoixCouleurStats=V_Value

	//	Determines if the analysis is per experiment or per ROI
	ControlInfo/W=P_Group C_MoyOuROI	//	determines if show per experiment or per individual
	vMoyOuIndividuel=V_Value

	//	Clears all trace on the G_ graph, except W_Vide so that it keeps axis definitions
	EnleveToutesLesTracesSauf("G_Group", "W_Vide")

	//	Get the name of waves to be used for stat analysis; read in popups
	//	Value used for X axis
	ControlInfo/W=P_Group C_ChoixWavePourX
	sNomWave_X=S_Value
	ControlInfo/W=P_Group C_NumCol_X
	vColWave_X=V_Value-1

	//	Measurement displayed in Y
	ControlInfo/W=P_Group C_ChoixWavePourY
	sNomWave_Y=S_Value
	ControlInfo/W=P_Group C_NumCol_Y
	vColWave_Y=V_Value-1

	//	For the color
	ControlInfo/W=P_Group C_ChoixWavePourZ
	sNomWave_Z=S_Value
	ControlInfo/W=P_Group C_NumCol_Z
	vColWave_Z=V_Value-1

	//	For the text
	ControlInfo/W=P_Group C_ChoixWavePourT
	sNomWave_T=S_Value
	ControlInfo/W=P_Group C_NumCol_T
	vColWave_T=V_Value-1
	
	//	Adapts the name of the data waves to per average or per ROI
	if (vMoyOuIndividuel==2)		//	 per ROI
		if (CmpStr(sNomWave_X, "Dose")!=0)	//	does it only if X axis is not "Dose"
			sNomWave_X+="_ROI"
		endif
		sNomWave_Y+="_ROI"
		if (CmpStr(sNomWave_Z, "Cond. #")!=0)	//	does it only if Z data is not "Cond. #"
			sNomWave_Z+="_ROI"
		endif
	endif

	DoWindow G_Group
	if (V_Flag==0)	//	window does not exists and must be created
		//	Make the graph window
		Display/W=(44,490,680,914)/K=1/N=G_Group W_Vide as "Group traces"	//	this empty wave is always displayed, otherwise, removing other waves suppresses axis definitions etc...
		ModifyGraph hideTrace=1	//	Hide that trace
		DoUpdate
	endif	
	if (V_TypeFusion==1)	//	If Pulse analysis, the graph window should exist but must be hidden
		DoWindow/HIDE=1 G_Group	//	hide window
	else
		DoWindow/F/HIDE=0 G_Group
	endif

	//	Make a table with the list of conditions, the stat results from calculation, dose, axis labels, concentration, stat results
	DoWindow T_Group
	if (V_flag)	//	Table already exists
		GetWindow T_Group wsize	//	returns V_left, V_right, V_top, and V_bottom
		KillWindow/Z T_Group		//	kills the previous table, if any
		Edit/K=1/N=T_Group/W=(V_left, V_top, V_right, V_bottom) WS_Conditions as "Group main table"
	else
		Edit/K=1/N=T_Group WS_Conditions as "Group main table"
	endif
	
	AppendToTable/W=T_Group W_N
	if (V_StatsParametriques==1)
		AppendToTable/W=T_Group W_SD,W_SEM
	endif

	//	If "per average", append a column showing the nb of individual ROI included in the total
	if (vMoyOuIndividuel==1)		//	 per average
		AppendToTable/W=T_Group W_NbROI
	endif
	
	//	nb of different experiment dates
	AppendToTable/W=T_Group W_NbDays, W_Moy
	
	//	To append a column with the corresponding concentration value
	if (V_AfficheAxeConcentration==1)
		Duplicate/O W_Moy, W_Moy_Conc
		AppendToTable/W=T_Group W_Moy_Conc

		//	Append concentration settings
		AppendToTable/W=T_Group W_Concentration_X, W_Concentration_Y, WS_Concentration
	else
		KillWaves/Z W_Moy_Conc
	endif
	
	//	add more stuff to the table
	AppendToTable/W=T_Group W_Dose,WS_AxisLabels,WS_TraceLabels,WS_PlotLabels,W_Colors, W_Symbols, W_Style

	//	Situation in which different columns of a same table are used for stats
	//	If checked, add one more columns to the table to indicate what columns to use
	if (V_DifferentYValues==1)
		vCustom=1
		AppendToTable/W=T_Group W_ListeElements.ld//, WS_ListeElements
		ModifyTable/W=T_Group title(W_ListeElements)="param #", width(W_ListeElements)=90
		ModifyTable/W=T_Group title(W_ListeElements.l)="param", width(W_ListeElements.l)=40
		
		//	Automatically fills the .l column with the corresponding parameter name
//	This part of the code doesn't work as expected since it can't access the content of a list defined by a name

//		sNomListe="ksCursParams"+num2str(V_CursorMode)	// parameter list depends on the cursor type
//		if (vMoyOuIndividuel==2)		//	ROI mode
//			sNomListe+="_ROI"
//		endif

		//	Indicate the index label
		for (i=0; (i<vNbConditions); i+=1)
			if ( (numtype(W_ListeElements[i])==0) && (V_TypeFusion==0) )
// *** switch depending on what is the source of data ***
				StrSwitch(sNomWave_Y)
					case "W_Mes_Raplouf":
					case "W_Mes_Raplouf_ROI":
						sTemp="Raplouf "+StringFromList(W_ListeElements[i], ksCursParams1_ROI)
					break
					case "W_Mes_Filemaker":
						sTemp="Filemaker "+StringFromList(W_ListeElements[i], ksFileMakerParams)
					break
					case "W_Mes_Fusion":
					case "W_Mes_Fusion_ROI":
						sTemp="Fusion "+StringFromList(W_ListeElements[i], ksFusionParams)
					break
					default:
						sTemp="--"
					break
				EndSwitch
				SetDimLabel 0, i, $sTemp, W_ListeElements
			endif
		endfor
		//	Disable the popup that allows data selection
		PopupMenu C_NumCol_Y win=P_Group, disable=1
	else
		vCustom=0
		PopupMenu C_NumCol_Y win=P_Group, disable=0
	endif
	
	//	For statistics
	AppendToTable/W=T_Group W_StatTests, W_Shapiro
	
	//	Plot showing measurements
	DoWindow/F S_Group	//	Check if window already exists
	if (V_Flag==0)	//	doesn't exist -> created
		Display/K=1/N=S_Group W_Vide as "Group measurements - plot"
		ModifyGraph/W=S_Group hideTrace=1
	endif
	
	//	Clears all drawings in the prog layer
	SetDrawLayer/W=S_Group/K ProgFront	

	//	Clear all plots except the empty
	EnleveToutesLesTracesSauf("S_Group", "W_Vide;W_Vide_C")

	//	Kill former waves used as plots and graphs
	sListe=WaveList("W_Plot*", ";", "")+WaveList("W_Trace*", ";", "")
	for (i=0; (i<ItemsInList(sListe)); i+=1)
		sNomWave=StringFromList(i, sListe)
		Wave wSupprime=$sNomWave
		KillWaves/Z wSupprime
	endfor					

	//	Clears stat values
	W_Moy=NaN; W_SD=NaN; W_SEM=NaN
	
	//	table showing the individual measurements
	DoWindow U_Group
	if (V_flag==0)
		Edit/K=1/N=U_Group as "Group measurements - table"	//	make empty window
	endif

	
	//	Main loop to examine each condition
	//************************************************************************************************************
	for (i=0; (i<vNbConditions); i+=1)
	
		//	null dose -> this condition is not taken into account
		if (NumType(W_Dose(i))!=0)
			W_Moy[i]=NaN; W_SD[i]=NaN; W_SEM[i]=NaN; W_N[i]=NaN
			continue	//	terminates the analysis of this condition and jumps to the next condition
		endif
		
		//	determine the datafolder for the current condition
		sNomDF=StringFromList(V_TypeFusion, ksListeConditions)	//	gets the prefix of condition datafolder, depending on data type
		//	S_NomGroupe can contain a default string to add to the left of every condition name
		if (StrLen(S_NomGroupe)==0)
			sNomDF+=WS_Conditions[i][0]
		else
			sNomDF+=S_NomGroupe+"_"+WS_Conditions[i][0]
		endif
		DFREF dfCondition=root:$sNomDF	//	dfref to the current condition
		if (DataFolderRefStatus(dfCondition)==0)	//	if invalid condition name, issue a warning
			DoAlert 0, sNomDF+" is not a valid name for a condition"
			return(0)	//	aborts execution to prevent other errors from happening
			//	continue	//	terminates and jumps to the next condition			
		endif
		
		//	Deals with the waves in the condition folder
		//	Declares the trace and text waves in that condition's datafolder; depends on the type of analysis
		Switch(V_TypeFusion)
			case 0:	//	cursor measurement

				//	Tests if the cursor mode in this conditions matches the cursor type indicated for this group
				NVAR/SDFR=dfCondition vCursorMode=V_CursorMode
				if (vCursorMode!=V_CursorMode)
					DoAlert 0, "The condition "+sNomDF+" has a different cursor mode than the one specified for this group"
					continue	//	terminates and jumps to the next condition	
				endif

				//	Average traces to be displayed in G_Group_#
				//	Determine what error wave to display; W_Error_SD(_ROI)
				Switch(V_TypeErreurTrace)
					case 1:
						sNomWave="W_Error_SD"
					break
					case 2:
						sNomWave="W_Error_CI"
					break
					case 3:
						sNomWave="W_Error_SEM"
					break					
				EndSwitch
				Switch(vMoyOuIndividuel)
					case 1:	//	average of average experiment
						Wave/SDFR=dfCondition/T wNoms=WS_NomManip
						Wave/SDFR=dfCondition wTrace_Moy=W_Average, wMesRaploufROI=W_Mes_Raplouf_ROI
						//	Counting the total number of ROIs included in the average
						W_NbROI[i]=DimSize(wMesRaploufROI, 0)
						//	Counting the total number of different dates used for this condition
						Make/O/FREE/T/N=(DimSize(wNoms,0)) wsDates
						for (j=0; (j<DimSize(wNoms, 0)); j+=1)
							sTemp=wNoms[j][0]				
							wsDates[j]=sTemp[0,9]	//	keep only the date part of the experiment name
						endfor
						FindDuplicates/RT=wsUniqueDates/Z wsDates	//	generates a wave containing no duplicates
						W_NbDays[i]=DimSize(wsUniqueDates,0)		//	size of this resulting wave = nb of unique date values
						KillWaves/Z wsUniqueDates
					break
					case 2:	//	average of individual ROIs
						Wave/SDFR=dfCondition/T wNoms=WS_Nom_ROI
						Wave/SDFR=dfCondition wTrace_Moy=W_Average_ROI
						Wave/SDFR=dfCondition wNumManip=W_NumManip_ROI
						Wave/SDFR=dfCondition W_NumROI_ROI
						sNomWave+="_ROI"	//	Name of error wave
						W_NbROI[i]=NaN
					break
				endswitch

				//	Saving the selected trace and error waves in the corresponding waves of waves.
				wWave_Trace[i]=wTrace_Moy
				if (V_TypeErreurTrace>0)
					Wave/SDFR=dfCondition/Z wTrace_Err=$sNomWave
					wWave_TraceErr[i]=wTrace_Err
				endif

			break
			case 1:	//	Pulse: nothing to plot in the G_ window
				Wave/SDFR=dfCondition/T wNoms=WS_NomManip
			break
		endswitch

// *** Extract the measurement of interest in the current condition ***
//	Calculating statistics: collecting numerical values and text corresponding to all items in the condition being treated

		//	Define the wave which contains the values for analysis and display: Y values
		Wave/Z/SDFR=dfCondition wValeurs_Y=$sNomWave_Y
		if (!WaveExists(wValeurs_Y))
			Print "The wave for Y value is not found in the "+sNomDF+" condition datafolder"
			Continue
		endif

		//	Create a text wave to contain, for each Y measurement, a piece of text such as the name of experiment and other text infos
		sNomWave="W_Plot_"+WS_Conditions[i][0]+"_"+Num2Str(i)+"T"
		Make/O/T/N=(DimSize(wValeurs_Y,0)) $sNomWave
		Wave/T wPlot_T=$sNomWave
		wPlot_T=wNoms[p]

		//	- values used for X axis; usually, drug dose ± noise
		sNomWave="W_Plot_"+WS_Conditions[i][0]+"_"+Num2Str(i)+"X"
		Make/O/N=(DimSize(wValeurs_Y,0)) $sNomWave
		Wave wPlot_X=$sNomWave
		
		//	Special case: in most conditions, the X axis is the dose; but there are other possibilities
		StrSwitch(sNomWave_X)
			case "Dose":
				wPlot_X=W_Dose[i]	//	define X axis as the dose
				//	Optionally add a noise to the X value to spread the points
				if (V_Bruit !=0)
					if (V_Log==1)		//	log
						wPlot_X+=eNoise(wPlot_X[p]*V_Bruit)
					else	//	linear
						wPlot_X+=eNoise(V_Bruit)
					endif
				endif
			break
			default:	//	any other source of data for X axis
				//	Define the wave which contains the values for stat analysis and plot display: X value
				Wave/Z/SDFR=dfCondition wValeurs_X=$sNomWave_X
				if (!WaveExists(wValeurs_X))
					Print "The wave for X value is not found in the "+sNomDF+" condition datafolder"
					Continue
				endif
				//	transfers X value into xPlot_X
				if (DimSize(wValeurs_X,1)>0)	//	wValeurs_X has 2 dimensions
					if (vColWave_X < DimSize(wValeurs_X,1))
						wPlot_X=wValeurs_X[p][vColWave_X]
					else
						wPlot_X=NaN
					endif
				else	//	wValeurs_X has 1 dimension
					wPlot_X=wValeurs_X[p]
				endif
			break
		endswitch
		
		//	- values to plot in Y
		sNomWave="W_Plot_"+WS_Conditions[i]+"_"+Num2Str(i)+"Y"
		Make/O/N=(DimSize(wValeurs_Y,0)) $sNomWave
		Wave wPlot_Y=$sNomWave
		
		if (vCustom==1)	// If "custom" mode is selected, gets the colomn number from the table
			vColWave_Y=W_ListeElements[i]
			if (DimSize(wValeurs_Y,1)>vColWave_Y)
				wPlot_Y=wValeurs_Y[p][vColWave_Y]
			else
				Beep
				wPlot_Y=NaN
				print "trying to get column #"+num2Str(vColWave_Y)+" from "+NameOfWave(wValeurs_Y)+" which only has "+Num2Str(DimSize(wValeurs_Y,1))+" columns."
			endif
		else
			//	DimSize of wValeurs_Y unknown at compile time => test its size so it is possible to copy its content without error
			if (DimSize(wValeurs_Y,1)>0)	//	wValeurs_Y has 2 dimensions
				if (vColWave_Y < (DimSize(wValeurs_Y,1)))
					wPlot_Y=wValeurs_Y[p][vColWave_Y]
				else
					wPlot_Y=NaN
				endif
			else	//	wValeurs_Y has 1 dimension
				wPlot_Y=wValeurs_Y[p]
			endif
		endif

		//	- values to use for Z dimension, currently color
		sNomWave="W_Plot_"+WS_Conditions[i]+"_"+Num2Str(i)+"Z"
		Make/O/N=(DimSize(wValeurs_Y,0)) $sNomWave
		Wave wPlot_Z=$sNomWave
		StrSwitch(sNomWave_Z)
			case "Cond. #":
				wPlot_Z=i	//	define Z value as the condition #
			break
			default:
				Wave/Z/SDFR=dfCondition wValeurs_Z=$sNomWave_Z
				if (!WaveExists(wValeurs_Z))
					Print "The wave for Z value is not found in the "+sNomDF+" condition datafolder"
					Continue
				endif
		
				//	DimSize of wValeurs_Z unknown at compile time => test its size so it is possible to copy its content without error
				if (DimSize(wValeurs_Z,1)>0)	//	wValeurs_Y has 2 dimensions
					if (vColWave_Z < (DimSize(wValeurs_Z,1)))
						wPlot_Z=wValeurs_Z[p][vColWave_Z]
					else
						wPlot_Z=NaN
					endif
				else	//	wValeurs_Z has 1 dimension
					wPlot_Z=wValeurs_Z[p]
				endif
			break
		endswitch

		//	Add the waves containing the individual values of this condition into the wave of waves
		wWave_X[i]=wPlot_X
		wWave_Y[i]=wPlot_Y
		wWave_Z[i]=wPlot_Z
		wWave_T[i]=wPlot_T

		//	Calculate stats for the Y value
		if (V_StatsParametriques)
			WaveStats/Q wPlot_Y
			W_Moy[i]=V_avg
			W_SD[i]=V_sdev
			W_SEM[i]=V_sem
			W_N[i]=V_npnts
		else
			W_Moy[i]=Median(wPlot_Y)
		endif

		//	Adds the plotted values in the table
		AppendToTable/W=U_Group wPlot_T, wPlot_X, wPlot_Y, wPlot_Z
		sNomWave=NameOfWave(wPlot_T)
		ModifyTable/W=U_Group title($sNomWave)=WS_Conditions[i], size($sNomWave)=10, width($sNomWave)=105
		sNomWave=NameOfWave(wPlot_X)
		ModifyTable/W=U_Group title($sNomWave)="(X)", size($sNomWave)=10,sigDigits($sNomWave)=4,width($sNomWave)=50
		sNomWave=NameOfWave(wPlot_Y)
		ModifyTable/W=U_Group title($sNomWave)="(Y)", size($sNomWave)=10,sigDigits($sNomWave)=4,width($sNomWave)=50		
		sNomWave=NameOfWave(wPlot_Z)
		ModifyTable/W=U_Group title($sNomWave)="(color)", size($sNomWave)=10,sigDigits($sNomWave)=4,width($sNomWave)=50		
		
	EndFor	
	//************************************************************************************************************
	//	End of main loop to examine each condition

// *** Plotting traces and statistical results ***

// At this stage, all data is stored in waves of waves, with i corresponding to the line in the table of conditions:
//	 Traces: wWave_Trace[i] and wWave_TraceErr[i]
//	 Measurements to be plotted: wWave_X[i] (x value), wWave_Y[i] (Y value), wWave_Z[i] (color), wWave_T[i] (text comment)

	//	When paired analysis, plotting measurements as connected lines
	if (V_Apparie)	//	If "Connected points" is checked
		//	Checks if pairing is correct
		//	Looks for the first and second existing waves
		for (i=0; (i<vNbConditions); i+=1)	
			Wave/T/Z wTest0=wWave_T[i]
			if (WaveExists(wTest0))
				for (j=i+1; (j<vNbConditions); j+=1)
					Wave/T/Z wTest1=wWave_T[j]
					if (WaveExists(wTest1))
						//	Tests if waves have different sizes
						if (DimSize(wTest1,0)!=DimSize(wTest0,0))	//	Checks if the size of the text waves are equal in all conditions
							sMessage="Conditions have different number of measurements: uncheck 'Paired data'"
							DoAlert 0, sMessage
							print sMessage
							Return(0)
						Endif
						break	//	exits the j loop
					endif
				endfor
				break //	exits the i loop
			endif
		endfor

//	à terminer: récupérer les valeurs de i et j qui définissent les waves qu'il faut réorganiser; ignorer les autres waves

		//	Reorganizes the waves of waves, to interleave the different conditions
		RangeParGroupe(wWave_X)
		Wave W_MergedWave
		Duplicate/O W_MergedWave, W_MergedWave_X
		RangeParGroupe(wWave_Y)
		Duplicate/O W_MergedWave, W_MergedWave_Y
		KillWaves W_MergedWave
		AppendToTable/W=U_Group W_MergedWave_X, W_MergedWave_Y
		ModifyTable/W=U_Group sigDigits(W_MergedWave_X)=4,width(W_MergedWave_X)=50
		ModifyTable/W=U_Group size=10,sigDigits(W_MergedWave_Y)=4,width(W_MergedWave_Y)=50
		AppendToGraph/W=S_Group W_MergedWave_Y vs W_MergedWave_X
		ModifyGraph/W=S_Group mode(W_MergedWave_Y)=0,marker(W_MergedWave_Y)=41,rgb(W_MergedWave_Y)=(34952,34952,34952),lsize(W_MergedWave_Y)=0.5
	endif

	//	Display traces (if any) and measurements
	//	Default (paired and unpaired), add symbols on the stats graph and plot the traces if available
	sTraceLegend=""
	sPlotLegend=""
	for (i=0; (i<vNbConditions); i+=1)
		if (WaveExists(wWave_Y[i]) && WaveExists(wWave_X[i]))
			sNomPlot=NameOfWave(wWave_Y[i])
			//	stats plot
			AppendToGraph/W=S_Group wWave_Y[i]/TN=$sNomPlot vs wWave_X[i]

			//	Handle plot appearance
			ModifyGraph/W=S_Group mode($sNomPlot)=3,mrkThick($sNomPlot)=1, msize($sNomPlot)=V_MarkerSize
			switch(vChoixCouleurStats)
				case 1:	//	"Diverse"
					ModifyGraph/W=S_Group zColor($sNomPlot)={wWave_Z[i],0,DimSize(M_CouleursVariees,0),cTableRGB,0, M_CouleursVariees}
				break
				case 2:	//	"Rainbow"
					ModifyGraph/W=S_Group zColor($sNomPlot)={wWave_Z[i], V_IMin, V_IMax, cTableRGB,1,M_CouleursSpectre}
				break
				case 3:	//	"From table"
					ModifyGraph/W=S_Group rgb($sNomPlot)=(W_Colors[i][0],W_Colors[i][1],W_Colors[i][2]),marker($sNomPlot)=W_Symbols[i]
				break
			endswitch

			//	Handle trace
			if (WaveExists(wWave_Trace[i]))
				sNomTrace="W_Trace"+sNomPlot[6,inf]	//	Replace in the name W_Plot_ by W_Trace_
				Duplicate/O wWave_Trace[i], $sNomTrace
				Wave wTrace=$sNomTrace
				
				if (WaveExists(wWave_TraceErr[i]))
					sNomTraceErr="W_Trace"+sNomPlot[6,inf]+"_Err"	//	Replace in the name W_Plot_ by W_Trace_
					Duplicate/O wWave_TraceErr[i], $sNomTraceErr
					Wave wTraceErr=$sNomTraceErr
				endif
				
				//	Conversion of time from seconds to minutes, if selected, by dividing sampling rate by 60
				vLeft=leftx(wTrace)
				vDelta=deltax(wTrace)
				if (V_Temps_en_Minutes)
					vLeft/=60; vDelta/=60
					SetScale/P x vLeft,vDelta,"min", wTrace
					S_AxisLabel_Graph_X="Time (min)"
					if (WaveExists(wWave_TraceErr[i]))
						SetScale/P x vLeft,vDelta,"min", wTraceErr
					endif
				else
					SetScale/P x vLeft,vDelta,"s", wTrace	//	to specify the units
					S_AxisLabel_Graph_X="Time (s)"
					if (WaveExists(wWave_TraceErr[i]))
						SetScale/P x vLeft,vDelta,"s", wTraceErr
					endif
				endif

				AppendToGraph/W=G_Group wTrace
				ModifyGraph/W=G_Group rgb($sNomTrace)=(W_Colors[i][0],W_Colors[i][1],W_Colors[i][2]),marker($sNomTrace)=W_Symbols[i],lstyle($sNomTrace)=W_Style[i],lsize($sNomTrace)=V_TraceThickness
				//	Add error as shading
				if ((WaveExists(wTraceErr)) && (V_TypeErreurTrace>0))
					ErrorBars/W=G_Group $sNomTrace SHADE={0,0,(W_Colors[i][0],W_Colors[i][1],W_Colors[i][2],15000),(0,0,0,0)},wave=(wTraceErr,wTraceErr)
				endif

				//	Add this trace to the string defining trace legend
				//	enclose trace names with quotes so that when a trace has an "illegal" name, quotes allow to define the trace anyway
				sTraceLegend+="\s('"+sNomTrace+"')"+WS_TraceLabels[i]+"\r"
				sPlotLegend+="\s('"+sNomPlot+"')"+WS_PlotLabels[i]+"\r"
			endif
		endif
	endfor

//	Handling axis labels
	Label/W=G_Group/Z bottom, S_AxisLabel_Graph_X
	Label/W=G_Group/Z left, S_AxisLabel_Graph_Y
	Label/W=S_Group/Z left, S_AxisLabel_Plot_Y
	Label/W=S_Group/Z right, S_AxisLabel_Plot_Yright
	ModifyGraph/W=S_Group/Z noLabel(left)= (V_ShowYAxisLabelS==1 ? 0 : 2)
	ModifyGraph/W=G_Group/Z noLabel(left)= (V_ShowYAxisLabelG==1 ? 0 : 2)

	//	Adds the legend on the graph
	if ((V_ShowLegendTraces==1) && (V_TypeFusion==0))
		sTraceLegend=RemoveEnding(sTraceLegend, "\r")	//	remove the last CR
		TextBox/W=G_Group/C/N=text_legend/V=1/B=1 sTraceLegend	//	create or make visible
	else
		TextBox/W=G_Group/C/N=text_legend/V=0	//	hide legend
	endif

	//	Adds the legend on the plot
	if ((V_ShowLegendPlot==1) && (V_TypeFusion==0))
		sPlotLegend=RemoveEnding(sPlotLegend, "\r")	//	remove the last CR
		TextBox/W=S_Group/C/N=text_legend/V=1/B=1 sPlotLegend	//	create or make visible
	else
		TextBox/W=S_Group/C/N=text_legend/V=0	//	hide legend
	endif

// *** Statistics ***

// *** Test Shapiro ***
	W_Shapiro=NaN
	for (i=0; (i<(DimSize(W_StatTests,0))); i+=1)
		if ( WaveExists(wWave_Y[i]) )		//	this condition should be tested
			//	Shapiro test applied to waves that are marked with 1; Tests for normal distribution of the data
			StatsShapiroWilkTest/Q/Z wWave_Y[i]
			W_Shapiro[i]=V_prob
		endif
	endfor

	//	***************		Perform statistical tests between two different waves marked with 1	*********************
	sListe=""; vCompteur=0
	for (i=0; (i<(DimSize(W_StatTests,0))); i+=1)
		if ( (W_StatTests[i]==1) && WaveExists(wWave_Y[i]) )		//	this condition should be tested
			vCompteur+=1
			sNomWave="w"+num2Str(i)
			Duplicate/O wWave_Y[i], $sNomWave	//	Y data is duplicated
			sListe=AddListItem(sNomWave, sListe, ";", inf)
		endif
	endfor
	
	//	Depending on the number of conditions selected, performs a 2 condition comparison, or more
	Switch(vCompteur)
		//	0 or 1 column is selected
		case 0:
		case 1:
		break	//	do nothing
		case 2:	//	comparison of 2 conditions
			//	grabs the two waves
			sNomWave=StringFromList(0, sListe)
			Wave wA=$sNomWave
			WaveTransform/O zapNaNs wA

			sNomWave=StringFromList(1, sListe)
			Wave wB=$sNomWave
			WaveTransform/O zapNaNs wB

			if (V_StatsParametriques)	//	T-test
				if (V_Apparie)				//	Paired data
					StatsTTest/Z/Q/PAIR wA,wB
					Wave W_StatsTTest
					vPValue=W_StatsTTest[6]
				else							//	Unpaired data
					StatsTTest/Q/Z wA,wB
					Wave W_StatsTTest
					vPValue=W_StatsTTest[9]
				endif
				AppendToTable/W=T_Group W_StatsTTest.ld
			else								//	Wilcoxon test
				vTemp=1
				if ((DimSize(wA, 0)+DimSize(wB, 0)) > 250)	//	test if there is a large number of samples, which takes a long time to compute
					DoAlert 1, "Large number of points, Wilcoxon test will take some time; proceed anyway ?"
					vTemp=V_Flag		//	change vTemp to 2 if "no" was selected
				endif
				if ( (DimSize(wA, 0)<3) || (DimSize(wA, 0)<3) )
					vTemp=0
				endif
				if (vTemp==1)	//	proceed with test
					if (V_Apparie)				//	Paired data
						StatsWilcoxonRankTest/Z/ALPH=(V_AlphaStats)/WSRT/Q wA,wB
						Wave W_WilcoxonTest
						vPValue=W_WilcoxonTest[3]			//	!!!!!!!!!!!!!	gets the lower tail
					else							//	unpaired data
						StatsWilcoxonRankTest/Z/ALPH=(V_AlphaStats)/TAIL=7/Q wA,wB
						Wave W_WilcoxonTest
						vPValue=W_WilcoxonTest[5]			//	!!!!!!!!!!!!!	gets the lower tail
					endif
					AppendToTable/W=T_Group W_WilcoxonTest.ld
				endif
			endif
			KillWaves wA, wB
			
			//	Defines the symbol to show depending on the P Value
//			if (vPValue<V_AlphaStats)
//				WS_EtoilesStats[0]="*"
//			else
//				WS_EtoilesStats[0]="n.s."
//			endif
		break
		default:	//	more than 2 conditions
			Print "More than 2 conditions are selected => manage yourself an Anova or Kruskal-Wallis test"
		break
	EndSwitch
	
	//	Show bar above the graph to indicate significance
	if ((V_ShowStatBars==1))// && (vPValue<=0.05))
		AppendToGraph/W=S_Group/R=labels W_BarreStats[][1] vs W_BarreStats[][0]
		ModifyGraph/W=S_Group lsize(W_BarreStats)=1.5,rgb(W_BarreStats)=(0,0,0)
		AppendToGraph/W=S_Group/R=labels W_EtoilesStats[][1] vs W_EtoilesStats[][0]
		ModifyGraph/W=S_Group mode(W_EtoilesStats)=3,rgb(W_EtoilesStats)=(0,0,0),msize(W_EtoilesStats)=3,textMarker(W_EtoilesStats)={WS_EtoilesStats,"default",1,0,1,0.00,0.00}
		AppendToTable/W=T_Group W_BarreStats, W_EtoilesStats, WS_EtoilesStats
		SetAxis/W=S_Group labels, 0, 1
		ModifyGraph/W=S_Group noLabel(labels)=2,axThick(labels)=0
	endif

	//	Plots the average
	StrSwitch(sNomWave_X)
		case "Dose":
			AppendToGraph/W=S_Group W_Moy vs W_Dose
			Modifygraph/W=S_Group userticks(bottom)={W_Dose,WS_AxisLabels}
			Modifygraph/W=S_Group opaque(W_Moy)=1
// *** on the stats plot, choose between SD and SEM ***
			Switch(V_TypeErreurPlot)
				case 0:
					Modifygraph/W=S_Group mode(W_Moy)=3, marker(W_Moy)=13, rgb(W_Moy)=(0,0,0), mrkThick(W_Moy)=1, msize(W_Moy)=V_AverageSize
				break
				case 1:	//	SD
					Modifygraph/W=S_Group mode(W_Moy)=3, marker(W_Moy)=19, rgb(W_Moy)=(0,0,0), mrkThick(W_Moy)=1, msize(W_Moy)=V_AverageSize
					ErrorBars/Y=10/W=S_Group W_Moy Y,wave=(W_SD,W_SD)
				break
				case 2:	//	CI
					Modifygraph/W=S_Group mode(W_Moy)=3, marker(W_Moy)=13, rgb(W_Moy)=(0,0,0), mrkThick(W_Moy)=1, msize(W_Moy)=V_AverageSize
//					ErrorBars/Y=10/W=S_Group W_Moy Y,wave=(W_SD,W_SD)
				break
				case 3:	//	SEM
					Modifygraph/W=S_Group mode(W_Moy)=3, marker(W_Moy)=19, rgb(W_Moy)=(0,0,0), mrkThick(W_Moy)=1, msize(W_Moy)=V_AverageSize
					ErrorBars/Y=10/W=S_Group W_Moy Y,wave=(W_SEM,W_SEM)
				break				
			EndSwitch
//			if (V_StatsParametriques==1)
//				Modifygraph/W=S_Group mode(W_Moy)=3, marker(W_Moy)=19, rgb(W_Moy)=(0,0,0), mrkThick(W_Moy)=1
//				ErrorBars/Y=10/W=S_Group W_Moy Y,wave=(W_SD,W_SD)
//			else
//				Modifygraph/W=S_Group mode(W_Moy)=3, marker(W_Moy)=13, rgb(W_Moy)=(0,0,0), mrkThick(W_Moy)=1, msize(W_Moy)=3
//			endif
//			ErrorBars/W=S_Group W_Moy Y,wave=(W_SD,W_SD)
			//	Shifts the average horizontally so that it does not cover the data points
			if (V_Log)
				ModifyGraph/W=S_Group muloffset(W_Moy)={V_OffsetMoy_X,0}, offset(W_Moy)={0,0}, log(bottom)=1
			else
				Modifygraph/W=S_Group offset(W_Moy)={V_OffsetMoy_X,0},muloffset(W_Moy)={0,0},log(bottom)=0
			endif
		break
		default:
			Modifygraph/W=S_Group userticks(bottom)=0,log=0
		break
	endswitch

	//	Indicates the number of points used to calculate the average
	if (V_AfficheNb)
		AppendToGraph/W=S_Group W_Moy/TN=NbDePoints vs W_Dose
		ModifyGraph/W=S_Group mode(NbDePoints)=3,textMarker(NbDePoints)={W_N,"default",0,0,1,0,0},offset(NbDePoints)={V_OffsetN_X,V_OffsetN_Y}
		ModifyGraph rgb(NbDePoints)=(0,0,0), msize(NbDePoints)=3//, offset(NbDePoints)={0,V_OffsetN}
//		if (V_Log)
//			ModifyGraph muloffset(NbDePoints)={1.3,0},offset(NbDePoints)={0,0}
//		else
//			ModifyGraph muloffset(NbDePoints)={0,0},offset(NbDePoints)={0.2,0}
//		endif
	endif

	//	Fits W_Moy to an Hill equation
	if (V_FitData==1)
		K0 = 0; K1=1; K2=1; K3=10
		CurveFit/G/H="0000"/TBOX=256/Q HillEquation W_Moy /X=W_Dose /W=W_SD /I=1 /D
	endif
	
	Wave/Z fit_W_Moy, fitX_W_Moy
	if (WaveExists(fit_W_Moy) && WaveExists(fitX_W_Moy) && V_Value)
		//	Si une trace de fit existe et si coché
		sListe=TraceNameList("S_Group",";",1)
		if (WhichListItem("fit_W_Moy", sListe)<0)	//	si la trace n'y est pas déjà, l'ajoute au graphe		
			AppendToGraph/W=S_Group fit_W_Moy vs fitX_W_Moy
		endif
	else
		EnleveTrace("S_Group", "fit_W_Moy")
	endif
	
	//	Adds custom annotation
	if (V_ShowAnnotations==1)
		if (StrLen(S_Annotation)==0)
			prompt sMessage, "Annotation to add on the graph"
			DoPrompt "Please enter", sMessage
			S_Annotation=sMessage
		endif
		TextBox/W=G_Group/C/N=text_annotation/V=1 S_Annotation	//	create or make visible the annotation
	else
		TextBox/W=G_Group/C/N=text_annotation/V=0 S_Annotation	//	hide text box
	endif

// *** Concentrations ***
	//	Displays a right axis with concentrations
	//	W_Concentration_X contains the concentation values that should be plotted on the right axis
	if (V_AfficheAxeConcentration)
		sListe=TraceNameList("S_Group",";",1)
		//	need to have a trace to display with this axis, otherwise the axis does not exist
		if (WhichListItem("W_Vide_C", sListe)<0)	//	W_Vide_C is the empty trace to keep the axis on the right
			AppendToGraph/W=S_Group/R W_Vide/TN=W_Vide_C
			ModifyGraph/W=S_Group hideTrace(W_Vide_C)=1
		endif
		
		//	Calculate position of concentration ticks
		Redimension/N=(DimSize(W_Concentration_X, 0)) W_Concentration_Y, WS_Concentration
		for (i=0; (i<DimSize(W_Concentration_X, 0)); i+=1)
			W_Concentration_Y[i]=Hill(W_Concentration_X[i], V_Rmin, V_Rmax, V_xhalf, V_rate)
			WS_Concentration[i]=num2Str(W_Concentration_X[i])
		endfor

		//	Transfers min and max settings from left to right axis
		GetAxis/W=S_Group/Q left
		SetAxis/W=S_Group right, V_min, V_max
		//	Sets graph ticks to computed values
		ModifyGraph/W=S_Group manTick(right)=0,userticks(right)={W_Concentration_Y,WS_Concentration}
		ModifyGraph/W=S_Group/Z fStyle(right)=2,axThick(right)=0.5
//		ModifyGraph/W=S_Group/Z axRGB(right)=(39321,1,1),tlblRGB(right)=(39321,1,1),alblRGB(right)=(39321,1,1)
		
		//	Computes concentration values corresponding to average measurement
		for (i=0; (i<DimSize(W_Moy_Conc, 0)); i+=1)
			W_Moy_Conc[i]=ReciproqueHill(W_Moy[i], V_Rmin, V_Rmax, V_xhalf, V_rate)
		endfor
	else
		//	Removing the trace associated with the concentration axis removes the axis
		RemoveFromGraph/Z/W=S_Group W_Vide_C
	endif
	
	//	customizing the table for readibility
	ModifyTable/W=T_Group/Z format(Point)=1//,width(WS_Conditions)=120,width(W_Moy)=40,width(W_SD)=40,width(W_SEM)=40,width(W_N)=20
	ModifyTable/W=T_Group/Z title(WS_Conditions)="Condition", title(W_SD)="SD", title(W_SEM)="SEM", title(W_N)="N",title(W_NbROI)="n",title(W_NbDays)="A"
	if (V_StatsParametriques)
		ModifyTable/W=T_Group/Z title(W_Moy)="Moy"
	else
		ModifyTable/W=T_Group/Z title(W_Moy)="Median"
	endif
	ModifyTable/W=T_Group/Z title(W_Moy_Conc)="Conc.",title(W_Concentration_X)="[-]",title(W_Concentration_Y)="ratio",title(WS_Concentration)="label"
	ModifyTable/W=T_Group/Z style(WS_Concentration)=2, style(W_Concentration_Y)=2
	ModifyTable/W=T_Group/Z title(W_Dose)="Dose",title(WS_AxisLabels)="Axis lbl",title(WS_TraceLabels)="Trace lbl",title(WS_PlotLabels)="Plot lbl"
	ModifyTable/W=T_Group/Z title(W_Colors)="Colors", title(W_Symbols)="Symb. #", title(W_Style)="Style"
	ModifyTable/W=T_Group/Z format(W_StatTests)=1,title(W_StatTests)="Stats",title(W_BarreStats)="Bars",title(W_EtoilesStats)="Pos.",title(WS_EtoilesStats)="Symbl."
	ModifyTable/W=T_Group/Z title(W_StatsTTest.l)="T-test",title(W_Shapiro.d)="Shapiro",title(W_StatsTTest.d)="T-test"
	ModifyTable/W=T_Group/Z title(W_WilcoxonTest.l)="Wilcoxon",title(W_WilcoxonTest.d)="Wilcoxon"
	ModifyTable/W=T_Group/Z size=10, autosize={0, 0, 2, 0, 0}

	
	//	Formatting stats window
	DoWindow/F S_Group
	ModifyGraph/W=S_Group tkLblRot(bottom)=V_AxisLabelRotation

// *** Calling an external function to polish the final graph ***

	//	This calls an optional function meant to be in the "Procedure" window or a shared procedure file, and therefore belonging to the experiment. 
	//	Changes which are local to that experiment can thus be programed without affecting the code made for general use.
#if (Exists("ApplyStyle")>0)
	ApplyStyle()
#endif
	DoUpdate
End

//	_______________________________________________________________________________
//	*************************	Utility functions for conditions		***************

//	Called by menu to create a new condition
Function CreeCondition()
	InitFusion()		//	to make sure V_TypeFusion variable exists 
	NVAR V_TypeFusion=root:V_TypeFusion
	Switch(V_TypeFusion)
		case 0:	//	Cursor measures
			CreeCondCurs()
		break
		case 1:	//	Pulse measures
			CreeCondPulse()
		break
		case 2:	//	Profile measures
			print "This feature has been disabled as of version 8.32"
//			CreeCondProfil()
		break
	EndSwitch
End

//	Activated by the menu; depending on the type of data, activates the relevant function
Function CreeFenetreCondition()
	InitFusion()		//	to make sure V_TypeFusion variable exists 
	NVAR V_TypeFusion=root:V_TypeFusion
	Switch(V_TypeFusion)
		case 0:	//	Cursor measures
			DoWindow/F F_CursorResults
			if (V_Flag!=1)
				Execute "F_CursorResults()"
			endif
		break
		case 1:	//	Pulse measures
			DoWindow/F F_PulseResults
			if (V_Flag!=1)
				Execute "F_PulseResults()"
			endif
		break
		case 2:	//	Profile measures
			DoWindow/F F_ProfileResults
			if (V_Flag!=1)
				Execute "F_ProfileResults()"
			endif
		break
	EndSwitch
End

//	Template function to perform some action on all conditions
//	Made for cursor conditions, but can be adapted to any other
Function ActionSurTouteCondition()
	variable i, j
	SetDataFolder root:
	String sListe=ListeDF("root:", ksNomCondCurs), sNomDF, sListeWaves, sNom1, sNom2
	DFREF dfCondition
	For (i=0; (i<ItemsInList(sListe)); i+=1)
		sNomDF=StringFromList(i, sListe)
		MajCondCurs(sNomDF)
//		dfCondition=root:$sNomDF
//		//	On fait quelque-chose dans ce datafolder
//		setdatafolder dfCondition
////		Wave W_ParametresMesures, W_Manip
//		Wave/T WS_NomManip
//		for (j=0; (j<DimSize(WS_NomManip,0));J+=1)
//			sNom1=WS_NomManip[j][1]
//			if (CmpStr(sNom1[0,8],"Curseur1_")==0)
//				sNom2=sNom1[9,inf]
//				WS_NomManip[j][1]=sNom2
//			endif
//		endfor
//		SetDataFolder dfCondition
//		sListeWaves=WaveList("!W_*", ";", "")
//		for (j=0; (j<ItemsInList(sListeWaves)); j+=1)
//			sNomWave=StringFromList(j, sListeWaves)
//			killwaves $sNomWave
//		endfor
//		Wave/Z W_ParametresMesures
//		KillWaves/Z W_ParametresMesures
	endfor
	SetDataFolder root:
End

//	Rename all condition datafolders
Function RenameConditionDatafolders()
	variable i
	SetDataFolder root:
	NVAR V_TypeFusion
	String sListe, sPrefixeCondition, sNomDF1, sNomDF2, sNom
	sPrefixeCondition=StringFromList(V_TypeFusion, ksListeConditions)	//	gets the prefix of condition datafolder, depending on data type
	sListe=ListeDF("root:", sPrefixeCondition)
	For (i=0; (i<ItemsInList(sListe)); i+=1)
		sNomDF1=StringFromList(i, sListe)
		sNom=sNomDF1[StrLen(sPrefixeCondition), inf]
		//	this is where the name should be changed
		sNomDF2=sPrefixeCondition+"5dpf_"+sNom
		renamedataFolder root:$sNomDF1, $sNomDF2
	endfor
	SetDataFolder root:
End

//	Lists all experiment present in all conditions
//	Allows basic sorting
Function ListeToutesLesManips()
	variable i	//	index of condition
	variable j	//	index of experiment # in a given condition
	variable vCompteur	=0	//	index in the final list
	variable vTest
	String sBaseNomCondition		//	basename of condition datafolder
	String sTemp
	DFREF dfCondition	//	points at the datafolder containing the condition currently being analyzed

	setdatafolder root:
	NVAR V_TypeFusion
	
	//	Determines the name of condition datafolders depending on the type of data being analyzed
	sBaseNomCondition=StringFromList(V_TypeFusion, ksListeConditions)

	prompt vTest, "Sort by what column:", popup, "experiment id#;export name;condition;error message;accepted or rejected;experimenter;"
	DoPrompt/HELP="List of experiments" "Question", vTest
	if (V_Flag)
		return(0)
	endif
	vTest-=1	//	returns popup number; -1 because popup counts from 1
	
	KillWindow/Z T_ExpList

	//	WS_ListeManips contains: 0: Unique ID #; 1: export name; 2: condition; 3: comment; 4: selected (1) or excluded (0) 
	Make/T/O/N=(1,9) WS_ListeManips
	SetDimLabel 1, 0, 'ID#', WS_ListeManips
	SetDimLabel 1, 1, 'export name', WS_ListeManips
	SetDimLabel 1, 2, condition, WS_ListeManips
	SetDimLabel 1, 3, comment, WS_ListeManips
	SetDimLabel 1, 4, selected, WS_ListeManips
	SetDimLabel 1, 5, experimenter, WS_ListeManips
	SetDimLabel 1, 6, age, WS_ListeManips
	SetDimLabel 1, 7, weight, WS_ListeManips
	SetDimLabel 1, 8, group, WS_ListeManips
	WS_ListeManips=""
	String sListe=ListeDF("root:", sBaseNomCondition), sNomDF, sListeWaves, sNomWave

	//	Examines each condition. 
	For (i=0; (i<ItemsInList(sListe)); i+=1)
		sNomDF=StringFromList(i, sListe)
		dfCondition=root:$sNomDF
		setdatafolder dfCondition
		Wave/T WS_NomManip, WS_Message, WS_Mes_Filemaker
		Wave W_Accept, W_Mes_Filemaker
		Wave/Z W_NumProfil		//	only for profiles
		For (j=0; j<DimSize(WS_NomManip,0); j+=1)
			Switch(V_TypeFusion)
				default:
					Redimension/N=((vCompteur+1),-1) WS_ListeManips
					WS_ListeManips[vCompteur][0]=WS_NomManip[j][0]
					WS_ListeManips[vCompteur][1]=WS_NomManip[j][1]
					WS_ListeManips[vCompteur][2]=sNomDF[StrLen(sBaseNomCondition), inf]	//	show only the first characters of the datafolder name
					if (j<DimSize(WS_Message, 0))	//	there is often an error since WS_Message may not have the right size for some reason
						WS_ListeManips[vCompteur][3]=WS_Message[j]
					else
						WS_ListeManips[vCompteur][3]="No message"
					endif
					WS_ListeManips[vCompteur][4]=Num2Str(W_Accept[j])
					WS_ListeManips[vCompteur][5]=WS_Mes_Filemaker[j][0]
					WS_ListeManips[vCompteur][6]=Num2Str(W_Mes_Filemaker[j][0])
					WS_ListeManips[vCompteur][7]=Num2Str(W_Mes_Filemaker[j][1])
					if (DimSize(	WS_Mes_Filemaker, 1)==6)
						WS_ListeManips[vCompteur][8]=WS_Mes_Filemaker[j][5]	//	Groupe
					else
						WS_ListeManips[vCompteur][8]="no group info"
					endif
					vCompteur+=1
				break
			endswitch
		endfor
	endfor
	SetDataFolder root:

	//	Trie la table par ordre croissant de nom de manip
	SortColumns/KNDX={vTest} sortWaves={WS_ListeManips}

	//	Remove duplicates among experiment ID
	Make/N=(DimSize(WS_ListeManips,0))/FREE/T wsTemp
	wsTemp=WS_ListeManips[p][vTest]
	FindDuplicates/RT=WS_ListeManipsUniques wsTemp
	
	//	Remove duplicates of a same date root -> number of days of experiments ~= number of animals
	Make/N=(DimSize(WS_ListeManips,0))/FREE/T wsTemp
	for (i=0; (i<DimSize(WS_ListeManips,0)); i+=1)
		sTemp=WS_ListeManips[i][0]
		sTemp=sTemp[0,9]
		wsTemp[i]=sTemp
	endfor
	FindDuplicates/RT=WS_ListeJoursUniques wsTemp	
	
	//	Display resulting lists
	DoWindow/F T_ExpList
	if (V_Flag!=1)
		Edit/K=1/N=T_ExpList WS_ListeManips.ld, WS_ListeManipsUniques, WS_ListeJoursUniques as "List of experiments"
	endif
End

//	*************************	End of utility functions for conditions		*********
//	_______________________________________________________________________________

//________________________________________________________________________________________________________
//**************************************		Condition Cursor measurement	****************************

//	Create a new condition datafolder for cursor measurements
Function CreeCondCurs()
	String sNom	
	string sNomDF=ksNomCondCurs
	SetDataFolder root:
	//	Asks until a new condition name is provided
	Do
		prompt sNomDF, "Name for the datafolder "
		DoPrompt ksNomCondCurs, sNomDF
		if (V_Flag)
			print "cancelled by user"
			return(0)
		endif
	while ((DataFolderExists(sNomDF)) || (StrLen(sNomDF)>31))
	if (V_Flag)
		return(0)
	endif
	//	crée le datafolder pour cette dose et y met les waves et variables spécifiques de cette condition
	NewDataFolder $sNomDF
	InitDataFolder("Init fusion.pxp", "f_Curs_", sNomDF)
End

//	_____________________	_____________________
// *** Update cursor condition ***
Function MajCondCurs(sNomDF)//, [vKeepMessage])
	String sNomDF	//	name of condition datafolder

	DFREF dfGlobal=root:Global
	NVAR/SDFR=dfGlobal V_IMin, V_IMax, V_ErrorInterval_SD, V_ErrorInterval_CI		//	Global variables
	Wave/SDFR=dfGlobal M_CouleursVariees, M_CouleursSpectre	//	Color tables

//	Objets
	Struct structFileMakerData stFMData
	Struct RGBColor stCouleur
	variable i, j, vTag, vNbCol, vTemp, vCompteur, vNbXWaves, vNbYWaves, vChoixCouleur, vChoixMoy
	variable vBoolean, vUnique, vDeltaX, vIndexManip=0, vIndexCouleur, vRed, vGreen, vBlue
	string sNomFenetre, sNomGraphe, sNomTableau, sListe, sNomTemps, sNomMoy, sNomWave, sNomTrace, sNomWaveStr, sNomROI, sNomTag
	string sNomImport, sNomDFImport, sNomColonne, sNomExport
	string sListeMoy_Y="", sListeMoy_X="", sListeROI_Y="", sListeROI_X=""	//	liste des waves affichées: moyennes ou traces individuelles

	DFREF dfCondCurs=root:$sNomDF
	SetDataFolder dfCondCurs

	//	Waves per experiment
	Wave/T WS_NomManip, WS_Message, WS_Tag, WS_NomTrace
	Wave W_Accept, W_Tag, W_IndexManip
	Wave W_Mes_Raplouf, W_Mes_Filemaker, W_Mes_Fusion
	Wave/T WS_Mes_Filemaker
	
	//	Waves per ROI
	Wave/T WS_Message_ROI, WS_Nom_ROI
	Wave W_NumManip_ROI, W_Average_ROI, W_Error_ROI, W_NumROI_ROI, W_IndexManip_ROI
	NVAR V_PeakStart, V_PeakEnd, V_FitStart, V_FitEnd, V_PntsBeforePeak, V_PntsAfterPeak, V_PosNeg, V_CursorMode
	Wave W_Mes_Raplouf_ROI, W_Mes_Filemaker_ROI, W_Mes_Fusion_ROI
	Wave/T WS_Mes_Filemaker_ROI

	//	Waves to display the selected info
	Wave W_DisplaySelection
	Wave/T WS_DisplaySelection
	
	//	Redimensionne les waves par manip selon la taille de WS_NomManip
	Redimension/N=(DimSize(WS_NomManip, 0), -1, -1, -1) WS_Message, W_Tag, WS_Tag, W_Accept, W_IndexManip,WS_NomTrace
	Redimension/N=(DimSize(WS_NomManip, 0), -1) W_Mes_Raplouf, W_Mes_Filemaker, W_Mes_Fusion, WS_Mes_Filemaker
	Redimension/N=(-1, 3) W_Mes_Filemaker
	Redimension/N=(-1, ItemsInList(ksFileMakerParamsStr)) WS_Mes_Filemaker
	Redimension/N=(-1, 9) W_Mes_Fusion, W_Mes_Fusion_ROI

	//	little addition for personal convenience
	//	If the user creates the waves W_Gain and W_Gain_ROI, they will be used as a coefficient in multiplicating intensity measurements
	variable vGain = 0	//	switches to 1 if W_Gain and W_Gain_ROI exist and should be processed
	Wave/Z W_Gain, W_Gain_ROI
	If ( WaveExists(W_Gain) && WaveExists(W_Gain_ROI) )
		vGain=1
		Redimension/N=(DimSize(WS_NomManip, 0)) W_Gain
	endif

	W_Mes_Raplouf=NaN
	W_Mes_Raplouf_ROI=NaN
	W_Mes_Fusion[][]=NaN
	W_Mes_Fusion_ROI[][]=NaN
	W_Mes_Fusion[][0,5]=NaN
	W_Mes_Fusion_ROI[][0,5]=NaN
	W_Mes_Filemaker_ROI=NaN
	WS_Mes_Filemaker_ROI=""
	WS_Message_ROI=""
	WS_NomTrace=""
	
//	Window names used to display the condition
	sNomFenetre="F_CursorResults"
	sNomGraphe= "F_CursorResults#G0"
	sNomTableau="F_CursorResults#T0"

	//	Begining of the loop to handle each experiment in the list
	For (i=0; (i<DimSize(WS_NomManip,0)); i+=1)

		//	Handles the data imported from the database, to put it in the W(S)_Filemaker waves
		//	Tests whether the datafolder exists; may not have been created
		if (DataFolderExists("root:FileMaker:"))
			//	Extract data from database
			stFMData.sNomManip=WS_NomManip[i][0]
			ExtraitFMData(stFMData)	//	Gets filemaker info for this precise experiment ID
			W_Mes_Filemaker[i][0]=stFMData.vAge
			W_Mes_Filemaker[i][1]=stFMData.vPoids
			W_Mes_Filemaker[i][2]=stFMData.vDoseTestee
			WS_Mes_Filemaker[i][0]=stFMData.sExperimentateur
			WS_Mes_Filemaker[i][1]=stFMData.sSexe
			WS_Mes_Filemaker[i][2]=stFMData.sBiosenseur
			WS_Mes_Filemaker[i][3]=stFMData.sClone
			WS_Mes_Filemaker[i][4]=stFMData.sGenotype
			WS_Mes_Filemaker[i][5]=stFMData.sGroupe
			WS_Mes_Filemaker[i][6]=stFMData.sCodeAnimal
			WS_Mes_Filemaker[i][7]=stFMData.sBrainStruct
		endif

		//	Skips items where the name is missing or the experiment is marked "0" (reject)
		if ((StrLen(WS_NomManip[i][0])==0) || (W_Accept[i]==0))
			W_IndexManip[i]=NaN
			Continue
		endif
		
		//	Index corresponding to this experiment
		W_IndexManip[i]=vIndexManip
		
		//	Define common element to this condition
		//	root df containing the data of this experiment
		sNomExport=WS_NomManip[i][1]	//	name of datafolder to get
		if (StrLen(sNomExport)==0)			//	If nothing specified, use the default name
			snomExport=ksNomExport
		else
			snomExport=ksNomExport+"_"+sNomExport
		endif
		
		sNomDFImport="root:"+ksNomDataFolderImport+":'"+WS_NomManip[i][0]+"_"+sNomExport+"'"
		DFREF dfImport = $sNomDFImport
		if (DataFolderRefStatus(dfImport)==0)
			WS_Message[i]+="No import datafolder; "
			Continue	//	on arrête l'examen de cette manip
		endif
				
		//	sub-datafolder containing the relevant traces
		ControlInfo C_Norm		//	get the type of normalization that is selected in the popup
		//	try the sub-datafolder with the correct normalization type
		sNomDFImport+=":"+S_Value
		DFREF dfImportTraces = $sNomDFImport
		if (DataFolderRefStatus(dfImportTraces)==0)
			//	sub-datafolder not found -> warning
			WS_Message[i]+="No (or old) datafolder for the traces; analysis skipped; "
			Continue
		endif

		NVAR/Z/SDFR=dfImport V_R0	//	Get R0 value for this experiment
		W_Mes_Fusion[i][0]=V_R0

		//	Stats wave in the imported datafolder
		sNomWave=WS_NomManip[i][0]+"_W_Ratio"
		Wave/SDFR=dfImport/Z wRatio=$sNomWave
		if (!WaveExists(wRatio))
			WS_Message[i]+="no imported stats; "
			Continue
		endif
		sNomWaveStr=WS_NomManip[i][0]+"_W_RatioStr"
		Wave/T/SDFR=dfImport wRatioStr=$sNomWaveStr
		sNomWave=WS_NomManip[i][0]+"_W_RatioTag"
		Wave/SDFR=dfImport wRatioTag=$sNomWave
		sNomWaveStr=WS_NomManip[i][0]+"_W_RatioTagStr"
		Wave/T/SDFR=dfImport wRatioTagStr=$sNomWaveStr
		
		vTag=W_Tag[i]

		//	Transfers the measurements from analysis table to condition table
		Redimension/N=(-1, (DimSize(wRatioTag,1))) W_Mes_Raplouf
		W_Mes_Raplouf[i][]=wRatioTag[vTag][q]

		//	Time wave for this experiment
		sNomTemps=WS_NomManip[i][0]+"_temps"
		Wave/Z/SDFR=dfImport wTemps=$sNomTemps
		if (!WaveExists(wTemps))
			sNomTemps=WS_NomManip[i][0]+"_"+WS_NomManip[i][2]+"_temps"
			Wave/Z/SDFR=dfImport wTemps=$sNomTemps
		endif
		if (!WaveExists(wTemps))
			WS_Message[i]+="No time wave; "
		endif
		//	Test if time is monotonic; if not, issue a warning
		if (!MonotonicCheck(wTemps, vDeltaX))
			WS_Message[i]+="Non-monotonic time; "
			Continue
		endif

		//	Average trace per tag
		sNomMoy=WS_NomManip[i][0]+"_Moy_"+num2str(W_Tag[i])
		Wave/Z/SDFR=dfImportTraces wMoy=$sNomMoy
		//	Détecte les problèmes dans la trace wMoy
		vBoolean=1
		if (!WaveExists(wMoy))
			//	mettre un message d'erreur
			WS_Message[i]+="avg trace not found; "
			vBoolean=0
		endif
		WaveStats/Z/Q/R=[V_PeakStart, V_PeakEnd] wMoy
		if (V_numNaNs>0)
			//	mettre un message d'erreur
			WS_Message[i]+="average trace contains NaN; "
			vBoolean=0
		endif
		//	Si existe, traite la trace moyenne: ajoute à la liste pour afficher, et effectue la mesure
		if (vBoolean==1)
			//	Save the wave name in the table
			WS_NomTrace[i]=sNomMoy
			//	Incrémente la liste des waves à moyenner à la fin
			sListeMoy_Y=AddListItem(GetWavesDataFolder(wMoy,2), sListeMoy_Y, ";", inf)
			sListeMoy_X=AddListItem(GetWavesDataFolder(wTemps,2), sListeMoy_X, ";", inf)
			
			//	Effectue la mesure sur la trace moyenne
			Wave wCoef=MesureEtFit(wtemps, wMoy, V_PeakStart, V_PeakEnd, V_FitStart, V_FitEnd, V_PntsBeforePeak, V_PntsAfterPeak, V_PosNeg)		
			W_Mes_Fusion[i][1]=wCoef[0]*V_PosNeg
			W_Mes_Fusion[i][2]=wCoef[1]*V_PosNeg
			W_Mes_Fusion[i][3]=wCoef[2]*V_PosNeg*1000
		endif	//	fin traitement trace moyenne
		
		//	Effectue le calcul AB norm
		if (V_CursorMode==1)
		else
			Print "Only works with cursor mode 1"
		endif

		//	Handle individual ROIs corresponding to this experiment
		for (j=1; (j<DimSize(wRatio, 0)); j+=1)	//	Loop for all ROIs
			if (wRatio[j][1]==vTag)	//	tag # corresponds to what is expected -> this ROI is included in the analysis

				//	Increase the size of tables holding ROI results, to accomodate for this new ROI
				//	vCompteur is the index in these tables
				Redimension/N=(vCompteur+1, -1) WS_Message_ROI, WS_Nom_ROI, W_IndexManip_ROI, W_NumManip_ROI, W_NumROI_ROI
				Redimension/N=(vCompteur+1, (DimSize(wRatio,1))) W_Mes_Raplouf_ROI
				Redimension/N=(vCompteur+1,-1) W_Mes_Fusion_ROI
				Redimension/N=(vCompteur+1,DimSize(W_Mes_Filemaker,1)) W_Mes_Filemaker_ROI
				Redimension/N=(vCompteur+1,DimSize(WS_Mes_Filemaker,1)) WS_Mes_Filemaker_ROI
				if (vGain)
					Redimension/N=(vCompteur+1) W_Gain_ROI
					W_Gain_ROI[vCompteur]=W_Gain[i]
				endif

				//	Transfers measurements from raplouf table
				W_Mes_Raplouf_ROI[vCompteur][]=wRatio[j][q]
				
				//	Copy filemaker info into _ROI waves
				W_Mes_Filemaker_ROI[vCompteur][]=W_Mes_Filemaker[i][q]
				WS_Mes_Filemaker_ROI[vCompteur][]=WS_Mes_Filemaker[i][q]
				
				//	set the experiment counter
				W_NumManip_ROI[vCompteur]=i
				
				//	Create the name for this ROI
				W_IndexManip_ROI[vCompteur]=vIndexManip
				W_NumROI_ROI[vCompteur]=wRatio[j][0]
				WS_Nom_ROI[vCompteur]=wRatioStr[j][0]+"#"+num2str(W_NumROI_ROI[vCompteur])
				
				//	Accède aux waves des traces pour la ROI en cours
				sNomROI=AjouteNumero(wRatioStr[j][0]+"_", wRatio[j][0], 4)
				Wave/Z/SDFR=dfImportTraces wROI=$sNomROI

				//	Détecte les problèmes dans la trace wROI
				vBoolean=1
				if (!WaveExists(wROI))
					WS_Message_ROI[vCompteur]+="ROI trace not found; "
					vBoolean=0
				endif
				if (!WaveExists(wTemps))
					WS_Message_ROI[vCompteur]+="time not found; "
					vBoolean=0					
				endif
				WaveStats/Z/Q/R=[V_PeakStart, V_PeakEnd] wROI
				if (V_numNaNs>0)
					WS_Message_ROI[vCompteur]+="trace contains NaN; "
					vBoolean=0					
				endif
				
				//	Fait la mesure sur les traces
				if (vBoolean==1)
					Wave wCoef=MesureEtFit(wtemps, wROI, V_PeakStart, V_PeakEnd, V_FitStart, V_FitEnd, V_PntsBeforePeak, V_PntsAfterPeak, V_PosNeg)
					W_Mes_Fusion_ROI[vCompteur][0]=V_R0
					W_Mes_Fusion_ROI[vCompteur][1]=wCoef[0]*V_PosNeg
					W_Mes_Fusion_ROI[vCompteur][2]=wCoef[1]*V_PosNeg
					W_Mes_Fusion_ROI[vCompteur][3]=wCoef[2]*V_PosNeg*1000
					
					//	Incrémente la liste des waves à moyenner à la fin
					sListeROI_Y=AddListItem(GetWavesDataFolder(wROI,2), sListeROI_Y, ";", inf)
					sListeROI_X=AddListItem(GetWavesDataFolder(wTemps,2), sListeROI_X, ";", inf)
				endif
				vCompteur+=1			
			endif
		endfor	//	fin du traitement de chaque ROI
		vIndexManip+=1	//	incrémente l'indexation des num de manip
	EndFor	//	fin de la boucle de traitement de chaque manip

//	Calcul des traces moyennes
		//	Attention: comportement prévu mais emmerdant: si sListeROI_X contient toujours la même wave X, fWaveAverage ne génère pas de nouvelles
		//	valeurs de x, et la wave moyenne est à une échelle start=0 ∆=1. Cas d'une manip unique dans la condition.
		// En revanche, s'il y a des waves X différentes, fWaveAverage génère une nouvelle échelle X interpolée..., et ça se met bien sur le graphe.

//	Calcule les moyennes et les ajoute sur les graphes; Liste de waves: sListeMoy_Y, sListeMoy_X, sListeROI_Y, sListeROI_X
	vNbXWaves=ItemsInList(sListeMoy_X)
	vNbYWaves=ItemsInList(sListeMoy_Y)
	if ((vNbXWaves>1) && (vNbXWaves==vNbYWaves))	//	pour exclure le cas où il n'y a pas de moyenne à montrer
		vUnique=0
		fWaveAverage(sListeMoy_Y, sListeMoy_X, 1, V_ErrorInterval_SD, "W_Average", "W_Error_SD")
		fWaveAverage(sListeMoy_Y, sListeMoy_X, 2, V_ErrorInterval_CI, "W_Average", "W_Error_CI")
		fWaveAverage(sListeMoy_Y, sListeMoy_X, 3, 1, "W_Average", "W_Error_SEM")
	else	//	cas d'une condition dans laquelle il y a une manip unique
		if (vNbXWaves==0)
			DoAlert 0, "Only one experiment, so not much to show!"
		else
			vUnique=1
			sNomWave=StringFromList(0, sListeMoy_Y)
			Wave wMoy=$sNomWave
			sNomWave=StringFromList(0, sListeMoy_X)
			Wave wX=$sNomWave
			//	Il faut rééchantillonner cette trace unique pour lui mettre un ∆x continu
			Interpolate2/T=1/N=200/Y=W_Average wX, wMoy
			//	Creating error waves = NaN
			Duplicate/O W_Average, W_Error_SD
			W_Error_SD=NaN
			Duplicate/O W_Error_SD, W_Error_CI, W_Error_SEM
		endif
	endif

//	idem, calcule la moyenne des ROI
	vNbXWaves=ItemsInList(sListeROI_X)
	vNbYWaves=ItemsInList(sListeROI_Y)

	//	Calcule la moyenne des traces.
	if (vNbXWaves>=1)
//		fWaveAverage(sListeROI_Y, sListeROI_X, V_ErrorType, 1, "W_Average_ROI", "W_Error_ROI")
		fWaveAverage(sListeROI_Y, sListeROI_X, 1, V_ErrorInterval_SD, "W_Average_ROI", "W_Error_SD_ROI")
		fWaveAverage(sListeROI_Y, sListeROI_X, 2, V_ErrorInterval_CI, "W_Average_ROI", "W_Error_CI_ROI")
		fWaveAverage(sListeROI_Y, sListeROI_X, 3, 1, "W_Average_ROI", "W_Error_SEM_ROI")
		if (vUnique==1)		//	il y a une unique manip dans cette condition
			//	on rééchantillonne la moyenne pour lui donner une définition en X qui fonctionne
			Duplicate/O/FREE W_Average_ROI, W_Average_ROI_temp
			Interpolate2/T=1/N=200/Y=W_Average_ROI wX, W_Average_ROI_temp
			Duplicate/O W_Average_ROI, W_Error_SD_ROI
			W_Error_SD_ROI=NaN
			Duplicate/O W_Error_SD_ROI, W_Error_CI_ROI, W_Error_SEM_ROI
			//	old code, need to be updated with SD, CI and SEM
//			Duplicate/O/FREE W_Error_ROI, W_Error_ROI_temp
//			Interpolate2/T=1/N=200/Y=W_Error_ROI wX, W_Error_ROI_temp
		endif
	endif

	//	Performs the additional calculations, incling custom functions, which is returned in the W_Mes_Fusion wave
	Custom_Calculations()
	
//	Up to here, the code executes the calculations corresponding to the condition
//	Should be executed to update the condition, each time this condition is used in a group.
//	From now on, it is worth executing only if there is a window to display the result
//	Terminates the execution if the condition window doesn't exist
	DoWindow F_CursorResults
	if (V_Flag==0)
		return(0)
	endif

//	Displays the waves in the graph #G0 sub-window
//	Clears traces except W_Vide
	EnleveToutesLesTracesSauf(sNomFenetre, "W_Vide", sNomSousfenetre="#G0")

	ControlInfo C_Moy	//	display the average or not
	vChoixMoy=V_Value
	ControlInfo C_ChoixCouleur	//	what color mode
	vChoixCouleur=V_Value
	ControlInfo C_MoyOuROI	//	display average or individual traces
	StrSwitch(S_Value)
		case "Average":
			//	scans all items in the list of waves of average traces
			for (i=0; (i<ItemsInList(sListeMoy_X)); i+=1)
				sNomMoy=StringFromList(i, sListeMoy_Y)
				sNomTemps=StringFromList(i, sListeMoy_X)
				Wave wMoy=$sNomMoy, wTemps=$sNomTemps
				sNomTrace=NameOfWave(wMoy)
				AppendToGraph/W=$sNomGraphe wMoy/TN=$sNomTrace vs wTemps
				Switch(vChoixCouleur)
					case 1:	//	experiment number
						vTemp=MOD(i, dimsize(M_CouleursVariees,0))
						vRed=M_CouleursVariees[vTemp][0]
						vGreen=M_CouleursVariees[vTemp][1]
						vBlue=M_CouleursVariees[vTemp][2]
					break
					case 2:	//	measurement selected for display in the table
						vIndexCouleur=((W_DisplaySelection[i]-V_IMin)/(V_IMax-V_IMin))*DimSize(M_CouleursSpectre, 0)
						if (NumType(vIndexCouleur)==0)
							vIndexCouleur=Min(vIndexCouleur, DimSize(M_CouleursSpectre, 0)-1)	//	to make sure the index does not go beyond wave size
							vIndexCouleur=Max(0, vIndexCouleur)
							vRed=M_CouleursSpectre[vIndexCouleur][0]
							vGreen=M_CouleursSpectre[vIndexCouleur][1]
							vBlue=M_CouleursSpectre[vIndexCouleur][2]
						else
							vRed=50000; vGreen=30000; vBlue=40000
						endif
					break
					case 3:	//	black
						vRed=0; vGreen=0; vBlue=0
					break
				endswitch
				ModifyGraph/W=$sNomGraphe rgb($sNomTrace)=(vRed, vGreen, vBlue)
			endfor

			if (vChoixMoy)	//	Appends the average of the average traces
				AppendToGraph/W=$sNomGraphe W_Average
				ModifyGraph/W=$sNomGraphe rgb(W_Average)=(0,0,0), lsize(W_Average)=3
//				Switch(V_ErrorType)
//					case 1:
//						ErrorBars/W=$sNomGraphe W_Average SHADE={0,0,(0,0,0,6554),(0,0,0,0)},wave=(W_Error_SD,W_Error_SD)
//					break
//					case 2:
//						ErrorBars/W=$sNomGraphe W_Average SHADE={0,0,(0,0,0,6554),(0,0,0,0)},wave=(W_Error_CI,W_Error_CI)
//					break
//					case 3:
//						ErrorBars/W=$sNomGraphe W_Average SHADE={0,0,(0,0,0,6554),(0,0,0,0)},wave=(W_Error_SEM,W_Error_SEM)
//					break
//				EndSwitch
			endif
		break
		case "ROI":
			for (i=0; (i<ItemsInList(sListeROI_X)); i+=1)
				sNomRoi=StringFromList(i, sListeROI_Y)
				sNomTemps=StringFromList(i, sListeROI_X)
				Wave wROI=$sNomROI, wTemps=$sNomTemps
				AppendToGraph/W=$sNomGraphe wROI vs wTemps
				switch(vChoixCouleur)
					case 1:	//	Exp #
						vIndexCouleur=MOD(W_NumManip_ROI[i], dimsize(M_CouleursVariees,0))
						vRed=M_CouleursVariees[vIndexCouleur][0]
						vGreen=M_CouleursVariees[vIndexCouleur][1]
						vBlue=M_CouleursVariees[vIndexCouleur][2]
					break
					case 2:	//	Intensity
//						vIndexCouleur=(1-(W_DisplaySelection[i]-V_IMin)/(V_IMax-V_IMin))*DimSize(M_CouleursSpectre, 0)
//						if (NumType(vIndexCouleur)==0)
//							vIndexCouleur=Min(vIndexCouleur, DimSize(M_CouleursSpectre, 0)-1)	//	to make sure the index does not go beyond wave size
//							vIndexCouleur=Max(0, vIndexCouleur)
//							vRed=M_CouleursSpectre[vIndexCouleur][0]
//							vGreen=M_CouleursSpectre[vIndexCouleur][1]
//							vBlue=M_CouleursSpectre[vIndexCouleur][2]
//						else
//							vRed=50000; vGreen=30000; vBlue=40000
//						endif
					break
					default:
						vRed=0; vGreen=0; vBlue=0
					break
				EndSwitch
				ModifyGraph/W=$sNomGraphe rgb[i+1]=(vRed,vGreen,vBlue)
			endfor

			if (vChoixMoy)	//	Appends the average of the ROI traces
				AppendToGraph/W=$sNomGraphe W_Average_ROI
				ModifyGraph/W=$sNomGraphe rgb(W_Average_ROI)=(0,0,0), lsize(W_Average_ROI)=3
//				Switch(V_ErrorType)
//					case 1:			
//						ErrorBars/W=$sNomGraphe W_Average_ROI SHADE={0,0,(0,0,0,6554),(0,0,0,0)},wave=(W_Error_SD_ROI,W_Error_SD_ROI)
//					break
//					case 2:			
//						ErrorBars/W=$sNomGraphe W_Average_ROI SHADE={0,0,(0,0,0,6554),(0,0,0,0)},wave=(W_Error_CI_ROI,W_Error_CI_ROI)
//					break
//					case 3:			
//						ErrorBars/W=$sNomGraphe W_Average_ROI SHADE={0,0,(0,0,0,6554),(0,0,0,0)},wave=(W_Error_SEM_ROI,W_Error_SEM_ROI)
//					break
//				endswitch
			endif
		break
	EndSwitch

	//	Transfers the right values in the waves displayed in the table
	//	Numeric data from selection
	ControlInfo/W=$sNomFenetre C_ChoixWavePourAfficher
	sNomWave=S_Value
	ControlInfo/W=$sNomFenetre C_MoyOuROI
	if (CmpStr(S_Value, "ROI")==0)
		sNomWave+="_ROI"
	endif
	Wave wSelection=$sNomWave
	Redimension/N=(DimSize(wSelection, 0)) W_DisplaySelection

	//	Determines which column to display
	ControlInfo/W=$sNomFenetre C_NumColPourAfficher
	//	Value may result from the previous selection in a different mode, 
	//	and V_Value may exceed the dimension of wSelection
	//	-> take the min
	vTemp=min(V_Value-1, DimSize(wSelection,1)-1)
	vTemp= (vTemp<0) ? 0 : vTemp
	W_DisplaySelection=wSelection[p][vTemp]
	PopupMenu C_NumColPourAfficher,win=$sNomFenetre,mode=vTemp+1
	
	//	Text data from selection; only displayed if in average mode
	ControlInfo/W=$sNomFenetre C_ChoixWavePourAfficherStr
	sNomWave=S_Value
	Wave/T wSelectionStr=$sNomWave	
	Redimension/N=(DimSize(wSelectionStr, 0)) WS_DisplaySelection
	//	Determines which column to display
	ControlInfo/W=$sNomFenetre C_NumColPourAfficherStr
	WS_DisplaySelection=wSelectionStr[p][V_Value-1]

End	//	___________________________________		Fin MaJCondCurs_		_____________________________________________________________

//	Define the window to display a condition
//	Attention: mise à jour automatique de la macro: repérer les objets "localisés" avec recherche sur "root:"
Window F_CursorResults() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /K=1 /W=(39,45,1351,530) as "Cursor measurements"
	ModifyPanel fixedSize=1
	PopupMenu C_PopChoixCondition,pos={8.00,4.00},size={156.00,23.00},proc=PopMenuSelectCondCurs,title="Condition:"
	PopupMenu C_PopChoixCondition,mode=1,popvalue="none",value= #"ListeDFCond()"
	PopupMenu C_MoyOuROI,pos={10.00,28.00},size={77.00,23.00},proc=PopMenuSelectCondCurs
	PopupMenu C_MoyOuROI,mode=1,popvalue="Average",value= #"\"Average;ROI\""
	PopupMenu C_Norm,pos={10.00,72.00},size={97.00,23.00},proc=PopMenuSelectCondCurs
	PopupMenu C_Norm,help={"Normalized: from Rmin to Rmax; Normalized_Baseline: substract AB"}
	PopupMenu C_Norm,mode=1,popvalue="Normalized",value= #"ksNomsTypeExport"
	PopupMenu C_ChoixCouleur,pos={10.00,294.00},size={120,23.00},proc=PopMenuSelectCondCurs,title="Plot color"
	PopupMenu C_ChoixCouleur,mode=1,popvalue="exp #",value= #"\"exp #;measure;black\""
	PopupMenu C_ChoixWavePourAfficher,pos={708.00,10.00},size={120.00,23.00},proc=PopMenuSelectCondCurs
	PopupMenu C_ChoixWavePourAfficher,mode=1,popvalue="W_Mes_Raplouf",value= #"ksWavesCondForDisplay\t"
	CheckBox C_Moy,pos={10.00,319.00},size={58.00,16.00},proc=CheckProcCondCurs,title="Show avg"
	CheckBox C_Moy,help={"displays the average on top of other traces"}
	CheckBox C_Moy,value= 0,side= 1

	Button C_OuvreManip,pos={10.00,350.00},size={110.00,18},proc=BoutonCondition,title="Open experiment"
	Button C_OuvreManip,help={"Open the selected experiment"},fSize=11
	Button C_ImporteData,pos={10.00,370.00},size={110.00,18},proc=BoutonCondition,title="Import data"
	Button C_ImporteData,help={"Import the data corresponding to this condition"}
	Button C_ImporteData,fSize=11
	Button C_EffaceMessages,pos={10.00,390.00},size={110.00,18},proc=BoutonCondition,title="Clear all messages"
	Button C_EffaceMessages,help={"Clear error messages in all conditions"},fSize=11
	
	Button C_ExportName,pos={766,450.00},size={38.00,16.00},proc=BoutonCondition,title="Same"
	Button C_ExportName,fSize=11
	Button C_Accept,pos={925,450.00},size={38.00,16.00},proc=BoutonCondition,title="Same"
	Button C_Accept,fSize=11
	Button C_TagNumber,pos={970,450.00},size={38.00,16.00},proc=BoutonCondition,title="Same"
	Button C_TagNumber,fSize=11

	
	SetVariable C_CursorMode,pos={10.00,54.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="Curs. mode",limits={1,4,1}
	SetVariable C_PosNeg,pos={10.00,94.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="+1 or -1",limits={-1,1,2}
	SetVariable C_PeakStart,pos={10.00,114.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="Peak start"
	SetVariable C_PeakEnd,pos={10.00,134.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="Peak end"
	SetVariable C_NbPtAvant,pos={10.00,154.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="Pts before peak"
	SetVariable C_NbPtApres,pos={10.00,174.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="Pts after peak"
	SetVariable C_FitDebut,pos={10.00,194.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="Fit start"
	SetVariable C_FitFin,pos={10.00,214.00},size={110.00,14.00},proc=SetVarProcMajCondCurs,title="Fit end"
	PopupMenu C_ChoixWavePourAfficherStr,pos={1015.00,10.00},size={138.00,23.00},proc=PopMenuSelectCondCurs
	PopupMenu C_ChoixWavePourAfficherStr,mode=1,popvalue="WS_Mes_Filemaker",value= #"ksWavesCondForDisplayStr"
	PopupMenu C_NumColPourAfficher,pos={850.00,10.00},size={90.00,23.00},proc=PopMenuSelectCondCurs
	PopupMenu C_NumColPourAfficher,mode=8,popvalue="Amplitude",value= #"ksCursParams1"
	PopupMenu C_NumColPourAfficherStr,pos={1161.00,10.00},size={108.00,23.00},proc=PopMenuSelectCondCurs
	PopupMenu C_NumColPourAfficherStr,mode=1,popvalue="Experimenter",value= #"ksFileMakerParamsStr\t"
	Button C_ListObjects,pos={10.00,420.00},size={110.00,18},proc=BoutonCondition,title="List of objects"
	Button C_ListObjects,help={"Show the list of all objects used in a condition"},fSize=11,fstyle=0
	Button C_Aide_Conditions,pos={10.00,460.00},size={50.00,20.00},proc=BoutonAide,title="Help"
	Button C_Aide_Conditions,help={"Show help topic"},fSize=11,fstyle=1
	CheckBox C_Active_P_Global title="Show global variables",pos={500,4},proc=CheckActivePanneauFusion,value=0
	
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:z_Initialisation:f_Global:
	Display/W=(137,32,585,444)/HOST=#  W_Vide
	SetDataFolder fldrSav0
	ModifyGraph hideTrace=1
	RenameWindow #,G0
	SetActiveSubwindow ##
	String fldrSav1= GetDataFolder(1)
	Edit/W=(606,34,1290,443)/HOST=#
	RenameWindow #,T0
	SetActiveSubwindow ##
	SetWindow kwTopWin hook(Curseur)=CrochetCurseur
EndMacro

//	Hook function linked to the table F_CursorResults#T0
// *** highlight the trace corresponding to the selected cell in the table ***
Function CrochetCurseur(s)
	STRUCT WMWinHookStruct &s
	Variable hookResult=0, vLigne
	string sInfo, sSelection, sNomTrace
	Switch(s.specialKeyCode)
		case 204:		//	escape key was pressed
			Wave/T/Z WS_NomTrace		//	if this point is reached, the datafolder should be the currently displayed condition and the wave should exist
			if (!WaveExists(WS_NomTrace))
				break
			endif
			ModifyGraph/W=F_CursorResults#G0 lsize=1	//	Set all traces to thickness=1
			sInfo=TableInfo("F_CursorResults#T0", -2)		//	to get the position of selected cell in the table
			sSelection=StringByKey("TARGETCELL", sInfo)	//	returns the coordinates of the selected cell in the table, as a coma-separated pair
			vLigne=Str2Num(StringFromList(0, sSelection, ","))	//	get the first argument, ie row number of selected cell
			if ((vLigne)>=DimSize(WS_NomTrace,0))	//	happens when the selected cell is at the end of the table
				break
			endif
			sNomTrace=WS_NomTrace[vLigne]
			ModifyGraph/W=F_CursorResults#G0/Z lsize($sNomTrace)=3		//	get the name of the trace from the text wave
			beep
			hookResult=0		//	the hook function should be followed by the expected change in the table
		break
	endswitch
	return hookResult
End

Function CheckProcTempsEnMinutes(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	
	ControlInfo C_PopChoixGroupe
	DFREF dfGroup=root:$S_Value

	NVAR/SDFR=dfGroup V_Temps_en_Minutes
	StrSwitch(ctrlName)
		case "C_Temps_en_Secondes":
			V_Temps_en_Minutes=0
		break
		case "C_Temps_en_Minutes":
			V_Temps_en_Minutes=1
		break
	EndSwitch
	CheckBox/Z C_Temps_en_Secondes win=P_Group,value=V_Temps_en_Minutes==0
	CheckBox/Z C_Temps_en_Minutes win=P_Group,value=V_Temps_en_Minutes==1
	MajGroupe()
End

Function PopMenuSelectCondCurs(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum
	String popStr
	string sNomDF
	string sTemp, sTemp2, sNomWave

	//	on récupère le nom du datafolder sélectionné
	ControlInfo C_PopChoixCondition
	sNomDF=S_Value
	DFREF dfCondition=root:$sNomDF
	SetDataFolder dfCondition

//	CheckProcTempsEnMinutes("", 0)

	InitDataFolder("Init fusion.pxp", "f_Curs_", sNomDF)	//	Initialize the condition datafolder
	
	NVAR V_CursorMode
	Wave WS_NomManip, WS_Nom_ROI, W_Accept, W_Tag, WS_Message, WS_Message_ROI, W_DisplaySelection, WS_DisplaySelection

	//	Clears drawings on graph or not, depending on ctrlName
	StrSwitch(ctrlName)
		case "SansEffacer":
		break
		default:
			SetDrawLayer/W=F_CursorResults#G0/K ProgFront
		break
	EndSwitch

	//	Clears table content
	Do
		sTemp=TableInfo("F_CursorResults#T0",0)
		sNomWave=StringByKey("WAVE", sTemp)
		if (StrLen(sNomWave)>0)
			Wave sW=$sNomWave
			RemoveFromTable/W=F_CursorResults#T0 sW
		else
			break
		endif
	While (1)
	
	//	Places the current waves in the table
	//	determines which wave to display
	ControlInfo C_MoyOuROI
	variable vMoyOuIndividuel=V_Value
	Switch(V_Value)
		case 1:	//	average
//	To eventually set a title to the column content; but somehow, it induces an infinite loop
//			SetDimLabel 1, 0, 'Expe ID', WS_NomManip
			AppendToTable/W=F_CursorResults#T0 WS_NomManip, W_Accept, W_Tag, WS_Message, W_DisplaySelection, WS_DisplaySelection
			ModifyTable/W=F_CursorResults#T0 size=11,format(Point)=1,width(Point)=30,width(WS_NomManip)=102
			ModifyTable/W=F_CursorResults#T0 width(W_Accept)=22,width(W_Tag)=20,width(WS_Message)=92,width(W_DisplaySelection)=62
			ModifyTable/W=F_CursorResults#T0 width(WS_DisplaySelection)=130
		break
		case 2:	//	roi
			AppendToTable/W=F_CursorResults#T0 WS_Nom_ROI, WS_Message_ROI, W_DisplaySelection//, WS_DisplaySelection
			ModifyTable/W=F_CursorResults#T0 size=11,format(Point)=1,width(Point)=30,width(WS_Nom_ROI)=130,width(WS_Message_ROI)=130
		break
	endswitch

	SetVariable C_CursorMode,value=V_CursorMode
	SetVariable C_PosNeg,value=V_PosNeg
	SetVariable C_PeakStart,value=V_PeakStart
	SetVariable C_PeakEnd,value=V_PeakEnd
	SetVariable C_NbPtAvant,value=V_PntsBeforePeak
	SetVariable C_NbPtApres,value=V_PntsAfterPeak
	SetVariable C_FitDebut,value=V_FitStart
	SetVariable C_FitFin,value=V_FitEnd
	
	ControlInfo C_ChoixWavePourAfficher
	Switch(V_Value)
		case 1: //	W_Mes_Raplouf
			if (vMoyOuIndividuel==2)	//	Per ROI
				sTemp2="_ROI"
			else
				sTemp2=""
			endif
			sTemp="ksCursParams"+num2str(V_CursorMode)+sTemp2	// parameter list depends on the cursor type
			PopupMenu C_NumColPourAfficher,value= #sTemp
		break
		case 2:	//	W_Mes_Filemaker
			PopupMenu C_NumColPourAfficher,value= #"ksFileMakerParams"
		break
		case 3:	//	W_Mes_Fusion
			PopupMenu C_NumColPourAfficher,value= #"ksFusionParams"
		break
		case 4:
			PopupMenu C_NumColPourAfficher,value=#"ksZero", mode=1
		break
	EndSwitch
	
	//	Goes through the whole procedure for condition update
	MajCondCurs(sNomDF)
End

//	Fonction relai activée par les setvar
Function SetVarProcMaJCondCurs(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName
	String sNomDF

	//	on récupère le nom du datafolder sélectionné
	ControlInfo C_PopChoixCondition
	sNomDF=S_Value
	DFREF dfCondition=root:$sNomDF
	SetDataFolder dfCondition

	StrSwitch(ctrlName)
		case "C_PeakStart":
		case "C_PeakEnd":
			//	Highlight the zone in which the peak will be detected
			NVAR V_PeakStart, V_PeakEnd
			SetDrawLayer/W=F_CursorResults#G0/K ProgFront
			SetDrawEnv/W=F_CursorResults#G0 xcoord=bottom,dash=4,fillfgc= (65535,65534,49151,15000)
			DrawRect/W=F_CursorResults#G0 V_PeakStart, 0, V_PeakEnd, 1
		break
		case "C_FitDebut":
		case "C_FitFin":
			//	Highlight the zone in which the peak will be detected
			NVAR V_FitStart, V_FitEnd
			SetDrawLayer/W=F_CursorResults#G0/K ProgFront
			SetDrawEnv/W=F_CursorResults#G0 xcoord=bottom,dash=4,fillfgc= (50000,65534,60000,19661)
			DrawRect/W=F_CursorResults#G0 V_FitStart, 0, V_FitEnd, 1
		break
	EndSwitch
	PopMenuSelectCondCurs("SansEffacer",0,"")
End

Function CheckProcCondCurs(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	PopMenuSelectCondCurs("rien",0,"")
End

//	Pour renvoyer un string contenant toutes les conditions
Function/S ListeDFCond()
	NVAR vTypeFusion=root:V_TypeFusion
	String sNom=StringFromList(vTypeFusion, ksListeConditions)
	String sListe=ListeDF("root:", sNom)
	Return sListe
End

//	Importe les données correspondant à la condition affichée
Function BoutonCondition(ctrlName) : ButtonControl
	String ctrlName
	
	NVAR V_TypeFusion=root:V_TypeFusion
	variable i, j, k, vChoix, vLigne, vColonne
	string sListe, sNomDF, sNomFichier, sNomExport, sInfo, sNomFenetre, sNomDF2, sSelection, sNomWave, sNomManip

	//	Détermine le nom de la fenêtre, selon le type de fusion
	Switch(V_TypeFusion)
		case 0:	//	cursor measurement
			sNomFenetre="F_CursorResults"
		break
		case 1:	//	pulse
			sNomFenetre="F_PulseResults"
		break
		case 2:	//	profile
			sNomFenetre="F_ProfileResults"
		break
	endswitch

	ControlInfo C_PopChoixCondition		//	récupère le nom du dfCondition
	DFREF dfCondition=root:$S_Value
	Wave/SDFR=dfCondition/T WS_NomManip, WS_Message
	Wave/SDFR=dfCondition W_Accept, W_Tag
	
	StrSwitch(ctrlName)
		case "C_ImporteData":		//	to import the data from analysis files
			Prompt vChoix, "Import data for:", popup, "selected experiment;this condition;all conditions"
			DoPrompt "Import", vChoix
			if (V_Flag)
				return (0)
			endif
			Switch(vChoix)
				case 1:	//	only the experiment selected in the table
					sInfo=TableInfo(sNomFenetre+"#T0", -2)		//	to get the position of selected cell
					sSelection=StringByKey("TARGETCELL", sInfo)	//	returns the coordinates of the selected cell in the table, as a coma-separated pair
					vLigne=Str2Num(StringFromList(0, sSelection, ","))	//	get the first argument, ie row number of selected cell
					sNomFichier=WS_NomManip[vLigne][0]
					switch(V_TypeFusion)
						case 0:	//	Cursor
							sNomExport=WS_NomManip[vLigne][1]	//	name of datafolder to get
							if (StrLen(sNomExport)==0)			//	If nothing specified, use the default name
								snomExport=ksNomExport
							else
								snomExport=ksNomExport+"_"+sNomExport
							endif
							WS_Message[vLigne]=ImporteData(sNomFichier, snomExport)
							return(0)
						break
						case 1:	//	Pulse
							WS_Message[vLigne]=ImporteData(sNomFichier, "Pulse")
							return(0)
						break
						case 2:	//	Profile
							WS_Message[vLigne]=ImporteData(sNomFichier, "Profile")
							return(0)
						break
						default:
							DoAlert 0, "Not yet implemented"
							Return(0)
						break
					endswitch
				break
				case 2:	//	only this condition
					ControlInfo C_PopChoixCondition		//	récupère le nom du dfCondition
					sListe=S_Value
				break
				case 3:	//	all conditions
					sListe=ListeDFCond()
				break
			endswitch
			//	Import is performed here on sListe datafolders
			For (k=0; k<ItemsInList(sListe); k+=1)
				sNomDF=StringFromList(k, sListe)	//	specify the datafolder which needs to be imported
				DFREF dfCondition=root:$sNomDF
				Wave/T/SDFR=dfCondition WS_NomManip, WS_Message
				Wave/SDFR=dfCondition W_Accept
				Redimension/N=(DimSize(WS_NomManip, 0),-1,-1,-1) WS_Message, W_Accept
				for (j=0; (j<DimSize(WS_NomManip, 0)); j+=1)
					sNomFichier=WS_NomManip[j][0]	
					switch(V_TypeFusion)
						case 0:	
							sNomExport=WS_NomManip[j][1]	//	name of datafolder to get
							if (StrLen(sNomExport)==0)			//	If nothing specified, use the default name
								snomExport=ksNomExport
							else
								snomExport=ksNomExport+"_"+sNomExport
							endif
						break
						case 1:
							sNomExport="Pulse"	
						break
						case 2:
							sNomExport="Profile"
						break
					endswitch
					
					if ((StrLen(sNomFichier)!=0) && (W_Accept[j][0]==1))	//	Si le nom de manip est défini et si la manip est à prendre en compte
						WS_Message[j]=ImporteData(sNomFichier, sNomExport)	//	Importe les données et place le résultat de l'import (message d'erreur éventuel) dans la colonne texte n°5
					else
						WS_Message[j]="not selected; "
					endif

				endfor
				SetDataFolder root:
				Print "Finished importing "+sNomDF
			endfor
			ControlInfo C_PopChoixCondition		//	récupère le nom du dfCondition
			switch(V_TypeFusion)
				case 0:
					MajCondCurs(S_Value)
				break
				case 1:
					MaJCondPulse(S_Value)
				break
				case 2:
					
				break
			endswitch
		break
		case "C_EffaceMessages":
			sListe=ListeDFCond()
			For (k=0; k<ItemsInList(sListe); k+=1)
				sNomDF=StringFromList(k, sListe)
				DFREF dfCondition=root:$sNomDF
				Wave/T/SDFR=dfCondition WS_Message
				WS_Message=""
			endfor
		break
		case "C_ListObjects":
			sNomExport=StringFromList(V_TypeFusion, ksListeConditions)
			AfficheInit(sNomExport)
		break
		case "C_OuvreManip":	//	To open the selected experiment 
			sInfo=TableInfo(sNomFenetre+"#T0", -2)		//	to get the position of selected cell
			sSelection=StringByKey("TARGETCELL", sInfo)	//	returns the coordinates of the selected cell in the table, as a coma-separated pair
			vLigne=Str2Num(StringFromList(0, sSelection, ","))	//	get the first argument, ie row number of selected cell
			vColonne=Str2Num(StringFromList(1, sSelection, ","))	//	get the 2d argument, ie column number of selected cell
			sInfo=TableInfo(sNomFenetre+"#T0", vColonne)	//	To get the full path to wave displayed in that column
			sNomWave=StringByKey("WAVE", sInfo)		//	returns the full path to that wave
			Wave/T wsNomManip=$sNomWave
			sNomManip=wsNomManip[vLigne][0]
			print "Going to open", sNomManip	//	keeps track in the history of the last executed action
			PathInfo data
			if (V_Flag==0)	//	le chemin "data" correspond à rien
				NewPath/M="Path to analysis files:" data
				PathInfo data
			endif
			String sCmd="LOADFILE "+S_path+sNomManip[0,3]+":"+sNomManip+".pxp"
			Execute/P sCmd
		break
		case "C_ExportName":
			WS_NomManip[][1]=WS_NomManip[0][1]
		break
		case "C_Accept":
			W_Accept[]=W_Accept[0]
		break
		case "C_TagNumber":
			W_Tag[]=W_Tag[0]
		break
	endswitch
End

//_______________________________________________________________________________________
//	**********************		Pulse analysis		**************************
//

//	creates a new condition: creates a "Pulse_*" datafolder and initializes it with required objects
Function CreeCondPulse()
	String sNom	
	string sNomDF=ksNomPulse
	SetDataFolder root:
	//	asks for a name until a new one is provided
	Do
		prompt sNomDF, "Name for the datafolder "
		DoPrompt ksNomPulse, sNomDF
		if (V_Flag)
			print "cancelled by user"
			return(0)
		endif
	while ((DataFolderExists(sNomDF)) || (StrLen(sNomDF)>31))
	if (V_Flag)
		return(0)
	endif
	
	NewDataFolder $sNomDF		//	creates a datafolder of that name
	InitDataFolder("Init fusion.pxp", "f_Pulse_", sNomDF)	//	Initializes this datafolder so that it contains the required objects
End

//	Executed when activating almost any controls on the window; triggers the update of all calculations
Function PopMenuSelectCondPulse(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum
	String popStr

	string sNomDF, sTemp, sNomWave

	//	Gets the name of the selected Pulse datafolder
	ControlInfo C_PopChoixCondition
	sNomDF=S_Value
	DFREF dfCondition=root:$sNomDF
	SetDataFolder dfCondition
	InitDataFolder("Init fusion.pxp", "f_Pulse_", sNomDF)

	//	Declare remaining waves
	Wave WS_NomManip, W_Accept, W_Tag, WS_Message, W_DisplaySelection, WS_DisplaySelection

	//	Clears table content
	Do
		sTemp=TableInfo("F_PulseResults#T0",0)
		sNomWave=StringByKey("WAVE", sTemp)
		if (StrLen(sNomWave)>0)
			Wave sW=$sNomWave
			RemoveFromTable/W=F_PulseResults#T0 sW
		else
			break
		endif
	While (1)

	//	Places the current waves in the table
	AppendToTable/W=F_PulseResults#T0 WS_NomManip, W_Accept, W_Tag, WS_Message, W_DisplaySelection, WS_DisplaySelection
	ModifyTable/W=F_PulseResults#T0 size=11,format(Point)=1,width(Point)=30,width(WS_NomManip)=102
	ModifyTable/W=F_PulseResults#T0 width(W_Accept)=22,width(W_Tag)=20,width(WS_Message)=92,width(W_DisplaySelection)=62
	ModifyTable/W=F_PulseResults#T0 width(WS_DisplaySelection)=130

	//	Passes the datafolder name for updating the calculations for that pulse condition
	MaJCondPulse(sNomDF)
End

//	Relay function activated by setvar controls
Function SetVarProcMaJCondPulse(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName
	PopMenuSelectCondPulse("rien",0,"")
End

//	Relay function activated by setvar controls
Function CheckProcPulse(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	PopMenuSelectCondPulse("rien",0,"")
End

//	Main function that does all the calculation for a selected pulse condition
Function MaJCondPulse(sNomDF)
	string sNomDF	//	name of the datafolder containing the condition to process

	Variable i, j, vIndexManip=0
	String sNomGraphe, sNomTableau, sNomDFImport, sNomWave
	
	//	Go to the datafolder defining this condition
	DFREF dfPulse=root:$sNomDF
	SetDataFolder dfPulse

	//	Waves in this condition datafolder
	Wave/T WS_NomManip, WS_Message, WS_Tag, WS_DisplaySelection
	Wave W_Accept, W_Tag, W_Mes_Raplouf, W_DisplaySelection, W_IndexManip, W_Mes_Fusion, W_Mes_FileMaker
	
	//	Makes sure that all the waves have a number of row equal to the number of experiments listed in WS_NomManip
	//	One stupid things of Igor: redimension fills the new values with 0 instead of NaN: so beware of clearing these values if possible
	Redimension/N=(DimSize(WS_NomManip, 0), -1, -1, -1) WS_Message, WS_Tag, W_Accept, W_Tag, W_Mes_Raplouf, W_Mes_Fusion, W_Mes_Filemaker, W_DisplaySelection, WS_DisplaySelection, W_IndexManip
	
	//	Sets the 2d dimension of the table to contain all results
	Redimension/N=(-1,ItemsInList(ksPulseParams),-1,-1) W_Mes_Raplouf

	W_Mes_Raplouf=NaN
	W_Mes_Fusion=NaN
	W_Mes_Filemaker=NaN
	W_DisplaySelection=NaN
	WS_DisplaySelection=""
	WS_Message=""

	//	Begining of the loop which processes each experiment in the list
	For (i=0; (i<DimSize(WS_NomManip,0)); i+=1)

		//	The name of experiment is blank or that line is rejected: jump to end of loop
		if ((StrLen(WS_NomManip[i][0])==0) || (W_Accept[i]==0))
			W_IndexManip[i]=NaN
			Continue
		endif
		
		//	Index de la manip
		W_IndexManip[i]=vIndexManip		
		
		//	imported datafolder containing the data of this experiment
		sNomDFImport="root:"+ksNomDataFolderImport+":'"+WS_NomManip[i][0]+"_"+"Pulse'"
		DFREF dfImport = $sNomDFImport
		if (DataFolderRefStatus(dfImport)==0)
			WS_Message[i]+="No import datafolder; "
			Continue	//	jumps to end of loop
		endif
		
		//	Connects the local name of result wave to the table containing the correct analysis result
		sNomWave="Pulse_"+WS_NomManip[i][1]
		Wave/SDFR=dfImport/Z wAllResults=$sNomWave
		if (WaveExists(wAllResults))
			W_Mes_Raplouf[i][0, (DimSize(wAllResults, 1)-1)]=wAllResults[ W_Tag[i] ][ q ]
			vIndexManip+=1	//	Increments the index
		else
			WS_Message[i]+="no analysis wave in the import folder; "
		endif
			
		//	transfers the tag name from the analysis file to here
//		Wave/SDFR=dfImport/T WS_TagName
//		WS_Tag[i]=WS_TagName[W_Tag[i]]

		//	Declares the waves containing the result of the analysis for that precise experiment
//		Wave/SDFR=dfImport W_mFrequency, W_mMaxPeakb, W_mMinPeakb, W_mAmpltd
//		Wave/SDFR=dfImport W_mTimetoPeak, W_mRisetime, W_mTimetoAntiPeak, W_mDecaytime
//		Wave/SDFR=dfImport W_mEventDuration, W_mTAP50R, W_mDecayslope, W_mRiseslope, W_Average, W_RMSSD
//		NVAR/SDFR=dfImport V_R0, V_Smoothing
		
		//	j: tag # to be processed for that experiment
//		j=W_Tag[i]
		
//	Do something here		!!!!!!!!!!!!	
		//	Checks if the relevant tag was calculated
//		if (DimSize(W_mFrequency, 0)<j+1)
//			WS_Message[i]+="this tag # was not calculated; "
//			Continue	//	jumps to end of loop
//		endif

		//	Transfers the informations of interest into the local _All wave
//	"Frequency;MaxPeakb;MinPeakb;Ampltd;TimetoPeak;Risetime;TimetoAntiPeak;Decaytime;EventDuration;TAP50R;Decayslope;Riseslope;Average"
//		W_Mes_Raplouf[i][0]=W_mFrequency[j]
//		W_Mes_Raplouf[i][1]=W_mMaxPeakb[j]
//		W_Mes_Raplouf[i][2]=W_mMinPeakb[j]
//		W_Mes_Raplouf[i][3]=W_mAmpltd[j]
//		W_Mes_Raplouf[i][4]=W_mTimetoPeak[j]
//		W_Mes_Raplouf[i][5]=W_mRisetime[j]
//		W_Mes_Raplouf[i][6]=W_mTimetoAntiPeak[j]
//		W_Mes_Raplouf[i][7]=W_mDecaytime[j]
//		W_Mes_Raplouf[i][8]=W_mEventDuration[j]
//		W_Mes_Raplouf[i][9]=W_mTAP50R[j]
//		W_Mes_Raplouf[i][10]=W_mDecayslope[j]
//		W_Mes_Raplouf[i][11]=W_mRiseslope[j]
//		W_Mes_Raplouf[i][12]=W_Average[j]
//		W_Mes_Raplouf[i][13]=V_R0
//		W_Mes_Raplouf[i][14]=V_Smoothing
//		W_Mes_Raplouf[i][15]=W_RMSSD[j]
//		//	Increments the index
//		vIndexManip+=1
	Endfor

	//	Determines which data to display
	ControlInfo/W=F_PulseResults C_ChoiceDataToDisplay
	W_DisplaySelection=W_Mes_Raplouf[p][V_Value-1]
	DoUpdate	
End

Window F_PulseResults() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /K=1 /W=(44,45,946,400) as "F_PulseResults"
	ShowTools/A
	SetDrawLayer UserBack
	SetDrawEnv arrow= 2
	DrawLine 381,310,381,333
	SetDrawEnv arrow= 1
	DrawLine 517,334,534,310
	SetDrawEnv arrow= 1
	DrawLine 577,333,560,311
	PopupMenu C_PopChoixCondition,pos={8.00,4.00},size={130.00,23.00},proc=PopMenuSelectCondPulse,title="Pulse condition:"
	PopupMenu C_PopChoixCondition,mode=1,popvalue="_None_",value= #"ListeDFCond()"
	Button C_ImporteData,pos={16.00,181.00},size={110.00,20.00},proc=BoutonCondition,title="Import data"
	Button C_ImporteData,help={"Import the data corresponding to this condition"}
	Button C_ImporteData,fSize=11
	Button C_OuvreManip,pos={16.00,201.00},size={110.00,20.00},proc=BoutonCondition,title="Open experiment"
	Button C_OuvreManip,help={"Open the selected experiment"},fSize=11
	Button C_ListObjects,pos={16,230},size={110,20},proc=BoutonCondition,title="List of objects"
	Button C_ListObjects,help={"Show the list of all objects used in a condition"},fSize=11,fstyle=0
	Button C_Aide_Conditions,pos={16,280},size={110.00,20.00},proc=BoutonAide,title="Help"
	Button C_Aide_Conditions,help={"Import the data corresponding to this condition"},fSize=11,fStyle=1
	Button C_ExportName,pos={364.00,337.00},size={38.00,16.00},proc=BoutonCondition,title="Same"
	Button C_ExportName,fSize=11
	Button C_Accept,pos={496.00,337.00},size={38.00,16.00},proc=BoutonCondition,title="Same"
	Button C_Accept,fSize=11
	Button C_TagNumber,pos={551.00,337.00},size={38.00,16.00},proc=BoutonCondition,title="Same"
	Button C_TagNumber,fSize=11
	PopupMenu C_ChoiceDataToDisplay,pos={10.00,43.00},size={83.00,23.00},proc=PopMenuSelectCondPulse
	PopupMenu C_ChoiceDataToDisplay,mode=1,popvalue="Frequency",value= #"ksPulseParams"
	Edit/W=(189,19,888,308)/HOST=# 
	ModifyTable format=1
	RenameWindow #,T0
	SetActiveSubwindow ##
EndMacro



//**************************************		End of Pulse section		************************************
//________________________________________________________________________________________________________


//	- StatsKDE pour calculer un histogramme lissé
//Function Stats()
//	SetDataFolder root:Densities
//	Wave W_Striatum, W_Striatum_Hist, W_Striatum_KDE, W_Cortex, W_Cortex_Hist, W_Cortex_KDE
//	StatsKDE/BWM=1/S={-100,1,200}/Q/DEST=W_Striatum_KDE W_Striatum
//	Histogram/B=5 W_Striatum,W_Striatum_Hist
//	StatsKDE/BWM=1/S={-100,1,200}/Q/DEST=W_Cortex_KDE W_Cortex
//	Histogram/B=5 W_Cortex, W_Cortex_Hist
//end

//	Managing global variables
Window P_Global_Curs() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel/K=1 /W=(2140,107,2328,365) as "Global variables"
	SetDrawLayer UserBack
	SetDrawEnv fsize= 10
	DrawText 14,242,"Time in"
	SetVariable C_ErrorInterval_CI,pos={17.00,53.00},size={150.00,14.00}
	SetVariable C_ErrorInterval_CI,title="Error for conf. int. (%)"
	SetVariable C_ErrorInterval_CI,limits={0,100,5},value=root:Global:V_ErrorInterval_CI
	SetVariable C_Alpha,pos={17.00,72.00},size={70.00,14.00},title="Alpha"
	SetVariable C_Alpha,help={"Error level"}
	SetVariable C_Alpha,limits={0.0001,0.05,0},value=root:Global:V_AlphaStats
	SetVariable C_MinIntensity,pos={21.00,127.00},size={60.00,14.00},title="Min"
	SetVariable C_MinIntensity,limits={0,50,1},value=root:Global:V_IMin
	SetVariable C_MaxIntensity,pos={106.00,127.00},size={60.00,14.00},title="Max"
	SetVariable C_MaxIntensity,limits={0,50,1},value=root:Global:V_IMax
	GroupBox C_Stats,pos={10.00,11.00},size={168.00,90.00},title="Statistics"
	GroupBox C_Intensity,pos={10.00,106.00},size={168.00,47.00}
	GroupBox C_Intensity,title="Color = f(something)"
	GroupBox C_Concentration,pos={10.00,156.00},size={168.00,66.00}
	GroupBox C_Concentration,title="Ratio -> concentration"
	SetVariable C_Rmin,pos={17.00,176.00},size={70.00,14.00},title="Rmin"
	SetVariable C_Rmin,limits={-5,5,0},value=root:Global:V_Rmin
	SetVariable C_Rmax,pos={98.00,176.00},size={70.00,14.00},title="Rmax"
	SetVariable C_Rmax,limits={0,10,0},value=root:Global:V_Rmax
	SetVariable C_Rate,pos={98.00,197.00},size={70.00,14.00},title="Rate"
	SetVariable C_Rate,limits={0,5,0},value=root:Global:V_rate
	SetVariable C_Xhalf,pos={17.00,197.00},size={70.00,16.00},title="EC\\B50"
	SetVariable C_Xhalf,limits={0,inf,0},value=root:Global:V_xhalf
	SetVariable C_ErrorInterval_SD,pos={96.00,72.00},size={70.00,14.00}
	SetVariable C_ErrorInterval_SD,title="Nb of SD"
	SetVariable C_ErrorInterval_SD,limits={0,10,0.5},value=root:Global:V_ErrorInterval_SD
EndMacro

Function PopMenuGlobal_Curs(ctrlName,popNum,popStr) : PopupMenuControl
	String ctrlName
	Variable popNum
	String popStr
	NVAR V_ErrorType=root:Global:V_ErrorType
	V_ErrorType=popNum
End

//	Copied from CheckActivePanneau, but simplified. CheckActivePanneau couldn't be used because it requires access to dfROI, which is not defined in Fusion.
Function CheckActivePanneauFusion(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	string sNomFenetre="P_Global_Curs"
	string sNomFenetrePrincipale=WinName(0, 1)		//	returns the name of the front window, which called function execution

	DoWindow/F $sNomFenetre		//	détecte si la fenêtre existe, et si oui, la met au premier plan
	Switch(checked)
		case 0:	//	La fenêtre ne doit pas être présente
			if (V_Flag==1)
				SetWindow $sNomFenetre, hide=1
			endif
		break
		case 1:	//	La fenêtre doit être présente et au premier plan
			if (V_Flag==0)	//	la fenêtre n'existe pas
				Execute "P_Global_Curs()"
				CheckProcTempsEnMinutes("",0)		//	updates the radio buttons to match V_Temps_en_Minutes value
			else
				SetWindow $sNomFenetre, hide=0
			endif
//			AutoPositionWindow/M=0/R=$sNomFenetrePrincipale $sNomFenetre
		break
	endswitch
End

//Function RenommerCondition()
//	variable i
//	setdatafolder root:
//	String sListe=DatafolderList("Curs_*", ";"), sNomInit, sNomFinal, sFragmentInit="6OHDA", sFragmentFinal="Lstr"
//	Prompt sFragmentInit, "String to search for replace:"
//	Prompt sFragmentFinal, "Replace with this string: "
//	DoPrompt "Replace strings in folder names", sFragmentInit, sFragmentFinal
//	if (V_Flag==1)
//		print "cancelled by user"
//		return(0)
//	endif
//	for (i=0; (i<ItemsInList(sListe)); i+=1)
//		sNomInit=StringFromList(i, sListe)
//		sNomFinal=ReplaceString(sFragmentInit, sNomInit, sFragmentFinal)
//		RenameDataFolder root:$sNomInit, $sNomFinal
//	endfor
//End
