#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=1		// Use modern global access method.

// *** Copyright ***
// © 2023 CNRS Shared by Pierre VINCENT, under the MIT License.
//	Contact: pierre.vincent@cnrs.fr; IGF, 141 rue de la Cardonille, 34094 Montpellier cedex 5, France.

//	Attention: lors de la recréation du macro de fenêtre, il y a des objets qui utilisent des variables ou strings rangés dans le df analyse.
//	Ce df n'existe pas forcément sous le même nom au moment de la création du panneau. => Après mise à jour du code de ce panneau, 
//	changer dans ce code les occurence de ces éléments (7) définis par root:Analyse?? et mettre NaN à la place.
//	Changer PopupMenu C_DF_Analyse,mode=2,popvalue="Analyse_YYY" en ="Undefined"

Window P_Controle() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /K=2 /W=(1976,45,2556,785) as "Control panel"
	ModifyPanel fixedSize=1
	SetDrawLayer ProgBack
	SetDrawEnv linefgc= (3,52428,1),fillpat= 0
	SetDrawEnv save
	SetDrawLayer UserBack
	SetDrawEnv fsize= 9
	DrawText 22,352,"Position (pixels)"
	SetDrawEnv linefgc= (30583,30583,30583)
	DrawLine 408,126,555,126
	DrawText 25,110,"A"
	DrawText 26,132,"B"
	DrawLine 23,146,62,146
	DrawLine 131,146,170,146
	SetDrawEnv fsize= 10,fstyle= 2
	DrawText 18,87,"fluo"
	SetDrawEnv fsize= 10,fstyle= 2
	DrawText 19,161,"ratio"
	SetDrawEnv arrow= 2,arrowlen= 5
	DrawLine 91,191,108,191
	DrawLine 107,171,107,191
	SetDrawEnv arrow= 2,arrowlen= 5
	DrawLine 91,170,108,170
	SetDrawEnv arrow= 2,arrowlen= 5
	DrawLine 91,233,108,233
	DrawLine 107,213,107,233
	SetDrawEnv arrow= 2,arrowlen= 5
	DrawLine 91,212,108,212
	SetDrawEnv fname= "default",fsize= 9
	DrawText 420,596,"Look for more\ndata points"
	SetDrawEnv fsize= 9
	DrawText 209,407,"Graph\rmargins:"
	SetDrawEnv fname= "Arial",fsize= 9
	DrawText 206,475,"Show traces as"
	SetDrawEnv fsize= 9,textyjust= 1
	DrawText 22,326,"Size:"
	SetDrawEnv fsize= 9
	DrawText 204,380,"\\JRShow tag \rlabels:"
	GroupBox C_GroupeRatio,pos={386.00,255.00},size={187.00,216.00},title="Ratio"
	GroupBox C_GroupeRatio,labelBack=(65535,57467,60967)
	GroupBox C_Intensite,pos={390.00,338.00},size={131.00,45.00},title="Intensity"
	GroupBox C_Intensite,help={"Which data channel provides intensity information"}
	GroupBox C_QuantifRatio,pos={391.00,384.00},size={176.00,80.00}
	GroupBox C_QuantifRatio,title="Ratio quantification"
	GroupBox C_QuantifRatio,help={"How the ratio value is estimated over a region of interest"}
	GroupBox C_groupMesures,pos={199.00,57.00},size={176.00,357.00}
	GroupBox C_groupMesures,title="ROI display",labelBack=(65535,65535,65535)
	GroupBox C_groupTraitementAuto,pos={386.00,57.00},size={187.00,196.00}
	GroupBox C_groupTraitementAuto,title="A&B corrections"
	GroupBox C_groupTraitementAuto,help={"Corrects the raw images"}
	GroupBox C_groupTraitementAuto,labelBack=(57346,65535,49151)
	GroupBox C_GroupCorrectionAuto,pos={394.00,75.00},size={170.00,98.00}
	GroupBox C_GroupCorrectionAuto,title="Movements",frame=0
	GroupBox C_GroupeFichiers,pos={14.00,502.00},size={176.00,170.00},title="Time"
	GroupBox C_GroupeFichiers,help={"Manages time"},labelBack=(65535,54611,49151)
	SetVariable C_T0,pos={20.00,554.00},size={110.00,14.00}
	SetVariable C_T0,title="Initial time T0 (s)",help={"To shift time zero"},fSize=9
	SetVariable C_T0,limits={-inf,inf,0},value=root:Ratio:V_T0
	GroupBox C_GroupeFichiers1,pos={386.00,637.00},size={187.00,95.00}
	GroupBox C_GroupeFichiers1,title="Export",labelBack=(53804,65535,53642)
	GroupBox C_GroupeTraitementAuto,pos={386.00,474.00},size={187.00,164.00}
	GroupBox C_GroupeTraitementAuto,title="Processing data"
	GroupBox C_GroupeTraitementAuto,labelBack=(56797,56797,56797)
	GroupBox C_GroupeAffichage,pos={14.00,57.00},size={176.00,216.00}
	GroupBox C_GroupeAffichage,title="Display"
	GroupBox C_GroupeAffichage,help={"Only affects the display of the images; no effect on the measurement."}
	GroupBox C_GroupeAffichage,labelBack=(49151,65535,65535)
	GroupBox C_groupSuppressionImages,pos={14.00,669.00},size={176.00,64.00}
	GroupBox C_groupSuppressionImages,title="Image suppression"
	GroupBox C_groupSuppressionImages,help={"Suppresses datapoint for the analysis; no effect on the original datafiles"}
	GroupBox C_groupSuppressionImages,labelBack=(65535,23484,25766)
	GroupBox C_GroupeCalibration,pos={14.00,277.00},size={176.00,159.00}
	GroupBox C_GroupeCalibration,title="Calibration square"
	GroupBox C_GroupeCalibration,labelBack=(51664,44236,58982)
	Slider C_GlissierePositionCourante,pos={13.00,5.00},size={431.00,44.00},proc=GlissiereAffichage
	Slider C_GlissierePositionCourante,limits={0,65,1},variable=root:Ratio:V_NumCoucheCourante,vert=0
	SetVariable C_NumTrame,pos={496.00,9.00},size={75.00,17.00},bodyWidth=60,proc=SetNum
	SetVariable C_NumTrame,title="n°",fSize=12
	SetVariable C_NumTrame,limits={0,65,1},value=root:Ratio:V_NumCoucheCourante
	SetVariable C_NumROI,pos={210.00,103.00},size={79.00,16.00},bodyWidth=46,proc=SetVarNumRoi
	SetVariable C_NumROI,title="ROI #",help={"Current ROI"},fSize=11
	SetVariable C_NumROI,limits={1,4,1},value=root:Analyse_0:V_NumROI
	SetVariable C_IMin,pos={25.00,164.00},size={63.00,16.00},bodyWidth=40,proc=MaJ_CasesACocher
	SetVariable C_IMin,title="IMin",help={"Minimal intensity level; below is black"}
	SetVariable C_IMin,fSize=10,limits={-inf,inf,0},value=root:Ratio:V_IMin
	SetVariable C_RMin,pos={21.00,206.00},size={67.00,16.00},bodyWidth=40,proc=MaJ_CasesACocher
	SetVariable C_RMin,title="RMin",help={"Minimal ratio displayed in blue"}
	SetVariable C_RMin,fSize=10,limits={0,inf,0},value=root:Ratio:V_RMin
	SetVariable C_IMax,pos={22.00,185.00},size={66.00,16.00},bodyWidth=40,proc=MaJ_CasesACocher
	SetVariable C_IMax,title="IMax"
	SetVariable C_IMax,help={"Maximal intensity; above is brilliant color"},fSize=10
	SetVariable C_IMax,limits={-inf,inf,0},value=root:Ratio:V_IMax
	SetVariable C_RMax,pos={18.00,227.00},size={70.00,16.00},bodyWidth=40,proc=MaJ_CasesACocher
	SetVariable C_RMax,title="RMax",help={"Maximal ratio displayed in red"},fSize=10
	SetVariable C_RMax,limits={0,inf,0},value=root:Ratio:V_RMax
	SetVariable C_CorrGamma,pos={111.00,173.00},size={70.00,16.00},bodyWidth=30,proc=MaJ_CasesACocher
	SetVariable C_CorrGamma,title="Gamma"
	SetVariable C_CorrGamma,help={"Non-linear correction of the intensity (gamma function); to show or hide dim objects in the image. 1 means no correction."}
	SetVariable C_CorrGamma,fSize=10,limits={0,4,0},value=root:Ratio:V_CorrGamma
	SetVariable C_R0,pos={398.00,317.00},size={57.00,16.00},bodyWidth=40,proc=MaJ_CasesACocher
	SetVariable C_R0,title="R0"
	SetVariable C_R0,help={"Constant multiplying the ratio; to position the ratio value nicely close to 1"}
	SetVariable C_R0,fSize=10,limits={0,20,0},value=root:Ratio:V_R0
	GroupBox C_GroupeZoom,pos={14.00,438.00},size={176.00,60.00}
	GroupBox C_GroupeZoom,title="Size of image window"
	GroupBox C_GroupeZoom,help={"Only affects the display and export of images; no effect on the measurements."}
	GroupBox C_GroupeZoom,labelBack=(61048,65535,56186)
	SetVariable C_Tag,pos={299.00,102.00},size={54.00,16.00},bodyWidth=35,proc=SetVarTag
	SetVariable C_Tag,title="tag"
	SetVariable C_Tag,help={"Affects the current ROI to the selected group; -1 means the ROI is considered background"}
	SetVariable C_Tag,fSize=11,limits={-1,3,1},value=root:Analyse_0:W_Tag[1]
	Button C_SupprimePoint,pos={25.00,690.00},size={70.00,30.00},proc=BoutonSupprime
	Button C_SupprimePoint,title="Suppress\rthis image"
	Button C_SupprimePoint,help={"Suppresses this datapoint from the analysis; updates traces accordingly"}
	Button C_SupprimePoint,fSize=11,fStyle=1,fColor=(65535,65535,65535)
	CheckBox C_CheckBoxDeplacement,pos={401.00,90.00},size={128.00,16.00},proc=CheckProc
	CheckBox C_CheckBoxDeplacement,title="Autocorrect movement"
	CheckBox C_CheckBoxDeplacement,help={"Automatically corrects for the movement of the whole field"}
	CheckBox C_CheckBoxDeplacement,fSize=11,value=0
	CheckBox C_CheckBoxDecalage,pos={401.00,134.00},size={131.00,16.00},disable=2,proc=CheckProc
	CheckBox C_CheckBoxDecalage,title="Autocorrect registration"
	CheckBox C_CheckBoxDecalage,help={"Automatically corrects for mis-registration between A and B channels"}
	CheckBox C_CheckBoxDecalage,fSize=11,value=0
	SetVariable C_SetResolution,pos={22.00,297.00},size={129.00,14.00},bodyWidth=40
	SetVariable C_SetResolution,title="Resolution (µm/pixel)"
	SetVariable C_SetResolution,help={"Size of a pixel (in microns)"}
	SetVariable C_SetResolution,limits={0,10,0},value=root:Ratio:V_Resolution
	SetVariable C_SetTailleCarre,pos={48.00,318.00},size={42.00,14.00},bodyWidth=25
	SetVariable C_SetTailleCarre,title="µm"
	SetVariable C_SetTailleCarre,help={"Size of the calibration square (in microns)"}
	SetVariable C_SetTailleCarre,limits={0,500,0},value=root:Ratio:V_DimCarre
	SetVariable C_DimCarreDix,pos={91.00,318.00},size={57.00,14.00},bodyWidth=30,disable=2
	SetVariable C_DimCarreDix,title="pixels"
	SetVariable C_DimCarreDix,limits={100,0,0},value=root:Ratio:V_DimCarrePix,noedit=1
	SetVariable C_PosCarreXPix,pos={94.00,339.00},size={40.00,14.00},bodyWidth=30
	SetVariable C_PosCarreXPix,title="X"
	SetVariable C_PosCarreXPix,limits={0,4000,0},value=root:Ratio:V_PosCarreXPix
	SetVariable C_PosCarreYPix,pos={140.00,339.00},size={40.00,14.00},bodyWidth=30
	SetVariable C_PosCarreYPix,title="Y"
	SetVariable C_PosCarreYPix,limits={0,4000,0},value=root:Ratio:V_PosCarreYPix
	Button C_SauveSerie,pos={478.00,678.00},size={75.00,20.00},proc=BoutonSauveImage
	Button C_SauveSerie,title="-> series"
	Button C_SauveSerie,help={"Saves a series of images as image files in the cache folder"}
	Button C_SauveSerie,fSize=11
	Button C_CouleursVariees,pos={211.00,152.00},size={64.00,23.00},proc=BoutonCouleurs
	Button C_CouleursVariees,title="varied colors"
	Button C_CouleursVariees,help={"Colorizes all ROI with varied colors"}
	Button C_CouleursVariees,labelBack=(0,0,65535),fSize=9
	Button C_CouleursVariees,fColor=(43690,43690,43690)
	Button C_Debut,pos={455.00,28.00},size={30.00,20.00},proc=BoutonDebutFin
	Button C_Debut,title="I\\F'Symbol'⇐"
	Button C_Debut,help={"Jump to previous point of view or first datapoint"}
	Button C_Debut,fSize=12,fStyle=1
	Button C_Fin,pos={455.00,6.00},size={30.00,20.00},proc=BoutonDebutFin
	Button C_Fin,title="\\F'Symbol'⇒\\F'Lucida Grande'I"
	Button C_Fin,help={"Jump to next point of view or last datapoint"},fSize=12
	Button C_Fin,fStyle=1
	Button C_CouleurROI,pos={214.00,181.00},size={50.00,20.00},proc=BoutonCouleurs
	Button C_CouleurROI,title="Color",help={"Change the color of the current ROI"}
	Button C_CouleurROI,fSize=10,fColor=(39321,1,31457)
	CheckBox C_AfficheROI,pos={207.00,207.00},size={69.00,16.00},proc=CheckAfficheROI
	CheckBox C_AfficheROI,title="Display ROIs"
	CheckBox C_AfficheROI,help={"Displays the ROI outlines on the image"},value=1
	SetVariable C_SetTaillePolice,pos={22.00,374.00},size={65.00,14.00},bodyWidth=25,proc=SetVarLegende
	SetVariable C_SetTaillePolice,title="Font size"
	SetVariable C_SetTaillePolice,help={"Font size for labels around the calibration square"}
	SetVariable C_SetTaillePolice,limits={1,80,0},value=root:Ratio:V_TaillePoliceCarre
	CheckBox C_CheckRatioModule,pos={399.00,402.00},size={89.00,22.00},proc=CheckModeCalcul
	CheckBox C_CheckRatioModule,title="Intensity-weighted\rratio average"
	CheckBox C_CheckRatioModule,help={"Calculates the ratio for each pixel; the measurement on the ROI is the average\rof the ratio values weighted by the intensity, pixel by pixel"}
	CheckBox C_CheckRatioModule,value=1,mode=1
	PopupMenu C_Affichage,pos={72.00,136.00},size={54.00,20.00},proc=PopMenuAffichage
	PopupMenu C_Affichage,help={"Select channel A, B, (other), or intensity-modulated ratio."}
	PopupMenu C_Affichage,fSize=9,mode=1,popvalue="RM",value=#"\"RM;A;B\""
	CheckBox C_CheckRatioDesMoyennes,pos={399.00,431.00},size={71.00,22.00},proc=CheckModeCalcul
	CheckBox C_CheckRatioDesMoyennes,title="Ratio of\rintensity avgs"
	CheckBox C_CheckRatioDesMoyennes,help={"Each ROI is averaged on A and B channels; the ratio measurement is the ratio of these two intensity averages;\requivalent to assuming that the whole ROI is a single giant pixel"}
	CheckBox C_CheckRatioDesMoyennes,value=0,mode=1
	Button C_SupprimeFichierTemp,pos={105.00,690.00},size={70.00,30.00},proc=BoutonSupprimeTemp
	Button C_SupprimeFichierTemp,title="Suppresses\rtemp files"
	Button C_SupprimeFichierTemp,help={"Clears cached files -> forces re-reading the original datafile; for chasing bugs"}
	Button C_SupprimeFichierTemp,fSize=11,fStyle=2,fColor=(65535,65535,65535)
	Button C_BoutonMoyenne1,pos={33.00,638.00},size={30.00,20.00},proc=BoutonMoyenneTemporelle
	Button C_BoutonMoyenne1,title="\\W623"
	Button C_BoutonMoyenne1,help={"Averages the current data point with its neighbours"}
	Button C_BoutonMoyenne1,fSize=10,fColor=(65535,54611,49151)
	PopupMenu C_ChangeTemps,pos={20.00,593.00},size={124.00,20.00},proc=PopMenuTypeAxeX
	PopupMenu C_ChangeTemps,title="\\Z09X axis:"
	PopupMenu C_ChangeTemps,help={"Horizontal axis can represent time in min, sec or image number"}
	PopupMenu C_ChangeTemps,fSize=9
	PopupMenu C_ChangeTemps,mode=1,popvalue="time (min)",value=#"\"time (min);time (sec);image #\""
	Button C_SauveVignetteChamp,pos={404.00,673.00},size={45.00,20.00},proc=BoutonSauveVignette
	Button C_SauveVignetteChamp,title="Image"
	Button C_SauveVignetteChamp,help={"Save this image as jpeg in the database folder"}
	Button C_SauveVignetteChamp,fSize=11
	CheckBox C_CheckIMoyA,pos={454.00,357.00},size={23.00,15.00},proc=CheckModeCalcul
	CheckBox C_CheckIMoyA,title="A"
	CheckBox C_CheckIMoyA,help={"The intensity image is taken as channel A"}
	CheckBox C_CheckIMoyA,value=0,mode=1
	CheckBox C_CheckIMoyAB,pos={397.00,357.00},size={48.00,15.00},proc=CheckModeCalcul
	CheckBox C_CheckIMoyAB,title="(A+B)/2"
	CheckBox C_CheckIMoyAB,help={"The intensity image is calculated as the average of A and B channels"}
	CheckBox C_CheckIMoyAB,value=1,mode=1
	CheckBox C_CheckIMoyB,pos={483.00,357.00},size={23.00,15.00},proc=CheckModeCalcul
	CheckBox C_CheckIMoyB,title="B"
	CheckBox C_CheckIMoyB,help={"The intensity image is taken as channel A"}
	CheckBox C_CheckIMoyB,value=0,mode=1
	SetVariable C_IMinA,pos={47.00,94.00},size={63.00,16.00},bodyWidth=40,proc=SetIntensiteAB
	SetVariable C_IMinA,title="IMin"
	SetVariable C_IMinA,help={"Minimum image intensity for scaling channel A"}
	SetVariable C_IMinA,fSize=10,limits={-inf,inf,0},value=root:Ratio:V_IMinA
	CheckBox C_AfficheMoy,pos={210.00,484.00},size={104.00,16.00},proc=CheckAfficheMoy
	CheckBox C_AfficheMoy,title="Display average trace",value=0
	SetVariable C_EpaisseurTrait,pos={22.00,356.00},size={91.00,14.00},bodyWidth=30
	SetVariable C_EpaisseurTrait,title="Line thickness"
	SetVariable C_EpaisseurTrait,help={"Line thickness around the calibration square"}
	SetVariable C_EpaisseurTrait,limits={0,20,0},value=root:Ratio:V_Trait
	SetVariable C_NbPlansLissage,pos={403.00,176.00},size={164.00,14.00},bodyWidth=40,proc=MaJ_CasesACocher
	SetVariable C_NbPlansLissage,title="Z stack average; nb of planes:"
	SetVariable C_NbPlansLissage,help={"Total number of planes inculded in the average (no average if 1)"}
	SetVariable C_NbPlansLissage,fSize=9,limits={1,inf,2},value=root:Ratio:V_Lissage
	SetVariable C_IMinB,pos={47.00,117.00},size={63.00,16.00},bodyWidth=40,proc=SetIntensiteAB
	SetVariable C_IMinB,title="IMin"
	SetVariable C_IMinB,help={"Minimum image intensity for scaling channel B"}
	SetVariable C_IMinB,fSize=10,limits={-inf,inf,0},value=root:Ratio:V_IMinB
	SetVariable C_IMaxB,pos={115.00,117.00},size={66.00,16.00},bodyWidth=40,proc=SetIntensiteAB
	SetVariable C_IMaxB,title="IMax"
	SetVariable C_IMaxB,help={"Maximal image intensity for scaling channel B"}
	SetVariable C_IMaxB,fSize=10,limits={-inf,inf,0},value=root:Ratio:V_IMaxB
	Button C_EffaceFonds,pos={530.00,228.00},size={30.00,16.00},proc=BoutonEffaceFonds
	Button C_EffaceFonds,title="clear"
	Button C_EffaceFonds,help={"Clears all backgrounds and sets corresponding ROI tag back to 0"}
	Button C_EffaceFonds,fSize=9
	SetVariable C_IMaxA,pos={115.00,94.00},size={66.00,16.00},bodyWidth=40,proc=SetIntensiteAB
	SetVariable C_IMaxA,title="IMax"
	SetVariable C_IMaxA,help={"Maximal image intensity for scaling channel A"}
	SetVariable C_IMaxA,fSize=10,limits={-inf,inf,0},value=root:Ratio:V_IMaxA
	CheckBox C_AutoZoomROI,pos={210.00,244.00},size={57.00,16.00},proc=CheckZoom
	CheckBox C_AutoZoomROI,title="Autozoom",value=0
	CheckBox C_Groupe0,pos={206.00,286.00},size={15.00,16.00},proc=CheckAfficheGroupe
	CheckBox C_Groupe0,title="",value=1
	CheckBox C_Groupe1,pos={206.00,302.00},size={15.00,16.00},proc=CheckAfficheGroupe
	CheckBox C_Groupe1,title="",value=1
	CheckBox C_Groupe2,pos={206.00,318.00},size={15.00,16.00},proc=CheckAfficheGroupe
	CheckBox C_Groupe2,title="",value=0
	CheckBox C_Groupe3,pos={206.00,335.00},size={15.00,16.00},proc=CheckAfficheGroupe
	CheckBox C_Groupe3,title="",value=0
	CheckBox C_AffichePosition,pos={210.00,439.00},size={87.00,16.00},proc=CheckAffichePosition
	CheckBox C_AffichePosition,title="Show time cursor",value=0
	ValDisplay C_TempsCourant,pos={20.00,537.00},size={110.00,13.00},disable=2
	ValDisplay C_TempsCourant,title="Raw time (s)"
	ValDisplay C_TempsCourant,help={"Time recorded with the datafile"}
	ValDisplay C_TempsCourant,limits={0,0,0},barmisc={0,60}
	ValDisplay C_TempsCourant,value=#"root:Ratio:W_Temps[root:Ratio:V_NumCoucheCourante]"
	ValDisplay C_TempsCourantNet,pos={20.00,574.00},size={115.00,13.00},disable=2
	ValDisplay C_TempsCourantNet,title="Temps corrigé (min)"
	ValDisplay C_TempsCourantNet,help={"Time for the current datapoint, recalculated for different T0, units etc..."}
	ValDisplay C_TempsCourantNet,limits={0,0,0},barmisc={0,60}
	ValDisplay C_TempsCourantNet,value=#"root:Ratio:W_Temps_Min[root:Ratio:V_NumCoucheCourante]"
	SetVariable C_SeuilRatio,pos={471.00,317.00},size={89.00,16.00},bodyWidth=20
	SetVariable C_SeuilRatio,title="Excl. threshold"
	SetVariable C_SeuilRatio,help={"Excludes from measurements pixels which have a ratio value above R0*N, or below R0/N;\rprevents aberrent values like +/- infinity, or negative values, to be taken in the calculations"}
	SetVariable C_SeuilRatio,fSize=10,limits={0,20,0},value=root:Ratio:V_SeuilRatio
	CheckBox C_AfficheEvt,pos={22.00,250.00},size={61.00,16.00},title="Display evt"
	CheckBox C_AfficheEvt,help={"Display the event text over the image"},value=0
	SetVariable C_PosXEvt,pos={95.00,250.00},size={41.00,16.00},bodyWidth=32
	SetVariable C_PosXEvt,title="x",help={"Position of the event text."},fSize=10
	SetVariable C_PosXEvt,limits={-inf,inf,0},value=_NUM:20
	SetVariable C_PosYEvt,pos={140.00,250.00},size={41.00,16.00},bodyWidth=32
	SetVariable C_PosYEvt,title="y",help={"Position of the event text"},fSize=10
	SetVariable C_PosYEvt,limits={-inf,inf,0},value=_NUM:20
	CheckBox C_PMI,pos={524.00,193.00},size={39.00,16.00},proc=CheckProjection
	CheckBox C_PMI,title="M.I.P."
	CheckBox C_PMI,help={"Maximum Intensity Projection: layer 0 contains the brightest pixel of the stack"}
	CheckBox C_PMI,value=0,side=1
	CheckBox C_Active_P_TableauROI,pos={282.00,244.00},size={80.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_TableauROI,title="Show ROI table"
	CheckBox C_Active_P_TableauROI,help={"Displays a table for all ROIs, with intensity measure, tag #, color specs, line thickness..."}
	CheckBox C_Active_P_TableauROI,value=0
	CheckBox C_ROI_Points,pos={272.00,461.00},size={41.00,16.00},proc=CheckROIMarqueurs
	CheckBox C_ROI_Points,title="points"
	CheckBox C_ROI_Points,help={"Show measurements as a dot for each time-point"}
	CheckBox C_ROI_Points,value=0
	SetVariable C_Magnification,pos={106.00,456.00},size={75.00,16.00},bodyWidth=44,proc=SetVarZoom
	SetVariable C_Magnification,title="zoom"
	SetVariable C_Magnification,help={"Just a zoom on the image; no effect on image resolution."}
	SetVariable C_Magnification,fSize=11
	SetVariable C_Magnification,limits={0.25,8,0.25},value=root:Ratio:V_Zoom
	SetVariable C_PixParPix,pos={24.00,456.00},size={80.00,16.00},bodyWidth=45,proc=SetVarZoom
	SetVariable C_PixParPix,title="pix/pix"
	SetVariable C_PixParPix,help={"Affects the resolution of the exported image"}
	SetVariable C_PixParPix,fSize=11,limits={0.2,3,0.1},value=root:Ratio:V_PixParPix
	Button C_SauveGraphesVersPict,pos={478.00,703.00},size={75.00,20.00},proc=BoutonSauveGrapheImage
	Button C_SauveGraphesVersPict,title="graph->pict"
	Button C_SauveGraphesVersPict,help={"Saves the current F_TracesTriees window as a pdf"}
	Button C_SauveGraphesVersPict,fSize=11
	Button C_Sauve1Image,pos={478.00,655.00},size={75.00,20.00},proc=BoutonSauveImage
	Button C_Sauve1Image,title="-> 1 image"
	Button C_Sauve1Image,help={"Saves the current image to... in memory or exports in file"}
	Button C_Sauve1Image,fSize=11
	CheckBox C_AfficheROI_TousPlans,pos={281.00,207.00},size={81.00,16.00},proc=CheckAfficheROI
	CheckBox C_AfficheROI_TousPlans,title="Display all ROIs"
	CheckBox C_AfficheROI_TousPlans,help={"Forces the display of all ROIs; useful when using stacks of images, to overlay ROIs from different planes"}
	CheckBox C_AfficheROI_TousPlans,value=0
	CheckBox C_Active_P_SelectionPlans,pos={396.00,192.00},size={82.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_SelectionPlans,title="Planes selection"
	CheckBox C_Active_P_SelectionPlans,help={"To select only some planes in the stack"}
	CheckBox C_Active_P_SelectionPlans,value=0,side=1
	CheckBox C_ROIMarqueurs,pos={315.00,461.00},size={49.00,16.00},proc=CheckROIMarqueurs
	CheckBox C_ROIMarqueurs,title="markers",help={"add markers on the trace"}
	CheckBox C_ROIMarqueurs,value=0
	SetVariable C_CorrRatio,pos={115.00,204.00},size={66.00,16.00},bodyWidth=34,proc=MaJ_CasesACocher
	SetVariable C_CorrRatio,title="Power",help={"Correction of color distribution"}
	SetVariable C_CorrRatio,fSize=10
	SetVariable C_CorrRatio,limits={-100,100,0},value=root:Ratio:V_CorrRatio
	PopupMenu C_DF_Analyse,pos={207.00,79.00},size={92.00,20.00},proc=PopMenuSelectAnalyse
	PopupMenu C_DF_Analyse,help={"To create and select several independent sets of ROI analysis "}
	PopupMenu C_DF_Analyse,fSize=12
	PopupMenu C_DF_Analyse,mode=3,popvalue="Analyse_0",value=#"ListeDFAnalyse()"
	CheckBox C_PMoy,pos={483.00,208.00},size={81.00,16.00},proc=CheckProjection
	CheckBox C_PMoy,title="Vertical avg proj"
	CheckBox C_PMoy,help={"Layer 0 contains the vertical average of the pixel column"}
	CheckBox C_PMoy,value=0,side=1
	CheckBox C_Active_P_Deplacement,pos={459.00,107.00},size={70.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Deplacement,title="Control panel",value=0
	CheckBox C_Active_P_Decalage,pos={459.00,152.00},size={70.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Decalage,title="Control panel",value=0
	CheckBox C_SD,pos={265.00,527.00},size={29.00,15.00},proc=CheckAfficheSDSEM
	CheckBox C_SD,title="SD",help={"Add error bars with standard deviation"}
	CheckBox C_SD,value=1,mode=1
	CheckBox C_SEM,pos={305.00,527.00},size={36.00,15.00},proc=CheckAfficheSDSEM
	CheckBox C_SEM,title="SEM",help={"Add bars with standard error of the mean"}
	CheckBox C_SEM,value=0,mode=1
	SetVariable C_CorrRatio2,pos={114.00,225.00},size={67.00,16.00},bodyWidth=35,proc=MaJ_CasesACocher
	SetVariable C_CorrRatio2,title=" Ampl."
	SetVariable C_CorrRatio2,help={"Correction of color distribution."},fSize=10
	SetVariable C_CorrRatio2,limits={-100,100,0},value=root:Ratio:V_CorrRatio2
	SetVariable C_EpaisseurMoyenne,pos={211.00,506.00},size={89.00,16.00},bodyWidth=40,proc=SetVarEpaisseurMoy
	SetVariable C_EpaisseurMoyenne,title="Thickness"
	SetVariable C_EpaisseurMoyenne,help={"Following Régis' urgent request, to control the thickness of the average line"}
	SetVariable C_EpaisseurMoyenne,fSize=10
	SetVariable C_EpaisseurMoyenne,limits={1,6,0.5},value=root:Analyse_0:V_EpaisseurMoy
	CheckBox C_SDSEM,pos={210.00,527.00},size={49.00,15.00},proc=CheckAfficheSDSEM
	CheckBox C_SDSEM,title="no error",help={"Remove error bars"},value=0,mode=1
	SetVariable C_SetChiffres,pos={98.00,374.00},size={46.00,14.00},bodyWidth=17,proc=SetVarLegende
	SetVariable C_SetChiffres,title="Digit #"
	SetVariable C_SetChiffres,help={"Number of digits on the ratio calibration scale"}
	SetVariable C_SetChiffres,limits={1,80,0},value=root:Ratio:V_NbDecimalesCarre
	SetVariable C_SetEspaceEvt,pos={292.00,390.00},size={35.00,14.00},bodyWidth=18,proc=SetVarEspaceEvt
	SetVariable C_SetEspaceEvt,title="top"
	SetVariable C_SetEspaceEvt,help={"Fraction (%) of the graphe reserved above the traces for displaying event bars"}
	SetVariable C_SetEspaceEvt,limits={0,80,0},value=root:Ratio:V_MargeHaut
	CheckBox C_Active_P_Derive_Base,pos={213.00,662.00},size={86.00,16.00},disable=2,proc=CheckActivePanneau
	CheckBox C_Active_P_Derive_Base,title="Baseline drift"
	CheckBox C_Active_P_Derive_Base,help={"To correct for baseline drift; use is not recommended"}
	CheckBox C_Active_P_Derive_Base,fSize=12,value=0
	CheckBox C_Active_P_Masquage,pos={435.00,208.00},size={43.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Masquage,title="Masks",help={"Reserved"},value=0,side=1
	Button C_SauveVignetteTraces,pos={404.00,698.00},size={45.00,20.00},proc=BoutonSauveVignette
	Button C_SauveVignetteTraces,title="Traces"
	Button C_SauveVignetteTraces,help={"Saves this image as jpeg in the database folder"}
	Button C_SauveVignetteTraces,fSize=11
	GroupBox C_GroupExportFileMaker,pos={396.00,655.00},size={63.00,68.00}
	GroupBox C_GroupExportFileMaker,title="->Database"
	GroupBox C_GroupExportFileMaker,help={"Save current image or graph in the folder accessed by database program"}
	GroupBox C_GroupExportFileMaker,frame=0
	TitleBox C_Fonds,pos={224.00,227.00},size={107.00,11.00}
	TitleBox C_Fonds,help={"number of background regions"},frame=0
	TitleBox C_Fonds,variable=root:Analyse_0:S_Fonds
	CheckBox C_CorrigeAB,pos={396.00,494.00},size={81.00,16.00}
	CheckBox C_CorrigeAB,title="A&B corrections"
	CheckBox C_CorrigeAB,help={"Correct the A and B channels for movement, registration, vertical projections, background subtraction..."}
	CheckBox C_CorrigeAB,value=1,side=1
	CheckBox C_CalculerRatio,pos={394.00,512.00},size={83.00,16.00}
	CheckBox C_CalculerRatio,title="Ratio calculation"
	CheckBox C_CalculerRatio,help={"Process ratio, intensity and ratio x intensity images"}
	CheckBox C_CalculerRatio,value=1,side=1
	CheckBox C_Mesurer,pos={387.00,530.00},size={90.00,16.00}
	CheckBox C_Mesurer,title="ROI measurement"
	CheckBox C_Mesurer,help={"Perform the measurement on all ROI"},value=1,side=1
	CheckBox C_Calculer_P_RM,pos={412.00,548.00},size={65.00,16.00}
	CheckBox C_Calculer_P_RM,title="Color image"
	CheckBox C_Calculer_P_RM,help={"Generate the pseudocolor image"},value=1,side=1
	Button C_BoutonCePoint,pos={528.00,492.00},size={20.00,20.00},proc=BoutonAnalyse
	Button C_BoutonCePoint,title="\\W623"
	Button C_BoutonCePoint,help={"Calculate only this current data point"},fSize=11
	Button C_BoutonAjoutePoints,pos={488.00,576.00},size={20.00,20.00},proc=BoutonAnalyse
	Button C_BoutonAjoutePoints,title="\\W649"
	Button C_BoutonAjoutePoints,help={"look for more files to analyze in the data folder"}
	Button C_BoutonAjoutePoints,fSize=11
	Button C_BoutonTousPoints,pos={514.00,517.00},size={50.00,20.00},proc=BoutonAnalyse
	Button C_BoutonTousPoints,title="\\W646 \\W649"
	Button C_BoutonTousPoints,help={"calculate all data points"},fSize=11
	TitleBox C_Duree_Analyse,pos={400.00,620.00},size={78.00,11.00}
	TitleBox C_Duree_Analyse,help={"Duration of the last calculation"},frame=0
	TitleBox C_Duree_Analyse,variable=root:Ratio:S_Duree_Analyse
	Button C_CouleursTriees,pos={285.00,154.00},size={45.00,20.00},proc=BoutonCouleurs
	Button C_CouleursTriees,title="intensity"
	Button C_CouleursTriees,help={"Choose colors based on the intensity measured over the ROI"}
	Button C_CouleursTriees,labelBack=(0,0,65535),fSize=9,fColor=(43690,43690,43690)
	SetVariable C_SetEspaceEvt1,pos={247.00,390.00},size={40.00,14.00},bodyWidth=18,proc=SetVarEspaceEvt
	SetVariable C_SetEspaceEvt1,title="bott."
	SetVariable C_SetEspaceEvt1,help={"Fraction (%) of the graphe reserved below the traces for displaying image numbers"}
	SetVariable C_SetEspaceEvt1,limits={0,80,0},value=root:Ratio:V_MargeBas
	Button C_BoutonTousCalculs,pos={484.00,496.00},size={22.00,68.00},proc=BoutonTousCalculs
	Button C_BoutonTousCalculs,title="⎤\r⎥\rAll\r⎥\r⎦",fSize=11
	GroupBox Temporal_image_averaging,pos={22.00,619.00},size={160.00,50.00}
	GroupBox Temporal_image_averaging,title="Temporal image averaging"
	GroupBox Temporal_image_averaging,help={"Performs a temporal smoothing of the data. Each corrected image is replaced by the average of itself with its neighbors."}
	Button C_BoutonMoyenneAll,pos={72.00,638.00},size={40.00,20.00},proc=BoutonMoyenneTemporelle
	Button C_BoutonMoyenneAll,title="\\W646\\W649"
	Button C_BoutonMoyenneAll,help={"Average all  data point in this experiment"}
	Button C_BoutonMoyenneAll,fSize=10,fColor=(65535,54611,49151)
	SetVariable C_NbMoyTemps,pos={116.00,641.00},size={60.00,14.00},title="nb pnts"
	SetVariable C_NbMoyTemps,help={"Nb of points to add on each side of the current data point: \"1\" means a total of 3 datapoints averaged into the current position."}
	SetVariable C_NbMoyTemps,limits={0,9,1},value=root:Ratio:V_NbMoyTemporelle
	Button C_BoutonPointsSuivants,pos={545.00,542.00},size={20.00,20.00},proc=BoutonAnalyse
	Button C_BoutonPointsSuivants,title="\\W649"
	Button C_BoutonPointsSuivants,help={"Calculate the following data points"}
	Button C_BoutonPointsSuivants,fSize=11
	Button C_BoutonPointsPrecedents,pos={516.00,542.00},size={20.00,20.00},proc=BoutonAnalyse
	Button C_BoutonPointsPrecedents,title="\\W646"
	Button C_BoutonPointsPrecedents,help={"Calculate the previous data points"}
	Button C_BoutonPointsPrecedents,fSize=11
	CheckBox C_Active_P_Export,pos={213.00,619.00},size={136.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Export,title="Cursor measurements"
	CheckBox C_Active_P_Export,help={"Perform cursor measurements"},fSize=12,value=0
	CheckBox C_Active_P_Evts,pos={213.00,597.00},size={54.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Evts,title="Events",help={"Show event window"},fSize=12
	CheckBox C_Active_P_Evts,value=0
	GroupBox C_GroupeMoyennes1,pos={199.00,419.00},size={176.00,132.00}
	GroupBox C_GroupeMoyennes1,title="Trace display"
	CheckBox C_Active_F_Pile,pos={213.00,640.00},size={88.00,16.00},proc=CheckActivePile
	CheckBox C_Active_F_Pile,title="Display stack"
	CheckBox C_Active_F_Pile,help={"Display image stack present with the data"}
	CheckBox C_Active_F_Pile,fSize=12,value=0
	GroupBox C_GroupePanneaux,pos={199.00,557.00},size={176.00,176.00}
	GroupBox C_GroupePanneaux,title="Other control panels"
	CheckBox C_Active_P_PdV,pos={407.00,601.00},size={126.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_PdV,title="Select points of view"
	CheckBox C_Active_P_PdV,help={"Manage a short list of interesting time-points"}
	CheckBox C_Active_P_PdV,fSize=12,value=0
	CheckBox C_AjoutePointsAuto,pos={520.00,578.00},size={36.00,16.00},proc=CheckAjoutePointsAuto
	CheckBox C_AjoutePointsAuto,title="Auto"
	CheckBox C_AjoutePointsAuto,help={"Automatically looks for new datapoints"}
	CheckBox C_AjoutePointsAuto,value=0
	CheckBox C_Active_P_Pulse,pos={213.00,683.00},size={47.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Pulse,title="Pulse",help={"Analyze periodic features"}
	CheckBox C_Active_P_Pulse,fSize=12,value=0
	ValDisplay C_NumFichier,pos={20.00,519.00},size={110.00,13.00},disable=2
	ValDisplay C_NumFichier,title="File index #"
	ValDisplay C_NumFichier,help={"Index value for the file corresponding to this time-point"}
	ValDisplay C_NumFichier,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_NumFichier,value=#"root:Ratio:W_NumTrame[root:Ratio:V_NumCoucheCourante]"
	PopupMenu C_PrereglagesMesure,pos={273.00,183.00},size={78.00,20.00},proc=PopMenuPreReglagesROI
	PopupMenu C_PrereglagesMesure,title="Presets"
	PopupMenu C_PrereglagesMesure,mode=0,value=#"\"D1/D2;Heart;ChIN;0;1;2;3\""
	CheckBox C_Active_P_Recadrage_Image,pos={40,476.00},size={94.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Recadrage_Image,title="More zoom settings"
	CheckBox C_Active_P_Recadrage_Image,help={"Show resize controls; original image is NOT cropped."}
	CheckBox C_Active_P_Recadrage_Image,fSize=12,value=0
	CheckBox C_Active_P_TableauCarreCalib,pos={22.00,392.00},size={86.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_TableauCarreCalib,title="Which datapoints"
	CheckBox C_Active_P_TableauCarreCalib,help={"Displays a table to control which data points show the calibration square"}
	CheckBox C_Active_P_TableauCarreCalib,value=0,side=1
	CheckBox C_Active_P_ROI,pos={213.00,575.00},size={114.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_ROI,title="More ROI controls"
	CheckBox C_Active_P_ROI,help={"Opens a window to define how to exclude from measurement pixels that are below a threshold"}
	CheckBox C_Active_P_ROI,fSize=12,fStyle=0,value=0
	CheckBox C_Active_P_Kymograph,pos={213.00,705.00},size={78.00,16.00},proc=CheckActivePanneau
	CheckBox C_Active_P_Kymograph,title="Kymograph"
	CheckBox C_Active_P_Kymograph,help={"Analyze the dynamics of ratio along a line to produce a kymograph"}
	CheckBox C_Active_P_Kymograph,fSize=12,value=0
	ValDisplay C_DeltaT,pos={139.00,574.00},size={40.00,13.00},title="∆T"
	ValDisplay C_DeltaT,help={"Sampling interval if regular sampling, NaN otherwise."}
	ValDisplay C_DeltaT,limits={0,0,0},barmisc={0,1000},value=#"root:Ratio:V_DeltaT"
	Button C_Aide_Ratio_Calculation,pos={521.00,356.00},size={45.00,18.00},proc=BoutonAide
	Button C_Aide_Ratio_Calculation,title="Help",fSize=11,fStyle=1
	Button C_Aide_Ratio_Calculation,fColor=(65535,0,0)
	ValDisplay C_FondAA,pos={397.00,229.00},size={80.00,13.00},title="Backgnd A"
	ValDisplay C_FondAA,help={"Background value for channel A"},fSize=9
	ValDisplay C_FondAA,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_FondAA,value=#"root:Analyse_0:W_Fond[root:Ratio:V_NumCoucheCourante][0]"
	ValDisplay C_FondBB,pos={481.00,229.00},size={45.00,13.00},title="B"
	ValDisplay C_FondBB,help={"Background value for channel B"},fSize=9
	ValDisplay C_FondBB,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_FondBB,value=#"root:Analyse_0:W_Fond[root:Ratio:V_NumCoucheCourante][1]"
	Button C_Aide_ROI_definition,pos={318.00,74.00},size={45.00,18.00},proc=BoutonAide
	Button C_Aide_ROI_definition,title="Help",fSize=11,fStyle=1
	Button C_Aide_ROI_definition,fColor=(65535,65535,65535)
	Button C_DessineROI,pos={204.00,127.00},size={30.00,20.00},proc=BoutonGereROI
	Button C_DessineROI,help={"Create a new region of interest"},fSize=10
	Button C_EditeROI,pos={238.00,127.00},size={40.00,20.00},proc=BoutonGereROI
	Button C_EditeROI,title="Modify",help={"Edit the current ROI"},fSize=10
	Button C_RAZRoi,pos={326.00,127.00},size={40.00,20.00},proc=BoutonGereROI
	Button C_RAZRoi,title="Reset"
	Button C_RAZRoi,help={"Resets the ROI to a minimal 2 points ROI; needed when drawing a ROI went wrong"}
	Button C_RAZRoi,fSize=10
	Button C_DupliqueROI,pos={282.00,127.00},size={40.00,20.00},proc=BoutonGereROI
	Button C_DupliqueROI,title="Duplic.",help={"Duplicate the current ROI"},fSize=10,disable=2
	GroupBox C_ModeRatio,pos={390.00,271.00},size={177.00,43.00}
	GroupBox C_ModeRatio,title="Calculation mode"
	GroupBox C_ModeRatio,help={"How data channels are used"}
	CheckBox C_CheckAB,pos={400.00,290.00},size={32.00,15.00},proc=CheckModeCalcul
	CheckBox C_CheckAB,title="A/B",help={"Ratio = channel A / channel B"}
	CheckBox C_CheckAB,value=1,mode=1
	CheckBox C_CheckBA,pos={441.00,290.00},size={32.00,15.00},proc=CheckModeCalcul
	CheckBox C_CheckBA,title="B/A",help={"Ratio = channel B / channel A"}
	CheckBox C_CheckBA,value=0,mode=1
	CheckBox C_CheckA1,pos={484.00,290.00},size={31.00,15.00},proc=CheckModeCalcul
	CheckBox C_CheckA1,title="A/1"
	CheckBox C_CheckA1,help={"Ratio = channel A (B is ignored in the ratio)"}
	CheckBox C_CheckA1,value=0,mode=1
	CheckBox C_CheckB1,pos={526.00,290.00},size={31.00,15.00},proc=CheckModeCalcul
	CheckBox C_CheckB1,title="B/1"
	CheckBox C_CheckB1,help={"Ratio = channel B (A is ignored in the ratio)"}
	CheckBox C_CheckB1,value=0,mode=1
	CheckBox C_CheckRatioSimple,pos={486.00,431.00},size={69.00,22.00},proc=CheckModeCalcul
	CheckBox C_CheckRatioSimple,title="Just the\raverage ratio"
	CheckBox C_CheckRatioSimple,help={"Calculates the ratio for each pixel; the measurement displayed on the trace is the average within the ROI\rof the ratio values for each pixel (no weighting by the intensity)"}
	CheckBox C_CheckRatioSimple,value=0,mode=1
	Button C_Aide_Calibration,pos={130.00,396.00},size={45.00,18.00},proc=BoutonAide
	Button C_Aide_Calibration,title="Help",fSize=11,fStyle=1,fColor=(29524,1,58982)
	CheckBox C_CheckNomTag,pos={249.00,362.00},size={30.00,15.00},proc=CheckAfficheNomTag
	CheckBox C_CheckNomTag,title="left",fSize=10,value=0,mode=1
	CheckBox C_CheckNomTag0,pos={284.00,362.00},size={39.00,15.00},proc=CheckAfficheNomTag
	CheckBox C_CheckNomTag0,title="none",fSize=10,value=1,mode=1
	CheckBox C_CheckNomTag1,pos={325.00,362.00},size={36.00,15.00},proc=CheckAfficheNomTag
	CheckBox C_CheckNomTag1,title="right",fSize=10,value=0,mode=1
	ToolsGrid snap=1,visible=1,grid=(0,28.35,5)
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(226,263,325,356)/HOST=#  W_NombreTag,W_NombreTagStr
	ModifyTable frameInset= 1,size=9,format(Point)=1,width(Point)=14,format(W_NombreTag)=1
	ModifyTable width(W_NombreTag)=30,width(W_NombreTagStr)=50
	ModifyTable showParts=0x49
	SetDataFolder fldrSav0
	RenameWindow #,T0
	SetActiveSubwindow ##
EndMacro

Function Init_P_Controle()
	Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	NVAR/SDFR=dfRatio Dim, V_NbPlans, V_NumCoucheCourante
	Wave/SDFR=dfROI W_Tag, W_Fond
	NVAR/SDFR=dfROI V_NbROI, V_NumROI, V_NbFonds
	SVAR/SDFR=dfROI S_Fonds

	string sFormule
	
	SetDataFolder dfRatio

//	Create the window. Calls a macro that can be updated interactively
	DoWindow/F P_Controle
	if (V_Flag!=1)	//	Window doesn't exist
		Execute "P_Controle()"	//	create the window
	endif
//	Make the panel non-resizable
	ModifyPanel/W=P_Controle fixedSize=1
	
//	After window creation, specify more precisely the state of some controls
	variable i
	HideTools/W=P_Controle/A

	//	valdisplays must point at the correct value, set here
	ValDisplay C_TempsCourant,value= #"root:Ratio:W_Temps[root:Ratio:V_NumCoucheCourante]"
	ValDisplay C_TempsCourantNet,value= #"root:Ratio:W_Temps_Min[root:Ratio:V_NumCoucheCourante]"
	
	CheckBox C_CheckBoxDecalage win=P_Controle, disable=2, value=0
	CheckBox C_CheckBoxDeplacement win=P_Controle, value=0, disable=0
	CheckBox C_CheckRatioModule win=P_Controle, value=1
	CheckBox C_CheckRatioDesMoyennes win=P_Controle, value=0
	CheckBox C_Active_P_Derive_Base win=P_Controle, value=0, disable=2	//	disable this feature
	PopupMenu C_Affichage win=P_Controle, mode=1
	CheckBox C_AutoZoomROI value=0
	CheckBox C_ROI_Points value=0
	CheckBox C_AfficheMoy value=0
	CheckBox C_AffichePosition value=0
	CheckBox C_PMoy value=0
	CheckBox C_PMI value=0
	CheckBox C_Active_P_SelectionPlans value=0
	CheckBox C_Active_P_Recadrage_Image value=0
	CheckBox C_Active_P_ROI value=0
	PopupMenu C_Affichage,fSize=9,mode=1,popvalue="RM",value= #"\"RM;A;B\""
	
	//	Checking the boxes of tag display, depending on what group shows on the graph
	CheckBox C_Groupe0 value=TesteGroupe(0)
	CheckBox C_Groupe1 value=TesteGroupe(1)
	CheckBox C_Groupe2 value=TesteGroupe(2)
	CheckBox C_Groupe3 value=TesteGroupe(3)
	CheckAfficheGroupe("", 1)

	//	 Radio buttons for IMoy selection
	CheckBox C_CheckIMoyAB, value=0
	CheckBox C_CheckIMoyA, value=0
	CheckBox C_CheckIMoyB, value=0
	
	//	Uncheck various check boxes
	CheckBox C_Active_P_Evts, value=0
	CheckBox C_Active_P_PdV, value=0
	CheckBox C_Active_P_Export, value=0
	CheckBox C_Active_F_Pile, value=0
	CheckBox C_Active_P_Derive_Base, value=0
	CheckBox C_Active_P_Deplacement value=0
	Checkbox C_Active_P_Decalage value=0
	Checkbox C_Active_P_Masquage value=0
	CheckBox C_Active_P_TableauROI value=0
	CheckBox C_Active_P_Pulse value=0
	CheckBox C_Active_P_Kymograph value=0
	
	//	Update the radio buttons to reflect the value of global variables
	CheckModeCalcul("Initialize", 0)

	CheckBox C_AfficheROI disable=0,value=1
	SetVariable C_NumROI limits={1,V_NbROI,1},value=V_NumROI
	SetVariable C_Tag value=W_Tag[V_NumROI]
	TitleBox C_Fonds variable=S_Fonds

	//	To display the list of Analyse_* datafolders that is available
	string sNomDF=GetDataFolder(0, dfROI)
	string sListe=ListeDFAnalyse()
	variable vRang=WhichListItem(sNomDF, sListe)		//	count the position of the current dfROI starting from 0
	PopupMenu C_DF_Analyse win=P_Controle,mode=(vRang+1),value=ListeDFAnalyse()	//	set the popup; n.b.: "mode" counts starting from 1

	if(V_NbPlans>1)
		Slider C_GlissierePlan win=F_RM, limits={0, (V_NbPlans-1),1}, disable=0
		//	If there are too many planes in the stack, reading from disk in real time is too slow; in that case, live=0
		if (V_NbPlans>5)
			Slider C_GlissierePositionCourante live=0, win=P_Controle
			Slider C_GlissierePositionCourante live=0, win=F_RM
		else
			Slider C_GlissierePositionCourante live=1, win=P_Controle
			Slider C_GlissierePositionCourante live=1, win=F_RM
		endif
	else
		Slider C_GlissierePositionCourante live=1, win=P_Controle
		Slider C_GlissierePlan win=F_RM, limits={0, 0,1}, disable=2
		Slider C_GlissierePositionCourante live=1, win=F_RM
		Slider C_GlissierePlan win=F_RM, limits={0, 0,1}, disable=2
	EndIf
end

Window F_Traces() : Graph
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Display /W=(3,45,441,413)/K=2  TraceR0000 vs W_Temps_min as "Raw measurements"
	AppendToGraph/L=F_A TraceA0000 vs W_Temps_min
	AppendToGraph/L=F_B TraceB0000 vs W_Temps_min
	AppendToGraph/R W_Evt vs W_EvtTemps
	AppendToGraph/R W_Evt vs W_EvtTemps
	AppendToGraph/R W_PosY vs W_PosX
	SetDataFolder fldrSav0
	ModifyGraph mode(TraceR0000)=4,mode(W_Evt)=3,mode(W_Evt#1)=1,mode(W_PosY)=1
	ModifyGraph rgb(W_Evt)=(0,0,0),rgb(W_Evt#1)=(0,0,0),rgb(W_PosY)=(36214,26214,56214)
	ModifyGraph msize(TraceR0000)=5,msize(W_Evt)=4
	ModifyGraph mskip(TraceR0000)=20
	ModifyGraph textMarker(TraceR0000)={:Ratio:W_NumTrame,"default",0,0,5,0.00,0.00}
	ModifyGraph textMarker(W_Evt)={:Ratio:W_EvtStr,"default",0,0,5,0.00,0.00}
	ModifyGraph zero(F_A)=3,zero(F_B)=3
	ModifyGraph nticks(left)=4,nticks(F_A)=3,nticks(F_B)=3,nticks(right)=0
	ModifyGraph noLabel(right)=2
	ModifyGraph standoff=0
	ModifyGraph axThick(right)=0
	ModifyGraph zeroThick(F_A)=1,zeroThick(F_B)=1
	ModifyGraph lblPos(left)=91,lblPos(F_A)=91,lblPos(F_B)=91
	ModifyGraph lblLatPos(left)=1,lblLatPos(F_A)=-1
	ModifyGraph freePos(F_A)=0
	ModifyGraph freePos(F_B)=0
	ModifyGraph axisEnab(left)={0,0.37}
	ModifyGraph axisEnab(F_A)={0.7,0.95}
	ModifyGraph axisEnab(F_B)={0.42,0.67}
	Label left "Ratio"
	Label bottom "Time (min)"
	Label F_A "F(A)"
	Label F_B "F(B)"
	SetAxis/A/E=1 F_A
	SetAxis/A/E=1 F_B
	SetAxis right 0,1
EndMacro

Window F_TracesTriees() : Graph
	PauseUpdate; Silent 1		// building window...
	SetDataFolder root:Ratio:
	Display/K=2 /W=(411,44,995,444) TraceR0000 vs W_Temps_min as "Sorted traces"
	AppendToGraph/L=tag1 TraceR0000 vs W_Temps_min
	AppendToGraph/L=tag2 TraceR0000 vs W_Temps_min
	AppendToGraph/L=tag3 TraceR0000 vs W_Temps_min
	AppendToGraph/R W_Evt vs W_EvtTemps
	AppendToGraph/R W_Evt vs W_EvtTemps
	ModifyGraph mode(W_Evt)=3,mode(W_Evt#1)=1
	ModifyGraph textMarker(W_Evt)={W_EvtStr,"default",1,0,0,0.00,0.00}
	ModifyGraph rgb(TraceR0000)=(65535,65535,65535),rgb(TraceR0000#1)=(65535,65535,65535)
	ModifyGraph rgb(TraceR0000#2)=(65535,65535,65535),rgb(TraceR0000#3)=(65535,65535,65535)
	ModifyGraph rgb(W_Evt)=(0,0,0),rgb(W_Evt#1)=(0,0,0)
	ModifyGraph textMarker(W_Evt)={W_EvtStr,"default",0,0,5,0.00,0.00}
	ModifyGraph noLabel(right)=2
	ModifyGraph standoff(left)=0,standoff(bottom)=0,standoff(tag1)=0,standoff(tag2)=0
	ModifyGraph standoff(tag3)=0
	ModifyGraph axThick(right)=0
	ModifyGraph lblPos(left)=60
	ModifyGraph freePos(tag1)=0
	ModifyGraph freePos(tag2)=0
	ModifyGraph freePos(tag3)=0
	ModifyGraph axisEnab(left)={0,0.23}
	ModifyGraph axisEnab(tag1)={0.25,0.47}
	ModifyGraph axisEnab(tag2)={0.5,0.73}
	ModifyGraph axisEnab(tag3)={0.75,1}
	Label bottom "Time (min)"
	AppendToGraph/R W_EvtCorr vs W_EvtTempsCorr2
	ModifyGraph lsize(W_EvtCorr)=1,rgb(W_EvtCorr)=(0,0,0),mode(W_EvtCorr)=4,textMarker(W_EvtCorr)={W_EvtStrCorr,"default",0,0,0,0.00,1.00}
	ModifyGraph noLabel(right)=2,axThick(right)=0,standoff=0
	SetAxis/W=F_TracesTriees right 0,1
	ModifyGraph gFont="Helvetica", gFsize=9,expand=-1.5
	ModifyGraph width=155.906,height=113.386	//	détermine une taille par défaut
	ModifyGraph width=0,height=0	//	permet de changer la taille de la fenêtre librement
	ModifyGraph manTick(left)={0,0.2,0,1},manMinor(left)={0,50}
	ModifyGraph manTick(tag1)={0,0.1,0,1},manMinor(tag1)={0,50}
	ModifyGraph manTick(tag2)={0,0.1,0,1},manMinor(tag2)={0,50}
	ModifyGraph manTick(tag3)={0,0.1,0,1},manMinor(tag3)={0,50}
	ModifyGraph margin(left)=34,margin(bottom)=34,margin(top)=30,margin(right)=20
	ModifyGraph width=0,height=0	//	pour libérer la contrainte de taille sur le graphe
	DoUpdate
EndMacro

Function Init_F_TracesTriees()
	variable i
	string sNomAxeD, sListeNomsAxes, sNomTag
Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	Wave/SDFR=dfRatio TraceR0000, W_Temps_min
	DoWindow/F F_TracesTriees
	HideInfo

	//	Masque les traces ROOOO qui servent à maintenir l'existence des axes mais ne doivent pas être visible
	ModifyGraph/Z/W=F_TracesTriees hideTrace(TraceR0000)=1,hideTrace(TraceR0000#1)=1,hideTrace(TraceR0000#2)=1,hideTrace(TraceR0000#3)=1
	ModifyGraph/Z/W=F_TracesTriees hideTrace(TraceR0000#4)=1,hideTrace(TraceR0000#5)=1,hideTrace(TraceR0000#6)=1,hideTrace(TraceR0000#7)=1
	
	//	Vérifie que les noms des groupes sont affichés, et si non, les crée
	for (i=0; (i<=3); i+=1)
		sNomTag="NomTag"+num2Str(i)
		TextBox/W=F_TracesTriees/C/N=$sNomTag "Tag"+num2Str(i)
	endfor
	HideInfo
End

Window F_RM() : Graph
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio
	NewImage/G=1 P_ACorr
	ModifyImage P_ACorr ctab= {*,*,Grays,0}
	AppendImage/T P_RM
	ModifyImage P_RM ctab= {*,*,Grays,0}
	SetDataFolder fldrSav0
	ModifyGraph margin(left)=-1,margin(bottom)=-1,margin(top)=-1,margin(right)=-1,expand=-0.5
	ModifyGraph width=1344,height=1024
	ModifyGraph mirror=0
	ModifyGraph nticks=0
	ModifyGraph noLabel=2
	ModifyGraph standoff=0
	ModifyGraph axThick=0
	SetAxis/A/R left
	ControlBar 90
	ControlBar/L 70
	Slider C_GlissierePlan,pos={7.00,98.00},size={49.00,393.00},disable=2,proc=GlissierePlan
	Slider C_GlissierePlan,fSize=8,limits={0,0,1},variable=root:Ratio:V_NumPlan
	Slider C_GlissierePositionCourante,pos={8.00,5.00},size={447.00,44.00},proc=GlissiereAffichage
	Slider C_GlissierePositionCourante,limits={0,231,1},variable=root:Ratio:V_NumCoucheCourante,vert=0
	Button C_Debut,pos={75.00,56.00},size={30.00,20.00},proc=BoutonDebutFin
	Button C_Debut,title="I\\F'Symbol'⇐",help={"Jump to first"},fSize=12,fStyle=1
	Button C_Fin,pos={117.00,56.00},size={30.00,20.00},proc=BoutonDebutFin
	Button C_Fin,title="\\F'Symbol'⇒\\F'Lucida Grande'I",help={"Jump to last"}
	Button C_Fin,fSize=12,fStyle=1
	SetVariable C_NumTrame,pos={6.00,58.00},size={60.00,17.00},bodyWidth=60,proc=SetNum
	SetVariable C_NumTrame,title=" ",fSize=12
	SetVariable C_NumTrame,limits={0,231,1},value=root:Ratio:V_NumCoucheCourante
	PopupMenu C_Affichage,pos={243.00,56.00},size={54.00,20.00},proc=PopMenuAffichage
	PopupMenu C_Affichage,fSize=9,mode=3,popvalue="RM",value=#"\"RM;A;B\""
	SetVariable C_Magnification,pos={158.00,59.00},size={75.00,16.00},bodyWidth=44,proc=SetVarZoom
	SetVariable C_Magnification,title="zoom"
	SetVariable C_Magnification,help={"Just a zoom on the image; no effect on image resolution."}
	SetVariable C_Magnification,fSize=11
	SetVariable C_Magnification,limits={0.25,8,0.25},value=root:Ratio:V_Zoom
	SetDrawLayer ProgFront
	SetDrawEnv xcoord= top,ycoord= left,linefgc= (65535,65535,65535),fillpat= 0,fsize= 20,textrgb= (65535,65535,65535)
	SetDrawEnv save
	SetDrawEnv textxjust= 1,textyjust= 2
	DrawText 80,929,"0"
	SetDrawEnv textxjust= 1,textyjust= 2
	DrawText 204,929,"3000"
	SetDrawEnv textyjust= 2
	DrawText 210,800,"1.20"
	DrawText 210,924,"0.90"
	SetDrawEnv textxjust= 1
	DrawText 142,796,"20 µm"
	SetDrawLayer UserFront
EndMacro

Window P_Initialisation() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(109,45,844,566) as "Data definition"
	ModifyPanel cbRGB=(56797,56797,56797), fixedSize=1, frameInset=3
	SetDrawLayer UserBack
	DrawText 424,124.333333333333,"Gain"
	SetDrawEnv fsize= 10
	SetDrawEnv save
	DrawText 36,240,"A"
	DrawText 36,260,"B"
	DrawText 36,280,"C"
	DrawText 36,300,"D"
	DrawText 36,320,"E"
	DrawText 36,340,"F"
	SetDrawEnv fsize= 9
	DrawText 232,207,"tail         ext."
	SetDrawEnv fsize= 12,fstyle= 1,textxjust= 1
	DrawText 379,311,"Experiment name"
	GroupBox C_Correction,pos={324.00,10.00},size={158.00,268.00}
	GroupBox C_Correction,title="Instrument corrections"
	GroupBox C_Correction,help={"Corrections depending on the instrument: shading, gain..."}
	GroupBox C_Correction,labelBack=(59305,65117,56063),fSize=12
	GroupBox C_Correction1,pos={336.00,193.00},size={128.00,76.00}
	GroupBox C_Correction1,title="Image orientation"
	GroupBox C_Correction1,help={"Optional: flip/rotate the image"},fSize=12
	GroupBox C_Correction1,fStyle=0
	GroupBox C_Chemins,pos={14.00,356.00},size={392.00,146.00},title="Path to files"
	GroupBox C_Chemins,labelBack=(65474,62852,59831),fSize=12
	Button C_BoutonFich1,pos={28.00,156.00},size={60.00,20.00},proc=BoutonOuvreFichier
	Button C_BoutonFich1,title="1st datafile"
	Button C_BoutonFich1,help={"Loads the first image of the experiment -> image sizes and starts the index of datafiles"}
	SetVariable C_NbChiffresFichier,pos={170.00,194.00},size={55.00,14.00},proc=SetVarNomManip
	SetVariable C_NbChiffresFichier,title=" index"
	SetVariable C_NbChiffresFichier,help={"Number of digits in the index for time points. 1 means no padding (0, 1, 2, ... 10, 11, 12..., 100, 101, 102...); 2 means index has 2 digits: 00, 01, 02... up to 99; 3 means index has 3 digits etc..."}
	SetVariable C_NbChiffresFichier,limits={1,5,1},value=root:Ratio:V_NbChiffresFichier
	PopupMenu C_Objectif,pos={332.00,32.00},size={100.00,20.00},proc=PopMenuObjectif
	PopupMenu C_Objectif,title="Objective"
	PopupMenu C_Objectif,help={"Determines the size of the pixel; no other effect"}
	PopupMenu C_Objectif,fSize=12,mode=1,popvalue="--",value=#"\"--;10;20;40;60\""
	SetVariable C_Offset,pos={332.00,82.00},size={76.00,17.00},title="Offset"
	SetVariable C_Offset,help={"Camera offset; value subtracted from all raw images."}
	SetVariable C_Offset,fSize=12
	SetVariable C_Offset,limits={-inf,inf,0},value=root:Ratio:V_OffsetCamera
	SetVariable C_Nom_Manip,pos={329.00,312.00},size={124.00,17.00},proc=SetVarNomManip
	SetVariable C_Nom_Manip,title=" ",fSize=12,value=root:Ratio:S_Nom_Manip
	CheckBox C_checkUnif,pos={337.00,109.00},size={39.00,16.00},proc=CheckLitUnif
	CheckBox C_checkUnif,title="Unif"
	CheckBox C_checkUnif,help={"To correct the uniformity of imaging field; \"flatfield\" or \"shading\" correction"}
	CheckBox C_checkUnif,fSize=12,value=0,side=1
	SetVariable C_GainA,pos={424.00,129.00},size={30.00,14.00},title=" ",fSize=9
	SetVariable C_GainA,limits={-inf,inf,0},value=root:Ratio:V_GainA
	SetVariable C_GainB,pos={424.00,147.00},size={30.00,14.00},title=" ",fSize=9
	SetVariable C_GainB,limits={-inf,inf,0},value=root:Ratio:V_GainB
	PopupMenu C_TypeManip,pos={24.00,34.00},size={156.00,20.00},proc=PopMenuPreReglage
	PopupMenu C_TypeManip,title="Presets:"
	PopupMenu C_TypeManip,help={"Various pre-set variables defining the conditions of image acquisition"}
	PopupMenu C_TypeManip,fSize=12
	PopupMenu C_TypeManip,mode=4,popvalue="Poste biolum",value=#"ksTypesAcquisition"
	PopupMenu C_ChoixServeurOuLocal,pos={25.00,378.00},size={156.00,20.00},proc=PopMenuInitChemins
	PopupMenu C_ChoixServeurOuLocal,title="guess path to folders"
	PopupMenu C_ChoixServeurOuLocal,help={"Automatically determines path to relevant folders, based on the YYY-MM-DDAXXX structure of file name; see documentation"}
	PopupMenu C_ChoixServeurOuLocal,fSize=11,fStyle=3
	PopupMenu C_ChoixServeurOuLocal,mode=0,value=#"\"-----;server Ocean;server DISTT;local computer\""
	CheckBox C_MiroirHorizontal,pos={348.00,215.00},size={91.00,16.00},proc=CheckMiroir
	CheckBox C_MiroirHorizontal,title="Horizontal mirror",fSize=10,value=0
	CheckBox C_MiroirVertical,pos={348.00,231.00},size={79.00,16.00},proc=CheckMiroir
	CheckBox C_MiroirVertical,title="Vertical mirror",fSize=10,value=0
	CheckBox C_Rotation,pos={348.00,246.00},size={54.00,16.00},proc=CheckMiroir
	CheckBox C_Rotation,title="Rotation",fSize=10,value=0
	SetVariable C_SetResolution,pos={332.00,58.00},size={98.00,17.00},bodyWidth=38,proc=MaJ_CasesACocher
	SetVariable C_SetResolution,title="Resolution"
	SetVariable C_SetResolution,help={"Resolution calculated from the objective; can also be entered manually. Should be in µm/pixel"}
	SetVariable C_SetResolution,fSize=12
	SetVariable C_SetResolution,limits={0,2,0},value=root:Ratio:V_Resolution
	ValDisplay C_MoyUnifA,pos={336.00,129.00},size={50.00,13.00},title="A"
	ValDisplay C_MoyUnifA,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_MoyUnifA,value=#"root:Ratio:V_MoyUnifA"
	ValDisplay C_MoyUnifB,pos={336.00,147.00},size={50.00,13.00},title="B"
	ValDisplay C_MoyUnifB,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_MoyUnifB,value=#"root:Ratio:V_MoyUnifB"
	SetVariable C_NomSenseur,pos={554.00,437.00},size={173.00,16.00}
	SetVariable C_NomSenseur,title="Biosensor:"
	SetVariable C_NomSenseur,help={"To store the name of the biosensor"},fSize=10
	SetVariable C_NomSenseur,fStyle=2,value=root:Ratio:S_NomSenseur
	SetVariable C_NomCellule,pos={561.00,457.00},size={166.00,16.00},title="Cells:"
	SetVariable C_NomCellule,help={"To store the type of cells used in this experiment"}
	SetVariable C_NomCellule,fSize=10,fStyle=2,value=root:Ratio:S_NomCellule
	SetVariable C_NbVoies,pos={194.00,34.00},size={110.00,17.00},proc=SetVarNbVoies
	SetVariable C_NbVoies,title="Acq. channels"
	SetVariable C_NbVoies,help={"Number of acquisition channels. At least one channel for donor (A) and for acceptor (B); more for additional fluorescence channels or transmitted light"}
	SetVariable C_NbVoies,fSize=12
	SetVariable C_NbVoies,limits={2,6,1},value=root:Ratio:V_NbVoies,noedit=1
	Button C_RedimensionImages,pos={428.00,445.00},size={45.00,20.00},proc=RedimensionImages
	Button C_RedimensionImages,title="Fix sizes"
	Button C_RedimensionImages,help={"To resize all images to the indicated size; useful in case of bug (accidental redimensioning of images)"}
	Button C_RedimensionImages,fSize=9
	TitleBox C_NomCheminDonnees,pos={92.00,406.00},size={277.00,11.00}
	TitleBox C_NomCheminDonnees,title="Portable Pierre:Users:pie … ges et Igor:Epac-BRET:2023-12-06F001:"
	TitleBox C_NomCheminDonnees,frame=0
	TitleBox C_NomCheminCalcul,pos={102.00,460.00},size={162.00,11.00}
	TitleBox C_NomCheminCalcul,title="Portable Pierre:Users:pierre:Documents:"
	TitleBox C_NomCheminCalcul,fSize=9,frame=0
	TitleBox C_NomCheminJPEG,pos={92.00,442.00},size={162.00,11.00}
	TitleBox C_NomCheminJPEG,title="Portable Pierre:Users:pierre:Documents:",frame=0
	TitleBox C_NomCheminAnalyses,pos={92.00,424.00},size={162.00,11.00}
	TitleBox C_NomCheminAnalyses,title="Portable Pierre:Users:pierre:Documents:"
	TitleBox C_NomCheminAnalyses,fSize=9,frame=0
	TitleBox C_NomCheminExport,pos={92.00,478.00},size={223.00,11.00},frame=0
	Button C_ChoixCheminDonnees,pos={25.00,404.00},size={60.00,16.00},proc=BoutonInitialisation
	Button C_ChoixCheminDonnees,title="raw images"
	Button C_ChoixCheminDonnees,help={"Path to the raw images to analyze."},fSize=9
	Button C_ChoixCheminAnalyses,pos={25.00,422.00},size={60.00,16.00},proc=BoutonInitialisation
	Button C_ChoixCheminAnalyses,title="analysis"
	Button C_ChoixCheminAnalyses,help={"Where to save the analysis file; this applies only to the save for the first time"},fSize=9
	Button C_ChoixCheminJPEG,pos={25.00,440.00},size={60.00,16.00},proc=BoutonInitialisation
	Button C_ChoixCheminJPEG,title="->Database"
	Button C_ChoixCheminJPEG,help={"Where to export traces and snapshot images; intended for the server and database."}
	Button C_ChoixCheminJPEG,fSize=9
	Button C_ChoixCheminCalcul,pos={25.00,458.00},size={33.00,16.00},proc=BoutonInitialisation
	Button C_ChoixCheminCalcul,title="cache"
	Button C_ChoixCheminCalcul,help={"Where to save the temporary files"},fSize=9
	Button C_ChoixCheminExport2,pos={25.00,476.00},size={60.00,16.00},proc=BoutonInitialisation
	Button C_ChoixCheminExport2,title="export figs."
	Button C_ChoixCheminExport2,help={"For exporting things like final figures; intended to point at the figure folder of a paper."}
	Button C_ChoixCheminExport2,fSize=9
	Button C_VideCheminCalcul,pos={64.00,458.00},size={33.00,16.00},proc=BoutonSupprimeTemp
	Button C_VideCheminCalcul,title="clear"
	Button C_VideCheminCalcul,help={"To clear all temporary files needed for the calculation in the cache directory; NO effect on original data or analysis files !"}
	Button C_VideCheminCalcul,fSize=9,fStyle=3,valueColor=(65535,0,0)
	CheckBox C_CheckFond,pos={349.00,170.00},size={81.00,16.00},proc=CheckLitFond
	CheckBox C_CheckFond,title="Background"
	CheckBox C_CheckFond,help={"Load a pair of background images to be subtracted from every image"}
	CheckBox C_CheckFond,fSize=12,value=0,side=1
	Button C_Aide_Data_definition,pos={673.00,490.00},size={50.00,20.00},proc=BoutonAide
	Button C_Aide_Data_definition,title="Help",fSize=12,fStyle=1,fColor=(52428,1,1)
	CheckBox C_Check_ChannelsMerged_1,pos={97.00,80.00},size={47.00,15.00},proc=CheckDataScheme
	CheckBox C_Check_ChannelsMerged_1,title="Merged"
	CheckBox C_Check_ChannelsMerged_1,help={"A single file contains all acquisition channels"}
	CheckBox C_Check_ChannelsMerged_1,value=0,mode=1,side=1
	CheckBox C_Check_ChannelsMerged_0,pos={37.00,80.00},size={53.00,15.00},proc=CheckDataScheme
	CheckBox C_Check_ChannelsMerged_0,title="Separate"
	CheckBox C_Check_ChannelsMerged_0,help={"One file contains only a single image or a Z stack from a single channel"}
	CheckBox C_Check_ChannelsMerged_0,value=1,mode=1,side=1
	GroupBox C_Wavelength,pos={24.00,58.00},size={278.00,50.00}
	GroupBox C_Wavelength,title="Different channels are stored..."
	CheckBox C_Check_Split_1,pos={255.00,80.00},size={34.00,15.00},disable=2,proc=CheckDataScheme
	CheckBox C_Check_Split_1,title="Split"
	CheckBox C_Check_Split_1,help={"A single image plane for both wavelength: generated by emission splitting devices"}
	CheckBox C_Check_Split_1,value=0,mode=1,side=1
	CheckBox C_Check_Split_0,pos={162.00,80.00},size={80.00,15.00},disable=2,proc=CheckDataScheme
	CheckBox C_Check_Split_0,title="1 channel, 1 file"
	CheckBox C_Check_Split_0,help={"Within one file, each image plane corresponds to one acquisition channel"}
	CheckBox C_Check_Split_0,value=1,mode=1,side=1
	GroupBox C_TimeSeries,pos={24.00,108.00},size={146.00,46.00}
	GroupBox C_TimeSeries,title="Different time points are stored..."
	CheckBox C_Check_TimepointsMerged_0,pos={41.00,128.00},size={53.00,15.00},proc=CheckDataScheme
	CheckBox C_Check_TimepointsMerged_0,title="Separate"
	CheckBox C_Check_TimepointsMerged_0,help={"Each time-point has one or a set of files"}
	CheckBox C_Check_TimepointsMerged_0,value=1,mode=1,side=1
	CheckBox C_Check_TimepointsMerged_1,pos={103.00,128.00},size={47.00,15.00},proc=CheckDataScheme
	CheckBox C_Check_TimepointsMerged_1,title="Merged"
	CheckBox C_Check_TimepointsMerged_1,help={"The images of all time-points are merged into one large time stack; one stack per acquisition channel"}
	CheckBox C_Check_TimepointsMerged_1,value=0,mode=1,side=1
	ValDisplay C_NbFichiers,pos={172.00,128.00},size={124.00,13.00}
	ValDisplay C_NbFichiers,title="Nb of files per time point",fStyle=2
	ValDisplay C_NbFichiers,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_NbFichiers,value=#"root:Ratio:V_NbFichiers"
	Button C_BoutonChargePileTemps,pos={198.00,166.00},size={105.00,20.00},disable=1,proc=BoutonChargeToutesImages
	Button C_BoutonChargePileTemps,title="Load time stacks"
	Button C_BoutonChargePileTemps,help={"Loads all images in the time stack(s), and save images in the cache."}
	Button C_BoutonChargePileTemps,fSize=12,fStyle=2
	GroupBox C_DataScheme,pos={14.00,10.00},size={300.00,350.00}
	GroupBox C_DataScheme,title="How images are stored",fSize=12
	GroupBox C_ImageSize,pos={417.00,359.00},size={67.00,118.00},title="Size"
	GroupBox C_ImageSize,help={"Size of the image at each time-point, in pixels"}
	GroupBox C_Time,pos={493.00,10.00},size={238.00,420.00},title="Timing"
	GroupBox C_Time,help={"How the time corresponding to data sample is handled"}
	GroupBox C_Time,labelBack=(65535,65535,57671),fSize=12
	ValDisplay C_NbPlans,pos={423.00,419.00},size={38.00,13.00},title="Z"
	ValDisplay C_NbPlans,help={"Number of pixels in Z dimension"}
	ValDisplay C_NbPlans,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_NbPlans,value=#"root:Ratio:V_NbPlans"
	ValDisplay C_TailleY,pos={423.00,399.00},size={38.00,13.00},title="Y"
	ValDisplay C_TailleY,help={"Number of pixels in Y dimension"}
	ValDisplay C_TailleY,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_TailleY,value=#"root:Ratio:V_Taille_Y"
	ValDisplay C_TailleX,pos={423.00,379.00},size={38.00,13.00},title="X"
	ValDisplay C_TailleX,help={"Number of pixels in X dimension"}
	ValDisplay C_TailleX,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_TailleX,value=#"root:Ratio:V_Taille_X"
	SetVariable C_Nom_Fich_A,pos={45.00,227.00},size={140.00,15.00},title=" "
	SetVariable C_Nom_Fich_A,font="Monaco",fSize=9
	SetVariable C_Nom_Fich_A,value=root:Ratio:S_Base_Nom_Fichier_A
	SetVariable C_Nom_Fich_B,pos={45.00,248.00},size={140.00,15.00},title=" "
	SetVariable C_Nom_Fich_B,font="Monaco",value=root:Ratio:S_Base_Nom_Fichier_B
	SetVariable C_Nom_Fich_C,pos={45.00,268.00},size={140.00,15.00},disable=1
	SetVariable C_Nom_Fich_C,title=" ",font="Monaco"
	SetVariable C_Nom_Fich_C,value=root:Ratio:S_Base_Nom_Fichier_C
	SetVariable C_Nom_Fich_D,pos={45.00,288.00},size={140.00,15.00},disable=1
	SetVariable C_Nom_Fich_D,title=" ",font="Monaco"
	SetVariable C_Nom_Fich_D,value=root:Ratio:S_Base_Nom_Fichier_D
	SetVariable C_Nom_Fich_E,pos={45.00,308.00},size={140.00,15.00},disable=1
	SetVariable C_Nom_Fich_E,title=" ",font="Monaco"
	SetVariable C_Nom_Fich_E,value=root:Ratio:S_Base_Nom_Fichier_E
	SetVariable C_Nom_Fich_F,pos={45.00,328.00},size={140.00,15.00},disable=1
	SetVariable C_Nom_Fich_F,title=" ",font="Monaco"
	SetVariable C_Nom_Fich_F,value=root:Ratio:S_Base_Nom_Fichier_F
	Button C_EditTable,pos={585.00,314.00},size={56.00,18.00},proc=BoutonInitialisation
	Button C_EditTable,title="Edit table",help={"Edit that table"}
	SetVariable C_NbLettresInutiles,pos={102.00,194.00},size={65.00,14.00},proc=SetVarNomManip
	SetVariable C_NbLettresInutiles,title=" skipped"
	SetVariable C_NbLettresInutiles,help={"Number of unused letters before the index"}
	SetVariable C_NbLettresInutiles,limits={0,50,1},value=root:Ratio:V_NbLettresInutiles
	SetVariable C_NbLettresRacine,pos={28.00,194.00},size={72.00,14.00},proc=SetVarNomManip
	SetVariable C_NbLettresRacine,title=" exp. ID"
	SetVariable C_NbLettresRacine,help={"Number of letters forming the unique identifier of the experiment -> experiment name"}
	SetVariable C_NbLettresRacine,limits={5,20,1},value=root:Ratio:V_NbLettresRacine
	TitleBox C_NomPremierFichier,pos={94.00,156.00},size={124.00,19.00}
	TitleBox C_NomPremierFichier,help={"Name of the first file; used as template to define name structure"}
	TitleBox C_NomPremierFichier,variable=root:Ratio:S_NomPremierFichier
	GroupBox C_FileName,pos={22.00,218.00},size={272.00,134.00}
	GroupBox C_FileName,help={"How the name of each file is decomposed to read different time points and channels"}
	SetVariable C_Suffixe_A,pos={217.00,227.00},size={40.00,14.00},title=" "
	SetVariable C_Suffixe_A,value=root:Ratio:S_Suffixe_A
	TitleBox C_Extension,pos={263.00,228.00},size={20.00,13.00},title=".TIF"
	TitleBox C_Extension,fSize=11,frame=0
	SetVariable C_Suffixe_B,pos={217.00,248.00},size={40.00,14.00},title=" "
	SetVariable C_Suffixe_B,value=root:Ratio:S_Suffixe_B
	SetVariable C_Suffixe_C,pos={217.00,268.00},size={40.00,14.00},disable=1
	SetVariable C_Suffixe_C,title=" ",value=root:Ratio:S_Suffixe_C
	SetVariable C_Suffixe_D,pos={217.00,288.00},size={40.00,14.00},disable=1
	SetVariable C_Suffixe_D,title=" ",value=root:Ratio:S_Suffixe_D
	SetVariable C_Suffixe_E,pos={217.00,308.00},size={40.00,14.00},disable=1
	SetVariable C_Suffixe_E,title=" ",value=root:Ratio:S_Suffixe_E
	SetVariable C_Suffixe_F,pos={217.00,328.00},size={40.00,14.00},disable=1
	SetVariable C_Suffixe_F,title=" ",value=root:Ratio:S_Suffixe_F
	GroupBox C_TimeCalculation,pos={501.00,338.00},size={220.00,85.00}
	GroupBox C_TimeCalculation,title="How time is determined"
	GroupBox C_TimeCalculation,help={"How the name of each file is decomposed to read different time points and channels"}
	CheckBox C_Check_TimeDefault,pos={549.00,360.00},size={45.00,15.00},proc=CheckTimeSelector
	CheckBox C_Check_TimeDefault,title="Default"
	CheckBox C_Check_TimeDefault,help={"Time is read using the default method defined by \"Presets\""}
	CheckBox C_Check_TimeDefault,value=0,mode=1,side=1
	CheckBox C_Check_TimeFromFile,pos={515.00,380.00},size={79.00,15.00},proc=CheckTimeSelector
	CheckBox C_Check_TimeFromFile,title="From image file"
	CheckBox C_Check_TimeFromFile,help={"Use the time the image file is created (saved) on disk"}
	CheckBox C_Check_TimeFromFile,value=0,mode=1,side=1
	CheckBox C_Check_TimeRegular,pos={508.00,400.00},size={86.00,15.00},proc=CheckTimeSelector
	CheckBox C_Check_TimeRegular,title="Regularly spaced"
	CheckBox C_Check_TimeRegular,help={"Regularly spaced time-points"}
	CheckBox C_Check_TimeRegular,value=1,mode=1,side=1
	SetVariable C_TimeInterval,pos={618.00,400.00},size={90.00,14.00},proc=SetVarIntervalleTemps
	SetVariable C_TimeInterval,title="Interval (s)"
	SetVariable C_TimeInterval,help={"Sampling interval if regular sampling; NaN otherwise."}
	SetVariable C_TimeInterval,limits={0,inf,0},value=root:Ratio:V_DeltaT
	SetVariable C_TimeOffset,pos={618.00,380.00},size={90.00,14.00}
	SetVariable C_TimeOffset,title="Offset (sec)"
	SetVariable C_TimeOffset,help={"Time difference between file time-stamp and event time"}
	SetVariable C_TimeOffset,limits={0,inf,0},value=root:Ratio:V_TimeOffset
	CheckBox C_Check_VraiePileZ,pos={259.00,146.00},size={46.00,15.00},disable=1,proc=CheckProc_VraiePileZ
	CheckBox C_Check_VraiePileZ,title="Z stack"
	CheckBox C_Check_VraiePileZ,help={"Use the time the image file is created (saved) on disk"}
	CheckBox C_Check_VraiePileZ,value=0,mode=1,side=1
	CheckBox C_Check_VraiePileZFalse,pos={211.00,146.00},size={45.00,15.00},disable=1,proc=CheckProc_VraiePileZ
	CheckBox C_Check_VraiePileZFalse,title="≠ fields"
	CheckBox C_Check_VraiePileZFalse,help={"Use the time the image file is created (saved) on disk"}
	CheckBox C_Check_VraiePileZFalse,value=1,mode=1,side=1
	ToolsGrid visible=1,grid=(0,28.35,5)
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(503,38,717,302)/HOST=#  W_NumTrame,W_Temps,W_Exposition
	ModifyTable frameInset= 1,size=9,format(Point)=1,width(Point)=20,title(Point)="#"
	ModifyTable sigDigits(W_NumTrame)=3,width(W_NumTrame)=50,title(W_NumTrame)="File index"
	ModifyTable width(W_Temps)=50,title(W_Temps)="Time (s)",width(W_Exposition)=35,title(W_Exposition)="Expo."
	ModifyTable showParts=0xee
	ModifyTable horizontalIndex=2
	SetDataFolder fldrSav0
	RenameWindow #,T0
	SetActiveSubwindow ##
EndMacro

//	pour régler les éléments du panneau sur la bonne situation
Function Init_P_Initialisation()
Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	WAVE/SDFR=dfRatio D_UnifA, D_UnifB
	NVAR/SDFR=dfRatio V_NbFichiers, V_MoyUnifA
	SVAR/SDFR=dfRatio S_Type_Image, S_Chemin_Donnees, S_Chemin_Analyses, S_Chemin_JPEG, S_Chemin_Calcul, S_Racine_Locale, S_Chemin_Export, S_Extension
	variable i

	Execute "P_Initialisation()"	//	Creates the panel
	ModifyTable/W=P_Initialisation#T0 horizontalIndex=2
	HideTools/W=P_Initialisation/A

	PopupMenu C_TypeManip win=P_Initialisation, mode=1, disable=0
	Button C_BoutonFich1 win=P_Initialisation, disable=0
	PopupMenu C_Objectif win=P_Initialisation, mode=1, disable=0
	SetVariable C_NbChiffresFichier win=P_Initialisation,  disable=0
	CheckBox C_checkUnif value=0, win=P_Initialisation, disable=0
	PopupMenu C_Objectif win=P_Initialisation, disable=0
	PopupMenu C_ChoixServeurOuLocal win=P_Initialisation, mode=0
	CheckBox C_MiroirHorizontal, value= 0
	CheckBox C_MiroirVertical, value= 0
	Button C_BoutonChargePileTemps, disable=1
	TitleBox C_Extension,win=P_Initialisation,title=S_Extension

	//	Updates the checkboxes to match the value of related variable
	CheckMiroir("init",0)
	CheckTimeSelector("init", 0)
	CheckProc_VraiePileZ("init", 0)
	
	//	If S_Type_Image has already been defined, set the Popup to display the correct value
	PopupMenu C_TypeManip win=P_Initialisation, value=ksTypesAcquisition, mode=WhichListItem(S_Type_Image, ksTypesAcquisition)+1
	
	//	To update the titlebox with path info matching the right path definition
	PopMenuInitChemins("",0,"")
	
	//	To handle unif
	if (V_MoyUnifA==1)
		FastOp D_UnifA=1
		FastOp D_UnifB=1
		CheckBox C_checkUnif win=P_Initialisation, value=0
	endif
	if ( (NumType(V_MoyUnifA)==0) && (V_MoyUnifA!=1) )	//	an analysis has already been done with unif correction
//		CheckLitUnif("", 1)
		CheckBox C_checkUnif win=P_Initialisation, value=1	//	just check the box: at this stage, the correct path to data may be wrong
	endif
end

Window P_Evts() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(753,126,1104,905) as "Events"
	SetDrawLayer UserBack
	SetDrawEnv fsize= 10
	SetDrawEnv save
	SetDrawEnv fsize= 9,fstyle= 2
	DrawText 33,734,"time in min"
	DrawText 23,40,"External event file"
	SetDrawEnv fsize= 9
	DrawText 243,270,"text offset"
	GroupBox C_GroupeEvt2,pos={14.00,244.00},size={320.00,497.00},title="Event display"
	GroupBox C_GroupeEvt2,labelBack=(59656,63282,64769)
	GroupBox C_GroupeEvt,pos={14.00,5.00},size={319.00,234.00},title="External event file"
	GroupBox C_GroupeEvt,labelBack=(59656,63282,64769)
	Button C_LitEvt,pos={112.00,23.00},size={90.00,20.00},proc=BoutonLitEvt,title="Read evt file"
	Button C_LitEvt,fSize=11
	Button C_AjouteBarres,pos={20.00,260.00},size={80.00,20.00},proc=BoutonEvt,title="Add evt bars"
	Button C_AjouteBarres,help={"Adds the horizontal bars; useful if accidentally removed"}
	Button C_AjouteBarres,fSize=11
	Button C_EnleveEvt,pos={208.00,23.00},size={102.00,20.00},proc=BoutonEvt,title="Remove vert. bars"
	Button C_EnleveEvt,help={"Remove the original vertical bars"},fSize=11
	SetVariable C_Evt_OffX,pos={222.00,270.00},size={40.00,14.00},proc=SetVarEvt,title="X"
	SetVariable C_Evt_OffX,help={"Text offset : X"},value= root:Ratio:V_Evt_OffX
	SetVariable C_Evt_Justif1,pos={127.00,270.00},size={75.00,13.00},proc=SetVarEvt,title="Text just."
	SetVariable C_Evt_Justif1,help={"Label justification mode"},font="Helvetica"
	SetVariable C_Evt_Justif1,value= root:Ratio:V_Evt_Justif
	SetVariable C_Evt_Epaiss1,pos={127.00,290.00},size={75.00,13.00},proc=SetVarEvt,title="Line thick."
	SetVariable C_Evt_Epaiss1,help={"Thickness of the event line"},font="Helvetica"
	SetVariable C_Evt_Epaiss1,limits={0,8,0.2},value= root:Ratio:V_Evt_Epaiss
	SetVariable C_Evt_OffY,pos={270.00,270.00},size={40.00,14.00},proc=SetVarEvt,title="Y"
	SetVariable C_Evt_OffY,help={"Text offset : Y"},value= root:Ratio:V_Evt_OffY
	SetVariable C_Evt_Size,pos={231.00,290.00},size={80.00,13.00},proc=SetVarEvt,title="Marker size"
	SetVariable C_Evt_Size,help={"Size of the text used as marker. Different from font size, see help."}
	SetVariable C_Evt_Size,font="Helvetica"
	SetVariable C_Evt_Size,limits={0,8,0.2},value= root:Ratio:V_Evt_Size
	Button C_Aide_Events,pos={136.00,751.00},size={50.00,20.00},proc=BoutonAide,title="Help"
	Button C_Aide_Events,fSize=12,fStyle=1
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(20,47,319,232)/HOST=#  W_EvtTemps,W_Evt,W_EvtStr
	ModifyTable format(Point)=1,width(Point)=22,width(W_Evt)=46,width(W_EvtStr)=126
	SetDataFolder fldrSav0
	RenameWindow #,T0
	SetActiveSubwindow ##
	String fldrSav1= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(20,310,319,721)/HOST=#  W_EvtTempsCorr,W_EvtCorr,W_EvtStrCorr
	ModifyTable format(Point)=1,width(Point)=0,width(W_EvtTempsCorr)=80,width(W_EvtCorr)=46
	ModifyTable width(W_EvtStrCorr)=146
	SetDataFolder fldrSav1
	RenameWindow #,T1
	SetActiveSubwindow ##
EndMacro

Function Init_P_Evts()
	Execute "P_Evts()"
end

//	To display a table with all ROI parameters: Tag, plane, colors...
//	Window P_TableauROI() : Panel	... not very convenient because there are lots of waves that depend on dfROI; 
//	The window is therefore hard coded, using waves from the current ROI datafolder
Function Init_P_TableauROI()
	Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]; DFREF dfExport=W_DFREF[1]
//	AppendToTable/W=T_Group W_ListeElements.ld

	SetDataFolder dfROI
//	Wave W_Tag,W_IntensiteOK,W_PlanROI,W_PlanROIPileExterne,W_Intensite,W_AfficheROI,W_EpaisseurROI,W_AfficheTrace,W_EpaisseurTrace,W_ROI_Area, W_ROI_EllipseData
//	SetDimLabel 1, 0, A, W_Intensite
//	SetDimLabel 1, 1, B, W_Intensite
	
	NewPanel/N=P_TableauROI/W=(908,80,1773,478) as "ROI parameters"
	Button C_ToutesIntensitesOK,pos={76.00,370},size={55.00,20.00},proc=BoutonParamsROI
	Button C_ToutesIntensitesOK,title="all ROI OK"
	Button C_ToutesIntensitesOK,help={"intensity measurement is OK for all ROI"}
	Button C_ToutesIntensitesOK,fSize=9
	Button C_ToutesROI,pos={440,370},size={70.00,20.00},proc=BoutonParamsROI
	Button C_ToutesROI,title="set ROI thickn."
	Button C_ToutesROI,help={"set the thickness of all ROI to a same value"},fSize=9
	Button C_ToutesTraces,pos={570,370},size={70.00,20.00},proc=BoutonParamsROI
	Button C_ToutesTraces,title="set trace thickn."
	Button C_ToutesTraces,help={"set the thickness of all traces to a same value"}
	Button C_ToutesTraces,fSize=9
	Button C_MaJIntensite,pos={300,370},size={50.00,20.00},proc=BoutonProc_Intensite
	Button C_MaJIntensite,title="Update all"
	Button C_MaJIntensite,help={"Measures intensity on all ROI that are OK"}
	Edit/W=(18,18,843,364)/HOST=#  W_Tag,W_IntensiteOK,W_PlanROI,W_PlanROIPileExterne,W_Intensite,W_AfficheROI,W_EpaisseurROI,W_AfficheTrace,W_EpaisseurTrace,W_ROI_Area, W_ROI_EllipseData
	ModifyTable size=10,format(Point)=1,width(Point)=30,title(Point)="ROI #",width(W_Tag)=30
	ModifyTable title(W_Tag)="Tag #",width(W_IntensiteOK)=40,title(W_IntensiteOK)="Intens. OK"
	ModifyTable width(W_PlanROI)=70,title(W_PlanROI)="Plane # ratio",title(W_PlanROIPileExterne)="Plane # ext. stack",width(W_AfficheROI)=70
	ModifyTable title(W_AfficheROI)="Display ROI",width(W_EpaisseurROI)=70,title(W_EpaisseurROI)="ROI thickn."
	ModifyTable width(W_AfficheTrace)=60,title(W_AfficheTrace)="Display trace",width(W_EpaisseurTrace)=60
	ModifyTable title(W_EpaisseurTrace)="trace thickn."
	ModifyTable width(W_Intensite)=50, title(W_Intensite)="intensity"
	ModifyTable width(W_ROI_Area)=50, title(W_ROI_Area)="ROI area"
	ModifyTable width(W_ROI_EllipseData)=70, title(W_ROI_EllipseData)="Ellipse diameter"
	ModifyTable showParts=0x6b
	RenameWindow #,T0
	SetActiveSubwindow ##
End

Window F_Pile() : Graph
	PauseUpdate; Silent 1		// building window...
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Analyse_0:
	Display /W=(462,45,1834,1080)/K=1 /T as "Image stack"
	AppendImage/T ::Ratio:P_Pile
	ModifyImage P_Pile ctab= {*,*,Grays,0}
	SetDataFolder fldrSav0
	ModifyGraph margin(left)=-1,margin(bottom)=-1,margin(top)=-1,margin(right)=-1
	ModifyGraph mirror=0
	ModifyGraph nticks=0
	ModifyGraph minor=1
	ModifyGraph noLabel=2
	ModifyGraph fSize=9
	ModifyGraph standoff=0
	ModifyGraph axThick=0
	ModifyGraph tkLblRot(left)=90
	ModifyGraph btLen=3
	ModifyGraph tlOffset=-2
	SetAxis/A/R left
	Cursor/P/I A P_Pile 605,461;Cursor/P/I B P_Pile 739,563
	ControlBar 126
	ControlBar/L 60
	GroupBox C_groupDistance,pos={497.00,2.00},size={138.00,111.00}
	GroupBox C_groupDistance,title="Distance between cursors"
	GroupBox C_groupDistance,labelBack=(65535,65535,65535)
	GroupBox C_groupDisplay,pos={52.00,2.00},size={325.00,111.00},title="Display"
	GroupBox C_groupDisplay,labelBack=(65535,65535,65535)
	GroupBox C_groupMesures,pos={382.00,2.00},size={108.00,111.00}
	GroupBox C_groupMesures,title="Regions of interest"
	GroupBox C_groupMesures,labelBack=(65535,65535,65535)
	Slider C_Plan,pos={6.00,116.00},size={45.00,505.00},proc=SliderPlanPile
	Slider C_Plan,limits={0,39,1},value=0,side=2
	Slider C_IMin,pos={64.00,57.00},size={299.00,44.00},proc=SliderContrastePile
	Slider C_IMin,limits={0,1143,10},value=0,side=2,vert=0
	Slider C_IMax,pos={64.00,20.00},size={299.00,44.00},proc=SliderContrastePile
	Slider C_IMax,limits={0,3429,10},value=1143,vert=0
	Button C_MesureDistance,pos={523.00,36.00},size={70.00,20.00},proc=BoutonMesureDistance
	Button C_MesureDistance,title="Measure",fSize=11
	SetVariable C_NumROI,pos={401.00,20.00},size={75.00,16.00},proc=SetVarProc_PlanIntensite
	SetVariable C_NumROI,title="ROI #",help={"Current ROI"},fSize=11
	SetVariable C_NumROI,limits={1,12,1},value=root:Analyse_0:V_NumROI,textAlign=2
	SetVariable C_Tag,pos={426.00,43.00},size={50.00,16.00},proc=SetVarTag
	SetVariable C_Tag,title="tag"
	SetVariable C_Tag,help={"Affects the current ROI to the selected group; -1 means the ROI is considered background"}
	SetVariable C_Tag,fSize=11
	SetVariable C_Tag,limits={-1,3,1},value=root:Analyse_0:W_Tag[3],textAlign=1
	Button C_Aide_Image_stack,pos={4.00,4.00},size={43.00,16.00},proc=BoutonAide
	Button C_Aide_Image_stack,title="Help",fSize=9,fStyle=1
	Button C_Aide_Image_stack,fColor=(65535,65535,65535)
	SetVariable C_PlanOptimal,pos={445.00,66.00},size={31.00,16.00},bodyWidth=31,disable=2,proc=SetVarTag
	SetVariable C_PlanOptimal,title=" "
	SetVariable C_PlanOptimal,help={"Affects the current ROI to the selected group; -1 means the ROI is considered background"}
	SetVariable C_PlanOptimal,fSize=11
	SetVariable C_PlanOptimal,limits={0,40,0},value=root:Analyse_0:W_PlanROIPileExterne[3],textAlign=2
	SetVariable C_Distance,pos={512.00,70.00},size={100.00,14.00},disable=2
	SetVariable C_Distance,title="Distance (µM)"
	SetVariable C_Distance,limits={-inf,inf,0},value=root:Ratio:V_Distance
	CheckBox C_IntensiteOK,pos={396.00,89.00},size={80.00,16.00},proc=CheckProc_IntensiteOK
	CheckBox C_IntensiteOK,title="Intensity is valid",value=1,side=1
	Button C_SauvePlan,pos={393.00,66.00},size={50.00,18.00},title="Get plane",proc=BoutonProc_PlanOptimal
EndMacro

Function Init_F_Pile()
Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	NVAR/SDFR=dfROI V_NumROI, V_NbROI, V_SourceIntensite
	NVAR/SDFR=dfRatio V_NbChiffres, V_IMinP, V_IMaxP, V_Taille_X, V_Taille_Y, V_Distance
	Wave/SDFR=dfROI W_CouleurROI, W_Tag, W_PlanROIPileExterne, W_IntensiteOK
	Wave/SDFR=dfRatio P_Pile

	Variable j, vNbPlans=DimSize(P_Pile,2)
	String NomROIx, NomROIy

	Execute "F_Pile()"
	Slider C_Plan limits={0,vNbPlans-1,1}, value=0
	ModifyImage P_Pile ctab= {*,*,Grays,0}
	WaveStats/Q/M=1 P_Pile
	V_IMinP=V_Min
	V_IMaxP=V_Max
	Slider C_IMin limits={0, V_IMaxP,10}, value=V_IMinP
	Slider C_IMax limits={V_IMinP, V_IMaxP+(V_IMaxP-V_IMinP)*2,10},  value=V_IMaxP
	SetVariable C_NumROI value=dfROI:V_NumROI,limits={1,V_NbROI,1}
	SetVariable C_Tag value=W_Tag[V_NumROI]
	SetVariable C_PlanOptimal value=W_PlanROIPileExterne[V_NumROI], limits={0,(DimSize(P_Pile, 2)),1}
	CheckBox C_IntensiteOK,value=W_IntensiteOK[V_NumROI]
	
	Cursor/A=1/I A P_Pile (V_Taille_X*0.45), (V_Taille_Y*0.45)
	Cursor/A=1/I B P_Pile (V_Taille_X*0.55), (V_Taille_Y*0.55)
	SliderPlanPile("",0,1)	//	update image to show plane #0
end

Window P_PdV() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(916,45,1251,356) as "View points"
	SetDrawLayer UserBack
	SetDrawEnv fsize= 10
	SetDrawEnv save
	Button C_AjouteMarqueurs,pos={14.00,251.00},size={85.00,16.00},proc=BoutonPdV
	Button C_AjouteMarqueurs,title="Add time makers"
	Button C_AjouteMarqueurs,help={"Adds the position of time makers on the grah"}
	Button C_AjouteMarqueurs,fSize=9
	Button C_EnleveMarqueurs,pos={107.00,251.00},size={112.00,16.00},proc=BoutonPdV
	Button C_EnleveMarqueurs,title="Remove time markers"
	Button C_EnleveMarqueurs,help={"Remove the time markers on the graph"},fSize=9
	Button C_HauteurMarqueurs,pos={227.00,251.00},size={90.00,16.00},proc=BoutonPdV
	Button C_HauteurMarqueurs,title="Make same height"
	Button C_HauteurMarqueurs,help={"Sets all time makers at the height defined for the first one"}
	Button C_HauteurMarqueurs,fSize=9
	Button C_LitPdV,pos={30.00,212.00},size={68.00,20.00},proc=BoutonPdV
	Button C_LitPdV,title="Update"
	Button C_LitPdV,help={"Reads and analyzes only the datapoints in the table; speeds-up reanalysis"}
	Button C_LitPdV,fSize=11
	Button C_Aide_View_points,pos={136.00,275.00},size={50.00,20.00},proc=BoutonAide
	Button C_Aide_View_points,title="Help",fSize=12,fStyle=1
	Button C_ExportePdV,pos={129.00,212.00},size={80.00,20.00},proc=BoutonPdV
	Button C_ExportePdV,title="Export images"
	Button C_ExportePdV,help={"Export images to picture gallery, for making mosaic layout"}
	Button C_ExportePdV,fSize=11
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(7,9,311,207)/HOST=#  W_PointsDeVue,W_PointsDeVueStr
	ModifyTable format(Point)=1,width(Point)=32,width(W_PointsDeVue)=50,title(W_PointsDeVue)=" "
	ModifyTable width(W_PointsDeVueStr)=100
	SetDataFolder fldrSav0
	RenameWindow #,T0
	SetActiveSubwindow ##
EndMacro

Function Init_P_PdV()
	Execute "P_PdV()"
	CheckAffichePosition("", 1)	//	pour afficher le curseur de position
End

Window P_SelectionPlans() : Table
	PauseUpdate; Silent 1		// building window...
	SetDataFolder root:Ratio:
	Edit/W=(408,117,602,894) W_SelectionPlans as "Sélection de plans à afficher"
	ModifyTable format(Point)=1
EndMacro

Function Init_P_SelectionPlans()
	Execute "P_SelectionPlans()"
	if (!Autorisation())
		DoAlert 0, "Fonction désactivée"
		KillWindow P_SelectionPlans
		return(0)
	endif
End

Window P_Deplacement() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(791,45,1271,591) as "Movements"
	ModifyPanel cbRGB=(65314,62013,65053)
	SetDrawLayer UserBack
	DrawText 0,0,"vertical (z)"
	Button C_DessineRegDeplacement,pos={289.00,290.00},size={70.00,20.00},proc=BoutonInitDepDec
	Button C_DessineRegDeplacement,title="Add zone"
	Button C_DessineRegDeplacement,help={"Select a region with high contrast for automatic movement correction"}
	Button C_DessineRegDeplacement,fSize=10
	Button C_EffaceRegDeplacement,pos={378.00,290.00},size={70.00,20.00},proc=BoutonInitDepDec
	Button C_EffaceRegDeplacement,title="Clear zones"
	Button C_EffaceRegDeplacement,help={"Clear all selected regions"},fSize=10
	ValDisplay C_DeplacementX,pos={287.00,458.00},size={40.00,13.00},bodyWidth=30
	ValDisplay C_DeplacementX,title="x",limits={0,0,0},barmisc={0,1000}
	ValDisplay C_DeplacementX,value=_NUM:NaN
	ValDisplay C_DeplacementY,pos={346.00,458.00},size={39.00,13.00},bodyWidth=30
	ValDisplay C_DeplacementY,title="y",limits={0,0,0},barmisc={0,1000},value=#"NaN"
	Button C_Gauche,pos={314.00,435.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Gauche,title="\\W646",fSize=9
	Button C_Haut,pos={329.00,422.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Haut,title="\\W617",fSize=9
	Button C_Bas,pos={329.00,450.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Bas,title="\\W623",fSize=9
	Button C_Droite,pos={345.00,435.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Droite,title="\\W649",fSize=9
	Button C_Gauche1,pos={298.00,435.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Gauche1,title="\\W646",fSize=9
	Button C_Bas1,pos={329.00,467.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Bas1,title="\\W623",fSize=9
	Button C_Droite1,pos={361.00,435.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Droite1,title="\\W649",fSize=9
	Button C_Haut1,pos={329.00,403.00},size={17.00,16.00},proc=BoutonDeplacement
	Button C_Haut1,title="\\W617",fSize=9
	ValDisplay C_DeplacementZ,pos={351.00,410.00},size={39.00,13.00},bodyWidth=30,disable=2
	ValDisplay C_DeplacementZ,title="z",limits={0,0,0},barmisc={0,1000},value=#"NaN"
	Button C_BasZ,pos={392.00,419.00},size={17.00,16.00},disable=2,proc=BoutonDeplacement
	Button C_BasZ,title="\\W623",fSize=9
	Button C_HautZ,pos={392.00,402.00},size={17.00,16.00},disable=2,proc=BoutonDeplacement
	Button C_HautZ,title="\\W617",fSize=9
	Button C_TraiteCettePosition,pos={402.00,456.00},size={50.00,20.00},proc=BoutonAnalyse
	Button C_TraiteCettePosition,title="Update"
	Button C_TraiteCettePosition,help={"Computes image and makes measurements"}
	Button C_TraiteCettePosition,fSize=10
	Button C_EffaceDepCettePosition,pos={116.00,488.00},size={25.00,25.00},proc=BoutonEffaceDepDec
	Button C_EffaceDepCettePosition,title="\\K(65000,0,0)\\W623"
	Button C_EffaceDepCettePosition,help={"Clear correction for this datapoint"}
	Button C_EffaceDepCettePosition,fSize=20
	Button C_EffaceDepSuite,pos={150.00,488.00},size={25.00,25.00},proc=BoutonEffaceDepDec
	Button C_EffaceDepSuite,title="\\K(65000,0,0)\\W649"
	Button C_EffaceDepSuite,help={"Clear correction for all following datapoints"}
	Button C_EffaceDepSuite,fSize=20
	CheckBox C_CheckOptimiseZ,pos={295.00,100.00},size={60.00,16.00},disable=2
	CheckBox C_CheckOptimiseZ,title="Optimize Z",value=0,side=1
	Button C_EffaceDepAvant,pos={81.00,488.00},size={25.00,25.00},proc=BoutonEffaceDepDec
	Button C_EffaceDepAvant,title="\\K(65000,0,0)\\W546"
	Button C_EffaceDepAvant,help={"Clear correction for all preceding datapoints"}
	Button C_EffaceDepAvant,fSize=20
	GroupBox C_Groupe_Manuel,pos={270.00,380.00},size={200.00,124.00}
	GroupBox C_Groupe_Manuel,title="Manual movement correction"
	GroupBox C_Groupe_Efface,pos={68.00,462.00},size={122.00,66.00}
	GroupBox C_Groupe_Efface,title="Clear values"
	SetVariable C_Position0,pos={285.00,80.00},size={130.00,14.00},disable=2
	SetVariable C_Position0,title="Reference time-point"
	SetVariable C_Position0,help={"Time-point used as reference, ie zero movement."}
	SetVariable C_Position0,limits={-inf,inf,0},value=root:Ratio:V_Position0Deplacement
	SetVariable C_VoieRef,pos={295.00,60.00},size={100.00,14.00},disable=2
	SetVariable C_VoieRef,title="Reference channel"
	SetVariable C_VoieRef,help={"Channel used to perform the calculation"}
	SetVariable C_VoieRef,value=root:Ratio:S_VoieRefDeplacement
	Button C_OptimiseCettePosition,pos={319.00,329.00},size={120.00,20.00},proc=BoutonAnalyse
	Button C_OptimiseCettePosition,title="Optimize this point"
	Button C_OptimiseCettePosition,help={"When doing manual correction, calculates movement based on the current value"}
	Button C_OptimiseCettePosition,fSize=10
	CheckBox C_CheckOptimiseFromPrevious,pos={295.00,120.00},size={109.00,16.00}
	CheckBox C_CheckOptimiseFromPrevious,title="Optimize from previous"
	CheckBox C_CheckOptimiseFromPrevious,help={"Try to correct the movement based on the previous datapoint"}
	CheckBox C_CheckOptimiseFromPrevious,value=1,side=1
	TabControl C_OngletModeDep,pos={280.00,30.00},size={180.00,130.00},proc=OngletDeplacement
	TabControl C_OngletModeDep,labelBack=(65278,61937,65021),tabLabel(0)="by zone"
	TabControl C_OngletModeDep,tabLabel(1)="global",value=0
	GroupBox C_Groupe_Automatic,pos={270.00,10.00},size={200.00,354.00}
	GroupBox C_Groupe_Automatic,title="Automatic movement correction"
	GroupBox C_Groupe_Zones,pos={280.00,160.00},size={180.00,160.00}
	GroupBox C_Groupe_Zones,title="Zone(s) for automatic correction"
	Button C_Aide_Movement_correction,pos={347.00,512.00},size={70.00,20.00},proc=BoutonAide
	Button C_Aide_Movement_correction,title="Help",fSize=10
	SetVariable C_Grossierete,pos={295.00,140.00},size={90.00,14.00}
	SetVariable C_Grossierete,title="Coarseness"
	SetVariable C_Grossierete,help={"Coarseness of the pyramid optimization; high -> faster but less precise."}
	SetVariable C_Grossierete,limits={1,8,1},value=root:Ratio:V_GrossiereteDep
	ValDisplay valdisp0,pos={390.00,140.00},size={14.00,13.00}
	ValDisplay valdisp0,limits={5,100,30},barmisc={0,0},mode=1,highColor=(1,12815,52428),lowColor=(52428,1,1),zeroColor=(19675,39321,1)
	ValDisplay valdisp0,value=#"root:ratio:V_GrossiereteDepOK"
	DefineGuide UGV0={FL,318},UGV1={FL,1,UGV0},UGH0={FB,-243}
	ToolsGrid grid=(0,28.35,5)
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Display/W=(10,10,260,260)/HOST=#  W_Deplacement[*][1] vs W_Deplacement[*][0]
	SetDataFolder fldrSav0
	ModifyGraph margin(top)=20,frameStyle=1,frameInset=1
	ModifyGraph mode=4
	ModifyGraph rgb=(0,0,0)
	ModifyGraph standoff=0
	Label left "Pixels"
	Label bottom "Pixels"
	Cursor/P A W_Deplacement 0
	SetDrawLayer UserFront
	SetDrawEnv xcoord= abs,ycoord= abs,fsize= 9,fstyle= 2
	DrawText 0,13,"horizontal (xy)"
	RenameWindow #,F_Deplacement
	SetActiveSubwindow ##
	String fldrSav1= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Display/W=(10,270,260,449)/HOST=#  W_Deplacement[*][2] vs W_Temps_min
	SetDataFolder fldrSav1
	ModifyGraph margin(top)=20,frameStyle=1,frameInset=1
	ModifyGraph mode=4
	ModifyGraph rgb=(0,0,0)
	ModifyGraph standoff=0
	Label left "Pixels"
	Label bottom "Time points"
	Cursor/P A W_Deplacement 0
	SetDrawLayer UserFront
	SetDrawEnv xcoord= abs,ycoord= abs,fsize= 9,fstyle= 2
	DrawText 0,13,"vertical (z)"
	RenameWindow #,F_DeplacementZ
	SetActiveSubwindow ##
	String fldrSav2= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(287,180,449,281)/HOST=#  W_ZoneRefDeplacement
	ModifyTable size=9,width=30,format(Point)=1,title(W_ZoneRefDeplacement)=" "
	ModifyTable showParts=0x80
	SetDataFolder fldrSav2
	RenameWindow #,T_ZoneRefDeplacement
	SetActiveSubwindow ##
EndMacro

Function Init_P_Deplacement()
Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	NVAR/SDFR=dfRatio V_NbPlans, V_MethodeDeplacement
	string sFormule
	
	Execute "P_Deplacement()"
	ValDisplay C_DeplacementX,value= #"root:Ratio:V_DeplacementX"
	ValDisplay C_DeplacementY,value= #"root:Ratio:V_DeplacementY"
	ValDisplay C_DeplacementZ,value= #"root:Ratio:V_DeplacementZ"
	if (V_NbPlans>1)
		ValDisplay C_DeplacementZ disable=0
		Button C_HautZ disable=0
		Button C_BasZ disable=0
		CheckBox C_CheckOptimiseZ win=P_Deplacement, disable=0, value=1
	else
		ValDisplay C_DeplacementZ win=P_Deplacement, disable=2
		Button C_HautZ win=P_Deplacement, disable=2
		Button C_BasZ win=P_Deplacement, disable=2
		CheckBox C_CheckOptimiseZ win=P_Deplacement, disable=2, value=0
	endif
	CheckBox C_CheckOptimiseFromPrevious win=P_Deplacement, value=1
	
	//	Initialize valdisplay formula
	sFormule="root:Ratio:W_Deplacement[root:Ratio:V_NumCoucheCourante][0]"
	ValDisplay C_DeplacementX, win=P_Deplacement, value=#sFormule
	sFormule="root:Ratio:W_Deplacement[root:Ratio:V_NumCoucheCourante][1]"
	ValDisplay C_DeplacementY, win=P_Deplacement, value=#sFormule
	sFormule="root:Ratio:W_Deplacement[root:Ratio:V_NumCoucheCourante][2]"
	ValDisplay C_DeplacementZ, win=P_Deplacement, value=#sFormule
	
	//	Initialize tabs for method selection
	TabControl C_OngletModeDep, value=V_MethodeDeplacement
	OngletDeplacement("",V_MethodeDeplacement)
End

Window P_Decalage() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(791,45,1356,320) as "Registration"
	ModifyPanel cbRGB=(59795,61031,65535)
	ValDisplay C_DeplacementX,pos={268.00,78.00},size={40.00,13.00},bodyWidth=25
	ValDisplay C_DeplacementX,title="dx",limits={0,0,0},barmisc={0,1000}
	ValDisplay C_DeplacementX,value=_NUM:NaN
	ValDisplay C_DeplacementY,pos={330.00,77.00},size={39.00,13.00},bodyWidth=25
	ValDisplay C_DeplacementY,title="dy",limits={0,0,0},barmisc={0,1000}
	ValDisplay C_DeplacementY,value=_NUM:NaN
	Button C_Haut2,pos={311.00,41.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Haut2,title="\\W617",fSize=9
	Button C_Haut3,pos={311.00,24.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Haut3,title="\\W617",fSize=9
	Button C_Droite2,pos={327.00,57.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Droite2,title="\\W649",fSize=9
	Button C_Droite3,pos={343.00,57.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Droite3,title="\\W649",fSize=9
	Button C_Gauche2,pos={297.00,57.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Gauche2,title="\\W646",fSize=9
	Button C_Gauche3,pos={280.00,57.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Gauche3,title="\\W646",fSize=9
	Button C_Bas2,pos={311.00,72.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Bas2,title="\\W623",fSize=9
	Button C_Bas3,pos={311.00,90.00},size={17.00,16.00},proc=BoutonDecalage
	Button C_Bas3,title="\\W623",fSize=9
	SetVariable C_SetRes,pos={271.00,30.00},size={36.00,14.00},bodyWidth=17
	SetVariable C_SetRes,title="Res",help={"Resampling level"}
	SetVariable C_SetRes,limits={1,10,0},value=root:Ratio:V_Res
	Button C_BoutonDecalageTous,pos={277.00,133.00},size={75.00,30.00},proc=BoutonDecalagePartout
	Button C_BoutonDecalageTous,title="Apply to\rall images"
	Button C_BoutonDecalageTous,help={"Apply the same registration value to all images; for stable conditions, to save calculation time"}
	Button C_BoutonDecalageTous,fSize=9
	Button C_DessineRegDecalage,pos={390.00,27.00},size={75.00,20.00},proc=BoutonInitDepDec
	Button C_DessineRegDecalage,title="Select. region"
	Button C_DessineRegDecalage,help={"Use marquee to select a region with high contrast and rainbow effect"}
	Button C_DessineRegDecalage,fSize=10
	Button C_EffaceDecCettePosition,pos={306.00,198.00},size={25.00,25.00},proc=BoutonEffaceDepDec
	Button C_EffaceDecCettePosition,title="\\K(65000,0,0)\\W623"
	Button C_EffaceDecCettePosition,help={"Clear registration values for the current datapoint"}
	Button C_EffaceDecCettePosition,fSize=20
	Button C_EffaceDecSuite,pos={340.00,198.00},size={25.00,25.00},proc=BoutonEffaceDepDec
	Button C_EffaceDecSuite,title="\\K(65000,0,0)\\W649"
	Button C_EffaceDecSuite,help={"Clear registration values for the following datapoints"}
	Button C_EffaceDecSuite,fSize=20
	Button C_EffaceRegDecalage,pos={471.00,27.00},size={75.00,20.00},proc=BoutonInitDepDec
	Button C_EffaceRegDecalage,title="Erase regions"
	Button C_EffaceRegDecalage,help={"Erase the regions previously selected for automatic registration"}
	Button C_EffaceRegDecalage,fSize=10
	GroupBox C_AutoReg,pos={381.00,5.00},size={175.00,159.00}
	GroupBox C_AutoReg,title="Automatic registration"
	GroupBox C_ManualReg,pos={264.00,5.00},size={110.00,114.00}
	GroupBox C_ManualReg,title="Manual registration"
	CheckBox C_Skew,pos={427.00,141.00},size={73.00,16.00},title="Allow skewing"
	CheckBox C_Skew,help={"Enable skewing (stretching) of the image for better registration"}
	CheckBox C_Skew,value=0
	Button C_EffaceDecAvant,pos={271.00,198.00},size={25.00,25.00},proc=BoutonEffaceDepDec
	Button C_EffaceDecAvant,title="\\K(65000,0,0)\\W546"
	Button C_EffaceDecAvant,help={"Clear registration values before the current datapoint"}
	Button C_EffaceDecAvant,fSize=20
	GroupBox C_Groupe_Efface,pos={264.00,174.00},size={110.00,66.00}
	GroupBox C_Groupe_Efface,title="Clear values"
	Button C_Aide_Image_registration,pos={428.00,221.00},size={70.00,20.00},proc=BoutonAide
	Button C_Aide_Image_registration,title="Help",fSize=10
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Display/W=(10,10,260,260)/HOST=#  W_Decalage[*][1] vs W_Decalage[*][0]
	SetDataFolder fldrSav0
	ModifyGraph frameStyle=1,frameInset=1
	ModifyGraph mode=3
	ModifyGraph marker=11
	ModifyGraph rgb=(0,0,0)
	ModifyGraph standoff=0
	Label left "Pixels"
	Label bottom "Pixels"
	Cursor/P A W_Decalage 0
	RenameWindow #,F_Decalage
	SetActiveSubwindow ##
	String fldrSav1= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(389,51,545,133)/HOST=#  W_ZoneRefDecalage
	ModifyTable format(Point)=1,width(Point)=32,size(W_ZoneRefDecalage)=9,width(W_ZoneRefDecalage)=31
	ModifyTable title(W_ZoneRefDecalage)=" "
	ModifyTable showParts=0x80
	SetDataFolder fldrSav1
	RenameWindow #,T0
	SetActiveSubwindow ##
EndMacro

Function Init_P_Decalage()
	string sFormule
	Execute "P_Decalage()"

	sFormule="root:Ratio:W_Decalage[root:Ratio:V_NumCoucheCourante][0]"
	ValDisplay C_DeplacementX,value= #sFormule
	sFormule="root:Ratio:W_Decalage[root:Ratio:V_NumCoucheCourante][1]"
	ValDisplay C_DeplacementY,value= #sFormule
End

//Window P_DeplaceROI() : Panel
//	PauseUpdate; Silent 1		// building window...
//	NewPanel /W=(913,45,1105,401) as "Moving ROI"
//	SetDrawLayer UserBack
//	SetDrawEnv fsize= 9
//	DrawText 20,258,"Continue to:"
//	SetDrawEnv fsize= 9
//	DrawText 15,271,"left : nada : right"
//	SetDrawEnv fsize= 9
//	DrawText 65,107,"vertical"
//	SetDrawEnv fsize= 9
//	DrawText 20,144,"propagate to:"
//	SetDrawEnv fsize= 9
//	DrawText 15,157,"left : nada : right"
//	Button C_Gauche4,pos={30.00,58.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Gauche4,title="\\W646",fSize=9
//	Button C_Haut4,pos={45.00,45.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Haut4,title="\\W617",fSize=9
//	Button C_Bas4,pos={45.00,73.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Bas4,title="\\W623",fSize=9
//	Button C_Gauche5,pos={14.00,58.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Gauche5,title="\\W646",fSize=9
//	Button C_Bas5,pos={45.00,90.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Bas5,title="\\W623",fSize=9
//	Button C_Haut5,pos={45.00,26.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Haut5,title="\\W617",fSize=9
//	Button C_Droite4,pos={61.00,58.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Droite4,title="\\W649",fSize=9
//	Button C_Droite5,pos={77.00,58.00},size={17.00,16.00},proc=BoutonDeplaceROI
//	Button C_Droite5,title="\\W649",fSize=9
//	CheckBox C_CheckDepROI_Gauche,pos={31.00,273.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
//	CheckBox C_CheckDepROI_Gauche,title=""
//	CheckBox C_CheckDepROI_Gauche,help={"Movements are propagated to earlier datapoints"}
//	CheckBox C_CheckDepROI_Gauche,value=0,mode=1
//	CheckBox C_CheckDepROI_Milieu,pos={54.00,273.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
//	CheckBox C_CheckDepROI_Milieu,title=""
//	CheckBox C_CheckDepROI_Milieu,help={"Only changes the current datapoint"}
//	CheckBox C_CheckDepROI_Milieu,value=1,mode=1
//	CheckBox C_CheckDepROI_Droite,pos={77.00,273.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
//	CheckBox C_CheckDepROI_Droite,title=""
//	CheckBox C_CheckDepROI_Droite,help={"Movements are propagated to later datapoints"}
//	CheckBox C_CheckDepROI_Droite,value=0,mode=1
//	Button C_PoursuiteAuto,pos={18.00,221.00},size={60.00,20.00},proc=BoutonDeplaceROI
//	Button C_PoursuiteAuto,title="Optimise",fSize=11
//	Button C_HautZ4,pos={73.00,82.00},size={17.00,16.00},disable=2,proc=BoutonDeplaceROI
//	Button C_HautZ4,title="\\W617",fSize=9
//	Button C_BasZ4,pos={73.00,108.00},size={17.00,16.00},disable=2,proc=BoutonDeplaceROI
//	Button C_BasZ4,title="\\W623",fSize=9
//	Button C_EffaceDep,pos={120.00,260.00},size={43.00,16.00},proc=BoutonDeplaceROI
//	Button C_EffaceDep,title="\\K(52428,1,1)Efface",fSize=9
//	Button C_AfficheDep,pos={120.00,205.00},size={43.00,16.00},proc=BoutonDeplaceROI
//	Button C_AfficheDep,title="Display",fSize=9
//	CheckBox C_PropageDepROI,pos={30.00,295.00},size={58.00,16.00},title="Propagate"
//	CheckBox C_PropageDepROI,help={"Automatically propagates the movement"}
//	CheckBox C_PropageDepROI,value=1,side=1
//	Button C_CopieDep,pos={120.00,231.00},size={43.00,16.00},proc=BoutonDeplaceROI
//	Button C_CopieDep,title="Copy",fSize=9
//	SetVariable C_MargeROIMobile,pos={18.00,204.00},size={70.00,14.00}
//	SetVariable C_MargeROIMobile,title="Margin"
//	SetVariable C_MargeROIMobile,limits={0.4,3,0.2},value=root:Ratio:V_MargeROIMobile
//	GroupBox C_GroupeAutomatique,pos={8.00,185.00},size={105.00,142.00}
//	GroupBox C_GroupeAutomatique,title="Automatic tracking"
//	CheckBox C_CheckDepROI_Gauche1,pos={31.00,159.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
//	CheckBox C_CheckDepROI_Gauche1,title=""
//	CheckBox C_CheckDepROI_Gauche1,help={"This adjustment is propagated to all preceding datapoints"}
//	CheckBox C_CheckDepROI_Gauche1,value=0,mode=1
//	CheckBox C_CheckDepROI_Milieu1,pos={54.00,159.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
//	CheckBox C_CheckDepROI_Milieu1,title=""
//	CheckBox C_CheckDepROI_Milieu1,help={"Changes only the current datapoint"}
//	CheckBox C_CheckDepROI_Milieu1,value=1,mode=1
//	CheckBox C_CheckDepROI_Droite1,pos={77.00,159.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
//	CheckBox C_CheckDepROI_Droite1,title=""
//	CheckBox C_CheckDepROI_Droite1,help={"This adjustment is propagated to all datapoints following this one"}
//	CheckBox C_CheckDepROI_Droite1,value=0,mode=1
//	GroupBox C_GroupeManuel,pos={8.00,6.00},size={105.00,176.00},title="Manual"
//	Button C_Aide_ROI_tracking,pos={124.00,291.00},size={30.00,18.00},proc=BoutonAide
//	Button C_Aide_ROI_tracking,title="Help",fSize=9,fStyle=1,fColor=(65535,0,0)
//EndMacro

//Function Init_P_DeplaceROI()
//	Wave/DF W_DFREF=root:W_DFREF
//	DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
//
//	NVAR/SDFR=dfRatio V_NbPlans, V_PropageDepROI
//	NVAR/SDFR=dfROI V_Position0DeplaceROI
//
//	Execute "P_DeplaceROI()"
//	
//	V_PropageDepROI=0
//	CheckBox C_CheckDepROI_Gauche win=P_DeplaceROI, value=0
//	CheckBox C_CheckDepROI_Milieu win=P_DeplaceROI, value=1
//	CheckBox C_CheckDepROI_Droite win=P_DeplaceROI, value=0
//	CheckBox C_CheckDepROI_Gauche1 win=P_DeplaceROI, value=0
//	CheckBox C_CheckDepROI_Milieu1 win=P_DeplaceROI, value=1
//	CheckBox C_CheckDepROI_Droite1 win=P_DeplaceROI, value=0
//	CheckBox C_PropageDepROI win=P_DeplaceROI, value=1
//	Button C_Bas4 win=P_DeplaceROI, disable =0
//	Button C_Bas5 win=P_DeplaceROI, disable =0
//	Button C_Haut4 win=P_DeplaceROI, disable =0
//	Button C_Haut5 win=P_DeplaceROI, disable =0
//	Button C_Gauche4 win=P_DeplaceROI, disable =0
//	Button C_Gauche5 win=P_DeplaceROI, disable =0
//	Button C_Droite4 win=P_DeplaceROI, disable =0
//	Button C_Droite5 win=P_DeplaceROI, disable =0
//	if (V_NbPlans>1)
//		Button C_HautZ4 win=P_DeplaceROI, disable =0
//		Button C_BasZ4 win=P_DeplaceROI, disable =0
//	else
//		Button C_HautZ4 win=P_DeplaceROI, disable =2
//		Button C_BasZ4 win=P_DeplaceROI, disable =2
//	endif
//End

//Window P_Derive_Base() : Panel
//	PauseUpdate; Silent 1		// building window...
//	SetDataFolder root:Ratio:
//	NewPanel /W=(997,44,1213,267) as "Baseline correction"
//	GroupBox C_Moyenne_Temps1,pos={14,38},size={165,68},title="Selection mask"
//	GroupBox C_Moyenne_Temps1,labelBack=(65535,64386,57615)
//	Button C_EffaceMasque,pos={20,77},size={75,20},proc=BoutonLigneDeBase,title="Deselect"
//	Button C_EffaceMasque,help={"Unmark datapoints between cursors"}
//	Button C_EffaceMasque,fSize=10
//	Button C_MarqueZone,pos={19,54},size={75,20},proc=BoutonLigneDeBase,title="Select"
//	Button C_MarqueZone,help={"Mark datapoints betweek cursors for baseline correction."}
//	Button C_MarqueZone,fSize=10
//	Button C_EffaceToutMasque,pos={99,71},size={75,30},proc=BoutonLigneDeBase,title="Deselect\rall"
//	Button C_EffaceToutMasque,help={"Deselect all points."},fSize=10
//	PopupMenu C_DeriveTag,pos={103,16},size={76,20},proc=PopMenuInitBase,title="group"
//	PopupMenu C_DeriveTag,help={"Select group to correct for baseline drift."}
//	PopupMenu C_DeriveTag,mode=1,popvalue="--",value= #"\"--;0;1;2;3\""
//	Button C_Execute,pos={20,108},size={130,20},proc=BoutonLigneDeBase,title="Calculate baseline"
//	Button C_Execute,help={"Calcule la ligne de base théorique."},fSize=10
//	Button C_CorrigeDerive,pos={19,134},size={130,20},proc=BoutonLigneDeBase,title="Correct baseline"
//	Button C_CorrigeDerive,help={"Apply the correction to all traces."}
//	Button C_CorrigeDerive,fSize=10
//	Button C_SauveTraces,pos={20,16},size={75,20},proc=BoutonSauveTraces,title="\\f01Save traces"
//	Button C_SauveTraces,help={"Save each trace as trace???_SOS."}
//	Button C_SauveTraces,fSize=10,fColor=(65535,16385,16385)
//	Button C_AnnuleDerive,pos={20,157},size={130,20},proc=BoutonLigneDeBase,title="Cancel baseline correction"
//	Button C_AnnuleDerive,help={"Revert to SOS traces."}
//	Button C_AnnuleDerive,fSize=10
//EndMacro
//
//Function Init_P_Derive_Base()
//	Execute "P_Derive_Base()"
//end

Window P_Masquage() : Panel
	PauseUpdate; Silent 1		// building window...
	SetDataFolder root:Ratio:
	NewPanel /W=(1513,44,1908,326) as "Masquage"
	ModifyPanel cbRGB=(56797,56797,56797)
	Button C_DessineRegMasque,pos={282.00,12.00},size={80.00,20.00},proc=BoutonMasquage,title="Sélect. région"
	Button C_DessineRegMasque,help={"sélectionne une région à fort contraste qui sert à la correction automatique"}
	Button C_DessineRegMasque,fSize=10
	Button C_ValideMasque,pos={284.00,38.00},size={80.00,20.00},proc=BoutonMasquage,title="valide région"
	Button C_ValideMasque,help={"valide cette région"},fSize=10
	SetVariable C_PlanMax,pos={266.00,71.00},size={83.00,14.00},bodyWidth=38,title="plan max"
	SetVariable C_PlanMax,limits={0,100,1},value= K1
	Button C_EffacePlan,pos={284.00,129.00},size={80.00,20.00},proc=BoutonMasquage,title="efface ce plan"
	Button C_EffacePlan,help={"valide cette région"},fSize=10
	Button C_Lisse,pos={284.00,162.00},size={80.00,20.00},proc=BoutonMasquage,title="lisse"
	Button C_Lisse,help={"valide cette région"},fSize=10
	SetVariable C_PlanMin,pos={269.00,91.00},size={80.00,14.00},bodyWidth=38,title="plan min"
	SetVariable C_PlanMin,limits={0,100,1},value= K2
	Display/W=(10,10,210,210)/HOST=# 
	AppendImage/T P_Masque
	ModifyImage P_Masque ctab= {*,*,Grays,0}
	ModifyGraph margin(left)=-1,margin(bottom)=-1,margin(top)=-1,margin(right)=-1
	ModifyGraph mirror=0
	ModifyGraph nticks=0
	ModifyGraph noLabel=2
	ModifyGraph standoff=0
	ModifyGraph axThick=0
	SetAxis/A/R left
	RenameWindow #,G0
	SetActiveSubwindow ##
EndMacro

Function Init_P_Masquage()
Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	NVAR/SDFR=dfRatio V_Taille_X, V_Taille_Y, V_NbPlans
	if (!Autorisation())
		DoAlert 0, "Fonction à débugger"
		return(0)
	endif
	Execute "P_Masquage()"
	if (!WaveExists(P_Masque))
		Make/N=(V_Taille_X, V_Taille_Y, V_NbPlans) P_Masque
		P_Masque=1
	endif
End


Window P_Export() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /K=1 /W=(986,44,1247,645) as "Measurement export"
	SetDrawLayer UserBack
	SetDrawEnv fsize= 11
	DrawText 18,347,"For cursor mode 1 or 3:"
	SetDrawEnv fsize= 11
	DrawText 22,187,"Directly enter the positions:"
	SetDrawEnv fsize= 11
	DrawText 19,371,"For cursor mode 4:"
	CheckBox C_CheckCurs1,pos={24.00,40.00},size={39.00,15.00},proc=CheckModeCurseur,title="Ratio"
	CheckBox C_CheckCurs1,value= 1,mode=1
	CheckBox C_CheckCurs2,pos={24.00,61.00},size={95.00,15.00},proc=CheckModeCurseur,title="D1/D2 separation"
	CheckBox C_CheckCurs2,value= 0,mode=1
	CheckBox C_CheckCurs0,pos={24.00,19.00},size={31.00,15.00},proc=CheckModeCurseur,title="Off"
	CheckBox C_CheckCurs0,value= 0,mode=1
	CheckBox C_CheckCurs3,pos={24.00,83.00},size={87.00,15.00},proc=CheckModeCurseur,title="D1 and D2 peak"
	CheckBox C_CheckCurs3,value= 0,mode=1
	CheckBox C_CheckCurs4,pos={24.00,106.00},size={51.00,15.00},proc=CheckModeCurseur,title="5 zones"
	CheckBox C_CheckCurs4,value= 0,mode=1
	Button C_Aide_Cursor_measurements,pos={132.00,93.00},size={40.00,20.00},proc=BoutonAide,title="\\f02\\f03Help"
	Button C_Aide_Cursor_measurements,help={"Description of cursors and statistics"},fSize=10
	PopupMenu C_DF_Export,pos={69.00,16.00},size={157.00,23.00},proc=PopMenuSelectExport
	PopupMenu C_DF_Export,help={"To create and select several independent sets of cursors and measurement exports"}
	PopupMenu C_DF_Export,fSize=12
	PopupMenu C_DF_Export,mode=6,popvalue="No selection",value= #"ListeDFExport()"
	Button C_StatsRatio,pos={35.00,454.00},size={60.00,20.00},proc=BoutonStatsRatio,title="\\Z13\\f01Do it"
	Button C_StatsRatio,help={"Calculates ratio measurements with current cursor position"}
	Button C_StatsRatio,fSize=10
	Button C_SuperposeCsrEF,pos={138.00,333.00},size={45.00,16.00},proc=BoutonCopieValeursCurseurs,title="EF=AB"
	Button C_SuperposeCsrEF,help={"Overlay EF on AB"},fSize=10
	SetVariable C_PosCsrB,pos={22.00,194.00},size={160.00,14.00},proc=SetVarZoomCurseur,title="B (absolute point number)"
	SetVariable C_PosCsrB,value= _NUM:139
	Button C_ZoomeSurB,pos={17.00,149.00},size={160.00,20.00},proc=BoutonZoomeSurB,title="Zoom on current B position"
	Button C_ZoomeSurB,fSize=11
	Button C_DeZoomePic,pos={33.00,304.00},size={150.00,20.00},proc=BoutonZoomeSurB,title="De-zoom"
	Button C_DeZoomePic,fSize=11
	SetVariable C_PosCsrA,pos={22.00,234.00},size={160.00,14.00},proc=SetVarZoomCurseur,title="A (before, relative to B)"
	SetVariable C_PosCsrA,value= _NUM:9
	SetVariable C_PosCsrC,pos={22.00,254.00},size={160.00,14.00},proc=SetVarZoomCurseur,title="C (after, relative to B)"
	SetVariable C_PosCsrC,value= _NUM:4
	SetVariable C_PosCsrD,pos={22.00,274.00},size={160.00,14.00},proc=SetVarZoomCurseur,title="D (after, relative to B)"
	SetVariable C_PosCsrD,value= _NUM:7
	Button C_SuperposeCsrGH,pos={190.00,333.00},size={45.00,16.00},proc=BoutonCopieValeursCurseurs,title="GH=end"
	Button C_SuperposeCsrGH,help={"Put GH at the end of the recording"},fSize=10
	SetVariable C_PosCsrB_Temps,pos={22.00,214.00},size={150.00,14.00},proc=SetVarZoomCurseur,title="B (raw time in min)"
	SetVariable C_PosCsrB_Temps,limits={0,inf,0},value= _NUM:0
	GroupBox C_Groupe_Curseur,pos={9.00,132.00},size={240.00,282.00},title="Cursor position"
	PopupMenu C_ChoixAffichage,pos={3.00,429.00},size={199.00,23.00},title="Display:"
	PopupMenu C_ChoixAffichage,help={"Selects what type of trace to display; does NOT affect the calculations."}
	PopupMenu C_ChoixAffichage,mode=1,popvalue="normalize Rmin/Rmax",value= #"\"normalize Rmin/Rmax;subtract AB baseline and norm;raw ratio\""
	Button C_StatsRatio1,pos={122.00,454.00},size={50.00,20.00},proc=BoutonTermineStats,title="\\Z11Close"
	Button C_StatsRatio1,help={"Closes stats windows"},fSize=10
	Button C_Copie,pos={119.00,356.00},size={72.00,16.00},proc=BoutonCopieValeursCurseurs,title="copy mode 1"
	Button C_Copie,help={"Get GH and IJ from EF and GH"},fSize=10
	Button C_CopieAutreReglage,pos={46.00,379.00},size={112.00,16.00},proc=BoutonCopieValeursCurseurs,title="copy from other set"
	Button C_CopieAutreReglage,help={"Get GH and IJ from EF and GH"},fSize=10
EndMacro

Function Init_P_Export()
	Execute "P_Export()"
	CheckBox C_CheckCurs2, disable=2	//	Curseur 2 désactivé car pas débuggé
	CheckBox C_CheckCurs3, disable=2	//	Curseur 3 désactivé car pas débuggé
	PopMenuSelectExport("", 0, "Vide")	//	pour initialiser le panneau proprement
	CheckAffichePosition("",0)	//	Désactive le curseur temps
End

Window P_Recadrage_Image() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(782,45,1241,368) as "Zoom"
	SetDrawLayer UserBack
	SetDrawEnv fillpat= 10,fillfgc= (26214,26214,26214)
	DrawRect 87,78,258,194
	DrawRect 119,102,185,140
	SetDrawEnv linethick= 2
	DrawLine 121,56,121,98
	SetDrawEnv linethick= 2
	DrawLine 186,145,186,211
	SetDrawEnv linethick= 2
	DrawLine 67,103,112,103
	SetDrawEnv linethick= 2
	DrawLine 193,140,270,140
	SetDrawEnv linethick= 2,arrow= 3
	DrawLine 124,252,187,252
	SetDrawEnv linethick= 2
	DrawLine 121,150,121,214
	SetDrawEnv linethick= 2
	DrawLine 194,103,269,103
	SetDrawEnv linethick= 2,arrow= 3
	DrawLine 361,97,361,140
	Button C_SauveRecadrage,pos={22.00,290.00},size={90.00,20.00},proc=BoutonZoom,title="Get from image"
	Button C_SauveRecadrage,help={"Get marquee position from the image"},fSize=11
	Button C_AppliqueRecadrage,pos={130.00,290.00},size={90.00,20.00},proc=BoutonZoom,title="Resize display"
	Button C_AppliqueRecadrage,help={"Resize the window axes to X1 X2 Y1 Y2 values."}
	Button C_AppliqueRecadrage,fSize=11
	SetVariable C_PosCadreX1,pos={91.00,35.00},size={60.00,14.00},proc=SetVarZoom,title="X1"
	SetVariable C_PosCadreX1,limits={0,inf,1},value= root:Ratio:V_PosZoomX1
	SetVariable C_PosCadreX2,pos={158.00,215.00},size={60.00,14.00},proc=SetVarZoom,title="X2"
	SetVariable C_PosCadreX2,limits={0,inf,1},value= root:Ratio:V_PosZoomX2
	SetVariable C_PosCadreY1,pos={3.00,96.00},size={60.00,14.00},proc=SetVarZoom,title="Y1"
	SetVariable C_PosCadreY1,limits={0,inf,1},value= root:Ratio:V_PosZoomY1
	SetVariable C_PosCadreY2,pos={277.00,132.00},size={60.00,14.00},proc=SetVarZoom,title="Y2"
	SetVariable C_PosCadreY2,limits={0,inf,1},value= root:Ratio:V_PosZoomY2
	SetVariable C_PosCadreDeltaX,pos={126.00,262.00},size={60.00,14.00},proc=SetVarZoom,title="∆X"
	SetVariable C_PosCadreDeltaX,limits={0,inf,1},value= root:Ratio:V_PosZoomDeltaX
	SetVariable C_PosCadreDeltaY,pos={370.00,111.00},size={60.00,14.00},proc=SetVarZoom,title="∆Y"
	SetVariable C_PosCadreDeltaY,limits={0,inf,1},value= root:Ratio:V_PosZoomDeltaY
	Button C_Aide_Image_display,pos={384.00,290.00},size={50.00,20.00},proc=BoutonAide,title="Help"
	Button C_Aide_Image_display,fSize=12,fStyle=1
	SetVariable C_PixParPix,pos={325.00,229.00},size={80.00,16.00},bodyWidth=45,proc=SetVarZoom,title="pix/pix"
	SetVariable C_PixParPix,help={"Changes axis \"size\", ie how many pixel per axis unit; affects the resolution of the exported image -> can make images smaller."}
	SetVariable C_PixParPix,fSize=11
	SetVariable C_PixParPix,limits={0.2,3,0.1},value= root:Ratio:V_PixParPix
	SetVariable C_Magnification,pos={299.00,257.00},size={106.00,16.00},bodyWidth=44,proc=SetVarZoom,title="zoom factor"
	SetVariable C_Magnification,help={"Just a zoom on the image; no effect on image resolution."}
	SetVariable C_Magnification,fSize=11
	SetVariable C_Magnification,limits={0.25,8,0.25},value= root:Ratio:V_Zoom
	Button C_ImageEntiere,pos={239.00,290.00},size={90.00,20.00},proc=BoutonZoom,title="Full view"
	Button C_ImageEntiere,help={"Shows the whole field of view"},fSize=11
EndMacro

Function Init_P_Recadrage_Image()
	Execute "P_Recadrage_Image()"
End

Window P_TableauCarreCalib() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(902,45,1163,853) as "Display calibration square for selected data points"
	SetDrawLayer UserBack
	Button C_Clear,pos={176.00,34.00},size={50.00,20.00},proc=BoutonCarreCalib,title="Clear"
	Button C_Clear,help={"Sets all values to 0"}
	Button C_SetTo1,pos={176.00,71.00},size={50.00,20.00},proc=BoutonCarreCalib,title="Set to 1"
	Button C_SetTo1,help={"Sets all values to 1"}
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Ratio:
	Edit/W=(18,18,158,791)/HOST=#  W_CarreCalib
	ModifyTable size(Point)=10,format(Point)=1,width(Point)=30,title(Point)="Time-point #"
	ModifyTable showParts=0x6b
	SetDataFolder fldrSav0
	RenameWindow #,T0
	SetActiveSubwindow ##
EndMacro

Function Init_P_TableauCarreCalib()
	Execute "P_TableauCarreCalib()"
End

Window P_ROI() : Panel
	PauseUpdate; Silent 1		// building window...
	NewPanel /W=(1526,45,1776,644) as "ROI control"
	SetDrawLayer UserBack
	SetDrawEnv fsize= 9
	DrawText 96,240,"Continue to:"
	SetDrawEnv fsize= 9
	DrawText 81,201,"vertical"
	SetDrawEnv textxjust= 1
	DrawText 120,253,"←    ∅    →"
	SetDrawEnv fsize= 10
	DrawText 139,137,"Reference point:"
	SetDrawEnv fsize= 9
	DrawText 179,536,"external stack"
	Button C_Gauche4,pos={42.00,155.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Gauche4,title="\\W646",fSize=9
	Button C_Haut4,pos={57.00,142.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Haut4,title="\\W617",fSize=9
	Button C_Bas4,pos={57.00,170.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Bas4,title="\\W623",fSize=9
	Button C_Gauche5,pos={26.00,155.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Gauche5,title="\\W646",fSize=9
	Button C_Bas5,pos={57.00,187.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Bas5,title="\\W623",fSize=9
	Button C_Haut5,pos={57.00,123.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Haut5,title="\\W617",fSize=9
	Button C_Droite4,pos={73.00,155.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Droite4,title="\\W649",fSize=9
	Button C_Droite5,pos={89.00,155.00},size={17.00,16.00},proc=BoutonDeplaceROI
	Button C_Droite5,title="\\W649",fSize=9
	CheckBox C_CheckDepROI_Gauche,pos={91.00,255.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
	CheckBox C_CheckDepROI_Gauche,title=""
	CheckBox C_CheckDepROI_Gauche,help={"Movements are propagated to earlier datapoints"}
	CheckBox C_CheckDepROI_Gauche,value=0,mode=1
	CheckBox C_CheckDepROI_Milieu,pos={114.00,255.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
	CheckBox C_CheckDepROI_Milieu,title=""
	CheckBox C_CheckDepROI_Milieu,help={"Only changes the current datapoint"}
	CheckBox C_CheckDepROI_Milieu,value=1,mode=1
	CheckBox C_CheckDepROI_Droite,pos={137.00,255.00},size={15.00,15.00},proc=CheckBasculeBoutonRadio
	CheckBox C_CheckDepROI_Droite,title=""
	CheckBox C_CheckDepROI_Droite,help={"Movements are propagated to later datapoints"}
	CheckBox C_CheckDepROI_Droite,value=0,mode=1
	Button C_PoursuiteAuto,pos={144.00,190.00},size={60.00,20.00},proc=BoutonDeplaceToutesROI
	Button C_PoursuiteAuto,title="Optimise",fSize=11
	Button C_HautZ4,pos={89.00,176.00},size={17.00,16.00},disable=2,proc=BoutonDeplaceROI
	Button C_HautZ4,title="\\W617",fSize=9
	Button C_BasZ4,pos={89.00,202.00},size={17.00,16.00},disable=2,proc=BoutonDeplaceROI
	Button C_BasZ4,title="\\W623",fSize=9
	Button C_EffaceDep,pos={128.00,279.00},size={43.00,16.00},proc=BoutonDeplaceROI
	Button C_EffaceDep,title="\\K(52428,1,1)Clear",fSize=9
	Button C_AfficheDep,pos={22.00,279.00},size={43.00,16.00},proc=BoutonDeplaceROI
	Button C_AfficheDep,title="Display",fSize=9
	Button C_CopieDep,pos={75.00,279.00},size={43.00,16.00},proc=BoutonDeplaceROI
	Button C_CopieDep,title="Copy",fSize=9
	SetVariable C_MargeROIMobile,pos={139.00,163.00},size={70.00,14.00}
	SetVariable C_MargeROIMobile,title="Margin"
	SetVariable C_MargeROIMobile,limits={1,30,1},value=root:Analyse_0:V_MargeROIMobile
	GroupBox C_GroupeAutomatique,pos={127.00,106.00},size={100.00,120.00}
	GroupBox C_GroupeAutomatique,title="Automatic tracking"
	Button C_Aide_Move_ROI,pos={181.00,278.00},size={43.00,16.00},proc=BoutonAide
	Button C_Aide_Move_ROI,title="Help",fSize=9,fStyle=1,fColor=(65535,65535,65535)
	GroupBox C_GroupeManuel,pos={17.00,106.00},size={100.00,120.00},title="Manual"
	GroupBox C_GroupeMouvement,pos={7.00,86.00},size={235.00,224.00}
	GroupBox C_GroupeMouvement,title="ROI movement",fSize=9,fColor=(1,1,1)
	GroupBox C_GroupeMorphometrie,pos={7.00,311.00},size={235.00,140.00}
	GroupBox C_GroupeMorphometrie,title="Morphometry"
	CheckBox C_ShowFittedEllipse,pos={166.00,392.00},size={67.00,16.00}
	CheckBox C_ShowFittedEllipse,title="Show ellipse"
	CheckBox C_ShowFittedEllipse,help={"Overlay the ellipse, best fit to the ROI"}
	CheckBox C_ShowFittedEllipse,value=1,side=1
	CheckBox C_AutoZoomROI,pos={101.00,11.00},size={71.00,16.00},proc=CheckZoom
	CheckBox C_AutoZoomROI,title="Zoom on ROI",help={"Zoom on the selected ROI"}
	CheckBox C_AutoZoomROI,value=0
	SetVariable C_NumROI,pos={10.00,11.00},size={79.00,16.00},bodyWidth=46,proc=SetVarNumRoi
	SetVariable C_NumROI,title="ROI #",help={"Current ROI"},fSize=11
	SetVariable C_NumROI,limits={1,12,1},value=root:Analyse_0:V_NumROI
	Button C_DessineROI,pos={10.00,37.00},size={50.00,20.00},proc=BoutonGereROI
	Button C_DessineROI,help={"Create a new region of interest"},fSize=10
	Button C_RAZRoi,pos={186.00,37.00},size={50.00,20.00},proc=BoutonGereROI
	Button C_RAZRoi,title="Reset"
	Button C_RAZRoi,help={"Resets the ROI to a minimal 2 points ROI; needed when drawing a ROI went wrong"}
	Button C_RAZRoi,fSize=10
	Button C_EditeROI,pos={69.00,37.00},size={50.00,20.00},proc=BoutonGereROI
	Button C_EditeROI,title="Modify",help={"Edit the current ROI"},fSize=10
	SetVariable C_Tag,pos={185.00,11.00},size={54.00,16.00},bodyWidth=35,proc=SetVarTag
	SetVariable C_Tag,title="tag"
	SetVariable C_Tag,help={"Affects the current ROI to the selected group; -1 means the ROI is considered background"}
	SetVariable C_Tag,fSize=11,limits={-1,3,1},value=root:Analyse_0:W_Tag[2]
	Button C_DupliqueROI,pos={127.00,37.00},size={50.00,20.00},proc=BoutonGereROI
	Button C_DupliqueROI,title="Duplicate",help={"Duplicate the current ROI"}
	Button C_DupliqueROI,fSize=10,disable=2
	SetVariable C_Position0DeplaceROI,pos={155.00,138.00},size={45.00,14.00},disable=2
	SetVariable C_Position0DeplaceROI,title=" "
	SetVariable C_Position0DeplaceROI,help={"Time-point from which all movements are calculated. Also provides the reference image for autotracking."}
	SetVariable C_Position0DeplaceROI,limits={0,232,1},value=root:Analyse_0:V_Position0DeplaceROI
	GroupBox C_GroupeBiosensorConcentation,pos={7.00,449.00},size={233.00,136.00}
	GroupBox C_GroupeBiosensorConcentation,title="Sensor concentration"
	Button C_Aide_Sensor_concentration,pos={197.00,558.00},size={30.00,16.00},proc=BoutonAide
	Button C_Aide_Sensor_concentration,title="Help",fSize=9,fStyle=1
	Button C_Aide_Sensor_concentration,fColor=(65535,65535,65535)
	CheckBox C_IntensiteOK,pos={148.00,465.00},size={80.00,16.00},proc=CheckProc_IntensiteOK
	CheckBox C_IntensiteOK,title="Intensity is valid",value=1,side=1
	ValDisplay C_ROI_Area,pos={146.00,332.00},size={88.00,13.00},title="ROI area"
	ValDisplay C_ROI_Area,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_ROI_Area,value=#"root:Analyse_0:W_ROI_Area[root:Analyse_0:V_NumROI]"
	ValDisplay C_ROI_EllipseDiameter0,pos={124.00,352.00},size={110.00,13.00}
	ValDisplay C_ROI_EllipseDiameter0,title="Ellipse diam. 0"
	ValDisplay C_ROI_EllipseDiameter0,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_ROI_EllipseDiameter0,value=#"root:Analyse_0:W_ROI_EllipseData[root:Analyse_0:V_NumROI][0]"
	ValDisplay C_ROI_EllipseDiameter1,pos={124.00,372.00},size={110.00,13.00}
	ValDisplay C_ROI_EllipseDiameter1,title="Ellipse diam. 1"
	ValDisplay C_ROI_EllipseDiameter1,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_ROI_EllipseDiameter1,value=#"root:Analyse_0:W_ROI_EllipseData[root:Analyse_0:V_NumROI][1]"
	Button C_Aide_Morphometry,pos={133.00,409.00},size={30.00,16.00},proc=BoutonAide
	Button C_Aide_Morphometry,title="Help",fSize=9,fStyle=1
	Button C_Aide_Morphometry,fColor=(65535,65535,65535)
	Button C_Aide_ROI_definition,pos={168.00,69.00},size={70.00,16.00},proc=BoutonAide
	Button C_Aide_ROI_definition,title="Main ROI help",fSize=9,fStyle=1
	Button C_Aide_ROI_definition,fColor=(65535,49151,49151)
	SetVariable C_FractionDesPixels,pos={130.00,482.00},size={101.00,14.00},proc=SetVarProc_SensorConcentration
	SetVariable C_FractionDesPixels,title="Pixels to use"
	SetVariable C_FractionDesPixels,help={"How much of the ROI should be taken for estimating sensor concentration (fraction)"}
	SetVariable C_FractionDesPixels,limits={0,1,0.1},value=root:Analyse_0:V_FractionDesPixelsPourIntensite
	ValDisplay C_IntensiteA,pos={126.00,503.00},size={50.00,13.00},title="A"
	ValDisplay C_IntensiteA,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_IntensiteA,value=#"root:Analyse_0:W_Intensite[root:Analyse_0:V_NumROI][0]"
	ValDisplay C_IntensiteB,pos={178.00,503.00},size={50.00,13.00},title="B"
	ValDisplay C_IntensiteB,limits={0,0,0},barmisc={0,1000}
	ValDisplay C_IntensiteB,value=#"root:Analyse_0:W_Intensite[root:Analyse_0:V_NumROI][1]"
	Button C_MaJIntensite,pos={138.00,556.00},size={50.00,20.00},proc=BoutonProc_Intensite
	Button C_MaJIntensite,title="Update all"
	Button C_MaJIntensite,help={"Measures intensity on all ROI that are OK"}
	CheckBox C_CheckSourceIntensiteDefault,pos={124.00,535.00},size={45.00,15.00},proc=CheckProc_SourceIntensite
	CheckBox C_CheckSourceIntensiteDefault,title="Default"
	CheckBox C_CheckSourceIntensiteDefault,help={"Use current image pair"}
	CheckBox C_CheckSourceIntensiteDefault,value=0,mode=1,side=1
	CheckBox C_CheckSourceIntensiteExtA,pos={179.00,535.00},size={23.00,15.00},proc=CheckProc_SourceIntensite
	CheckBox C_CheckSourceIntensiteExtA,title="A"
	CheckBox C_CheckSourceIntensiteExtA,help={"Use external image stack acquired in A channel"}
	CheckBox C_CheckSourceIntensiteExtA,value=0,mode=1,side=1
	CheckBox C_CheckSourceIntensiteExtB,pos={210.00,535.00},size={23.00,15.00},proc=CheckProc_SourceIntensite
	CheckBox C_CheckSourceIntensiteExtB,title="B"
	CheckBox C_CheckSourceIntensiteExtB,help={"Use external image stack acquired in B channel"}
	CheckBox C_CheckSourceIntensiteExtB,value=0,mode=1,side=1
	Display/W=(20,334,119,433)/HOST=# 
	AppendImage/T :Analyse_0:D_Masque
	ModifyImage D_Masque explicit= 1
	ModifyImage D_Masque eval={0,0,0,0}
	ModifyImage D_Masque eval={255,-1,-1,-1}
	ModifyImage D_Masque eval={1,65535,65535,65535}
	ModifyGraph margin(left)=-1,margin(bottom)=-1,margin(top)=-1,margin(right)=-1
	ModifyGraph mirror=0
	ModifyGraph nticks=0
	ModifyGraph noLabel=2
	ModifyGraph standoff=0
	ModifyGraph axThick=0
	SetAxis/A/R left
	RenameWindow #,G0
	SetActiveSubwindow ##
	Display/W=(20,472,119,572)/HOST=# 
	AppendImage/T :Analyse_0:D_Masque2
	ModifyImage D_Masque2 ctab= {*,*,Grays,0}
	ModifyGraph margin(left)=-1,margin(bottom)=-1,margin(top)=-1,margin(right)=-1
	ModifyGraph mirror=0
	ModifyGraph nticks=0
	ModifyGraph noLabel=2
	ModifyGraph standoff=0
	ModifyGraph axThick=0
	SetAxis/A/R left
	RenameWindow #,G1
	SetActiveSubwindow ##
EndMacro

Function Init_P_ROI()

	Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	NVAR/SDFR=dfROI V_NumROI, V_NbROI, V_MargeROIMobile, V_Position0DeplaceROI
	NVAR/SDFR=dfRatio Dim
	Wave/SDFR=dfROI W_Tag, D_Masque, D_Masque2, W_ROI_Area, W_ROI_EllipseData, W_IntensiteOK
	String sFormule, sNomDF
	DoWindow P_ROI
	if (V_Flag==0)
		Execute "P_ROI()"
	endif
	
	sNomDF=GetDataFolder(1, dfROI)

//	Highlights in red whether mobile ROIs has already been activated
	if (TesteROIMobile(V_NumROI)>0)
		GroupBox C_GroupeMouvement win=P_ROI,fSize=12,fColor=(52428,1,1),title="ROI movement activated"
	else
		GroupBox C_GroupeMouvement win=P_ROI,fSize=9,fColor=(1,1,1),title="ROI movement"
	endif
	
	//	Displays in the P_ROI the image of this datafolder
	ReplaceWave/W=P_ROI#G0 image=D_Masque, D_Masque
	ReplaceWave/W=P_ROI#G1 image=D_Masque2, D_Masque2
	
	// SetVariable connected to the right variable in current dfROI
	SetVariable C_NumROI win=P_ROI,value=V_NumROI,limits={1,V_NbROI,1}
	SetVariable C_Tag win=P_ROI,value=W_Tag[V_NumROI]
	SetVariable C_MargeROIMobile win=P_ROI,value=V_MargeROIMobile,limits={1,30,1}
	SetVariable C_Position0DeplaceROI win=P_ROI,value=V_Position0DeplaceROI
	CheckBox C_IntensiteOK win=P_ROI,value=W_IntensiteOK[V_NumROI]

	//	ValDisplay connected to the right value in dfROI
	sFormule=sNomDF+"W_ROI_Area["+sNomDF+"V_NumROI]"
	ValDisplay C_ROI_Area win=P_ROI,value=#sFormule
	sFormule=sNomDF+"W_ROI_EllipseData["+sNomDF+"V_NumROI][0]"
	ValDisplay C_ROI_EllipseDiameter0 win=P_ROI,value=#sFormule
	sFormule=sNomDF+"W_ROI_EllipseData["+sNomDF+"V_NumROI][1]"
	ValDisplay C_ROI_EllipseDiameter1 win=P_ROI,value=#sFormule
	sFormule=sNomDF+"W_Intensite["+sNomDF+"V_NumROI][0]"
	ValDisplay C_IntensiteA, win=P_ROI, value=#sFormule
	sFormule=sNomDF+"W_Intensite["+sNomDF+"V_NumROI][1]"
	ValDisplay C_IntensiteB, win=P_ROI, value=#sFormule
	
	//	Initialize radio buttons
	CheckProc_SourceIntensite("",0)
End

//	Activated by checkboxes to control the display or hiding of windows
//	The name of the checkbox control that activates this function
//	determines the command, which will initialize that window
Function CheckActivePanneau(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

	Wave/DF W_DFREF=root:W_DFREF; DFREF dfROI=W_DFREF[0]; DFREF dfRatio=W_DFREF[3]
	DFREF dfPulse=W_DFREF[5]; DFREF dfKymo=W_DFREF[6]
	DFREF dfCourant=root:
	String sNomFenetre, sNomCommande, sNomFenetrePrincipale

	//	Gets the window's name in ctrlName
	sNomFenetre=ctrlName[9,inf]

	//	Depending on the name of the window:
	// - attach the window to another one
	StrSwitch(sNomFenetre)
		case "P_Evts":
		case "P_Export":
		case "P_Derive_Base":
		case "P_PdV":
		case "P_Pulse":
			sNomFenetrePrincipale="F_TracesTriees"		//	target window to which the new window should be attached
		break
		case "P_Deplacement":
		case "P_Decalage":
		case "P_Seuillage":
		case "P_Recadrage_Image":
		case "P_Kymograph":
		case "P_ROI":
			sNomFenetrePrincipale="F_RM"
		break
	EndSwitch
	//	- which datafolder should be selected so that window creation will find the objects it needs
	StrSwitch(sNomFenetre)
		case "P_Pile":
			dfCourant=dfRatio
		break
		case "P_TableauROI":
		case "P_Seuillage":
		case "P_ROI":
			dfCourant=dfROI
		break
		case "P_Kymograph":
			dfCourant=dfKymo
		break
	EndSwitch

	DoWindow/F $sNomFenetre		//	if window exists, put at the forefront
	Switch(checked)
		case 0:	//	checkbox is unchecked -> the window should be hidden
			if (V_Flag==1)
				SetWindow $sNomFenetre, hide=1
			endif
		break
		case 1:	//	The window should be displayed at the forefront
			if (V_Flag==0)	//	window doesn't exist
				SetDataFolder dfCourant
				sNomCommande="Init_"+sNomFenetre+"()"
				Execute/Z sNomCommande	//	execute the code to create the window
			else
				SetWindow $sNomFenetre, hide=0
			endif
			//	Autoposition the window next to sNomFenetrePrincipale
			if (StrLen(sNomFenetrePrincipale)>0)	
			DoWindow/F $sNomFenetrePrincipale		//	it might be that the main window doesn"t exist -> skip autoposition
				if (V_Flag)
					DoWindow $sNomFenetre
					if (V_Flag)	
						AutoPositionWindow/M=0/R=$sNomFenetrePrincipale $sNomFenetre
					endif
				endif
			endif
		break
	EndSwitch
	SetDataFolder root:
End


